
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 16 "gram.y"

#include "./dbpmda.h"
#include "./lex.h"

extern int stmt_type;

static union {
    pmID	whole;
    __pmID_int	part;
} pmid;

static union {
    pmInDom		whole;
    __pmInDom_int	part;
} indom;


static int	inst;
static char	*str;
#define MYWARNSTRSZ 80
static char	warnStr[MYWARNSTRSZ];

param_t	param;

/*
 * pmidp may contain a dynamic PMID ... if so, ask the PMDA to
 * translate name if possible
 */
static int
fix_dynamic_pmid(const char *name, pmID *pmidp)
{
    int		sts;
    __pmPDU	*pb;
    extern int	toPMDA;
    extern int	fromPMDA;
    extern pmdaInterface	dispatch;

    if (IS_DYNAMIC_ROOT(*pmidp)) {
	if (connmode == CONN_DSO) {
	    if (dispatch.comm.pmda_interface >= PMDA_INTERFACE_4) {
		sts = dispatch.version.four.pmid(name, pmidp, dispatch.version.four.ext);
		if (sts < 0) return sts;
	    }
	}
	else if (connmode == CONN_DAEMON) {
	    sts = __pmSendNameList(toPMDA, FROM_ANON, 1, &name, NULL);
	    if (sts < 0) return sts;
	    sts = __pmGetPDU(fromPMDA, ANY_SIZE, TIMEOUT_NEVER, &pb);
	    if (sts < 0) return sts;
	    if (sts == PDU_PMNS_IDS) {
		int	xsts;
		sts = __pmDecodeIDList(pb, 1, pmidp, &xsts);
		__pmUnpinPDUBuf(pb);
		if (sts < 0) return sts;
		return xsts;
	    }
	    else if (sts == PDU_ERROR) {
		__pmDecodeError(pb, &sts);
		__pmUnpinPDUBuf(pb);
		return sts;
	    }
	}
    }
    return 0;
}




/* Line 189 of yacc.c  */
#line 143 "gram.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMBER2D = 258,
     NUMBER3D = 259,
     NUMBER = 260,
     NEGNUMBER = 261,
     FLAG = 262,
     NAME = 263,
     PATHNAME = 264,
     MACRO = 265,
     STRING = 266,
     NEGNAME = 267,
     COMMA = 268,
     EQUAL = 269,
     OPEN = 270,
     CLOSE = 271,
     DESC = 272,
     GETDESC = 273,
     GETINAME = 274,
     FETCH = 275,
     INSTANCE = 276,
     PROFILE = 277,
     HELP = 278,
     WATCH = 279,
     DBG = 280,
     QUIT = 281,
     STATUS = 282,
     STORE = 283,
     INFO = 284,
     TIMER = 285,
     NAMESPACE = 286,
     WAIT = 287,
     PMNS_NAME = 288,
     PMNS_PMID = 289,
     PMNS_CHILDREN = 290,
     PMNS_TRAVERSE = 291,
     ATTR = 292,
     LABEL = 293,
     CTXT = 294,
     DOMAIN = 295,
     INDOM = 296,
     CLUSTER = 297,
     ITEM = 298,
     INSTANCES = 299,
     DSO = 300,
     PIPE = 301,
     SOCK = 302,
     UNIX = 303,
     INET = 304,
     IPV6 = 305,
     ADD = 306,
     DEL = 307,
     ALL = 308,
     NONE = 309,
     ON = 310,
     OFF = 311,
     PLUS = 312,
     EOL = 313
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 85 "gram.y"

	char		*y_str;
	int		y_num;
	twodot_num      y_2num;
	threedot_num    y_3num;
	


/* Line 214 of yacc.c  */
#line 246 "gram.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 258 "gram.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  128
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   259

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  59
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  15
/* YYNRULES -- Number of rules.  */
#define YYNRULES  128
/* YYNRULES -- Number of states.  */
#define YYNSTATES  231

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   313

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,    13,    18,    22,    27,    32,    37,
      40,    43,    47,    50,    54,    57,    62,    65,    69,    74,
      77,    81,    86,    91,    94,    99,   104,   110,   116,   119,
     123,   126,   130,   133,   137,   140,   144,   147,   151,   155,
     158,   162,   167,   170,   174,   178,   183,   188,   193,   198,
     201,   205,   209,   213,   217,   221,   225,   229,   233,   237,
     241,   245,   249,   253,   257,   261,   265,   269,   273,   277,
     281,   285,   289,   293,   296,   299,   303,   307,   311,   314,
     317,   321,   325,   328,   332,   336,   339,   343,   347,   350,
     354,   356,   357,   359,   361,   363,   364,   366,   368,   370,
     372,   374,   376,   378,   380,   382,   384,   386,   388,   390,
     392,   394,   397,   401,   402,   404,   406,   408,   410,   413,
     417,   420,   424,   426,   428,   430,   432,   434,   436
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      60,     0,    -1,    15,    58,    -1,    15,    45,    61,     8,
      62,    58,    -1,    15,    46,    61,    70,    -1,    15,    47,
      61,    -1,    15,    47,    48,    61,    -1,    15,    47,    49,
      64,    -1,    15,    47,    50,    64,    -1,    16,    58,    -1,
      17,    58,    -1,    17,    65,    58,    -1,    20,    58,    -1,
      20,    69,    58,    -1,    28,    58,    -1,    28,    65,    11,
      58,    -1,    29,    58,    -1,    29,    65,    58,    -1,    29,
      41,    67,    58,    -1,    21,    58,    -1,    21,    67,    58,
      -1,    21,    67,     5,    58,    -1,    21,    67,    71,    58,
      -1,    22,    58,    -1,    22,    67,    53,    58,    -1,    22,
      67,    54,    58,    -1,    22,    67,    51,     5,    58,    -1,
      22,    67,    52,     5,    58,    -1,    24,    58,    -1,    24,
      61,    58,    -1,    33,    58,    -1,    33,    68,    58,    -1,
      34,    58,    -1,    34,     8,    58,    -1,    35,    58,    -1,
      35,     8,    58,    -1,    36,    58,    -1,    36,     8,    58,
      -1,    31,    61,    58,    -1,    37,    58,    -1,    37,    63,
      58,    -1,    37,    63,    11,    58,    -1,    38,    58,    -1,
      38,    39,    58,    -1,    38,    40,    58,    -1,    38,    41,
      67,    58,    -1,    38,    42,    66,    58,    -1,    38,    43,
      65,    58,    -1,    38,    44,    67,    58,    -1,    23,    58,
      -1,    23,    37,    58,    -1,    23,    16,    58,    -1,    23,
      25,    58,    -1,    23,    17,    58,    -1,    23,    20,    58,
      -1,    23,    18,    58,    -1,    23,    19,    58,    -1,    23,
      29,    58,    -1,    23,    21,    58,    -1,    23,    38,    58,
      -1,    23,    31,    58,    -1,    23,    15,    58,    -1,    23,
      35,    58,    -1,    23,    33,    58,    -1,    23,    34,    58,
      -1,    23,    36,    58,    -1,    23,    22,    58,    -1,    23,
      26,    58,    -1,    23,    27,    58,    -1,    23,    28,    58,
      -1,    23,    30,    58,    -1,    23,    32,    58,    -1,    23,
      24,    58,    -1,    26,    58,    -1,    25,    58,    -1,    25,
      53,    58,    -1,    25,    54,    58,    -1,    25,    72,    58,
      -1,    27,    58,    -1,    30,    58,    -1,    30,    55,    58,
      -1,    30,    56,    58,    -1,    18,    58,    -1,    18,    55,
      58,    -1,    18,    56,    58,    -1,    19,    58,    -1,    19,
      55,    58,    -1,    19,    56,    58,    -1,    32,    58,    -1,
      32,     5,    58,    -1,    58,    -1,    -1,     8,    -1,     9,
      -1,     5,    -1,    -1,     5,    -1,    11,    -1,     5,    -1,
      11,    -1,     5,    -1,     3,    -1,     4,    -1,     8,    -1,
       5,    -1,     3,    -1,     5,    -1,     6,    -1,     3,    -1,
       4,    -1,    65,    -1,    69,    65,    -1,    69,    13,    65,
      -1,    -1,    11,    -1,     8,    -1,     5,    -1,    73,    -1,
      72,     5,    -1,    72,    13,     5,    -1,    72,    73,    -1,
      72,    13,    73,    -1,     8,    -1,    12,    -1,    20,    -1,
      22,    -1,    39,    -1,    41,    -1,    37,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   137,   137,   141,   145,   149,   153,   157,   161,   165,
     168,   172,   176,   180,   183,   187,   192,   196,   201,   206,
     210,   216,   222,   228,   232,   242,   252,   264,   276,   280,
     284,   288,   292,   296,   300,   304,   308,   312,   316,   320,
     324,   329,   334,   338,   342,   346,   351,   356,   361,   367,
     371,   375,   379,   383,   387,   391,   395,   399,   403,   407,
     411,   415,   419,   423,   427,   431,   435,   439,   443,   447,
     451,   455,   459,   464,   465,   469,   478,   487,   490,   493,
     497,   500,   503,   507,   510,   513,   517,   520,   523,   527,
     530,   531,   541,   552,   555,   556,   559,   568,   579,   580,
     593,   606,   621,   637,   652,   656,   664,   668,   672,   680,
     689,   690,   691,   695,   698,   699,   702,   714,   727,   739,
     751,   764,   784,   785,   786,   787,   788,   789,   790
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER2D", "NUMBER3D", "NUMBER",
  "NEGNUMBER", "FLAG", "NAME", "PATHNAME", "MACRO", "STRING", "NEGNAME",
  "COMMA", "EQUAL", "OPEN", "CLOSE", "DESC", "GETDESC", "GETINAME",
  "FETCH", "INSTANCE", "PROFILE", "HELP", "WATCH", "DBG", "QUIT", "STATUS",
  "STORE", "INFO", "TIMER", "NAMESPACE", "WAIT", "PMNS_NAME", "PMNS_PMID",
  "PMNS_CHILDREN", "PMNS_TRAVERSE", "ATTR", "LABEL", "CTXT", "DOMAIN",
  "INDOM", "CLUSTER", "ITEM", "INSTANCES", "DSO", "PIPE", "SOCK", "UNIX",
  "INET", "IPV6", "ADD", "DEL", "ALL", "NONE", "ON", "OFF", "PLUS", "EOL",
  "$accept", "stmt", "fname", "optdomain", "attribute", "servport",
  "metric", "cluster", "indom", "raw_pmid", "metriclist", "arglist",
  "inst", "debug", "flag", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    59,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    61,    61,    62,    62,    63,    63,    64,    64,
      65,    65,    65,    65,    66,    66,    67,    67,    67,    68,
      69,    69,    69,    70,    71,    71,    72,    72,    72,    72,
      72,    72,    73,    73,    73,    73,    73,    73,    73
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     6,     4,     3,     4,     4,     4,     2,
       2,     3,     2,     3,     2,     4,     2,     3,     4,     2,
       3,     4,     4,     2,     4,     4,     5,     5,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     2,
       3,     4,     2,     3,     3,     4,     4,     4,     4,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     3,     2,     2,
       3,     3,     2,     3,     3,     2,     3,     3,     2,     3,
       1,     0,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     0,     1,     1,     1,     1,     2,     3,
       2,     3,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      91,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    90,     0,     0,     0,     0,
       2,     9,   101,   102,   100,   103,    10,     0,     0,     0,
      82,     0,     0,    85,    12,   110,     0,   108,   106,   107,
      19,     0,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,    92,    93,
      28,     0,   116,   122,   123,   124,   125,   128,   126,   127,
       0,     0,    74,     0,   117,    73,    78,    14,     0,     0,
      16,     0,     0,     0,    79,     0,     0,    88,   109,    30,
       0,     0,    32,     0,    34,     0,    36,    96,    97,    39,
       0,     0,     0,     0,     0,     0,     0,    42,     1,     0,
     113,     0,     0,     0,     5,    11,    83,    84,    86,    87,
       0,    13,   111,     0,   115,   114,    20,     0,     0,     0,
       0,     0,    61,    51,    53,    55,    56,    54,    58,    66,
      72,    52,    67,    68,    69,    57,    70,    60,    71,    63,
      64,    62,    65,    50,    59,    29,    75,    76,   118,     0,
      77,   120,     0,     0,    17,    80,    81,    38,    89,    31,
      33,    35,    37,     0,    40,    43,    44,     0,   105,   104,
       0,     0,     0,    95,     4,     6,    98,    99,     7,     8,
     112,    21,    22,     0,     0,    24,    25,   119,   121,    15,
      18,    41,    45,    46,    47,    48,    94,     0,    26,    27,
       3
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    26,    81,   227,   120,   208,    37,   200,    51,   110,
      46,   204,   147,    93,    94
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -92
static const yytype_int16 yypact[] =
{
     132,    16,   -12,    17,    22,    34,    23,    33,    39,   167,
      21,    45,    -7,     1,    29,     2,    68,   108,    13,     0,
      27,    46,    48,    12,   175,   -92,    76,   108,   108,    64,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,    10,    25,    47,
     -92,    49,    51,   -92,   -92,   -92,    11,   -92,   -92,   -92,
     -92,    44,   -92,    85,    53,    62,    70,    75,    83,    86,
      87,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   149,   150,   152,   153,   154,   -92,   -92,   -92,
     -92,   162,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     164,   166,   -92,    88,   -92,   -92,   -92,   -92,   111,   137,
     -92,   168,   169,   170,   -92,   171,   172,   -92,   -92,   -92,
     173,   174,   -92,   176,   -92,   177,   -92,   -92,   -92,   -92,
      37,   178,   179,   137,    61,   127,   137,   -92,   -92,   231,
     -92,   108,    36,    36,   -92,   -92,   -92,   -92,   -92,   -92,
     127,   -92,   -92,   183,   -92,   -92,   -92,   185,   239,   240,
     188,   189,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   201,
     -92,   -92,   190,   191,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   192,   -92,   -92,   -92,   193,   -92,   -92,
     194,   195,   196,   250,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   198,   199,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   200,   -92,   -92,
     -92
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -92,   -92,   -16,   -92,   -92,   126,    -6,   -92,    -5,   -92,
     -92,   -92,   -92,   -92,   -91
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      45,   105,   181,    53,   108,    32,    33,    34,    98,   101,
      35,   129,   130,   134,    32,    33,    34,   117,   106,    35,
      32,    33,    34,   118,   140,    35,    32,    33,    34,    78,
      79,    35,    32,    33,    34,   111,    47,    35,    48,    49,
     142,   206,    47,    99,    48,    49,    31,   207,   193,   143,
      82,    95,   144,    83,   113,   145,   115,    84,   109,    96,
     100,    27,    28,    29,   198,    85,   199,    86,   135,   141,
     119,   107,    78,    79,    30,    36,   128,    38,    39,    80,
      40,    44,    87,   136,    88,   112,    89,    97,   218,    41,
      42,    50,    43,   178,   183,   194,    83,    52,    90,    91,
      84,   179,   146,    92,   114,   137,   116,   138,    85,   139,
      86,   152,   131,   132,   133,   205,    78,    79,   197,   201,
     153,   202,   182,   102,   103,    87,   104,    88,   154,    89,
      32,    33,    34,   155,   210,    35,   148,   149,   150,   151,
      47,   156,    48,    49,   157,   158,   180,     1,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    54,    55,    56,    57,    58,    59,    60,    61,
      25,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,   217,   170,   171,    83,
     172,   173,   174,    84,   121,   122,   123,   124,   125,   126,
     175,    85,   176,    86,   177,    77,   184,   185,   186,   187,
     188,   189,   190,   127,   191,   192,   195,   196,    87,   203,
      88,   211,    89,   212,   213,   214,   215,   216,   219,   220,
     221,   222,   223,   224,   225,   226,   228,   229,   230,   209
};

static const yytype_uint8 yycheck[] =
{
       6,    17,    93,     8,     4,     3,     4,     5,    14,    15,
       8,    27,    28,    29,     3,     4,     5,     5,     5,     8,
       3,     4,     5,    11,    13,     8,     3,     4,     5,     8,
       9,     8,     3,     4,     5,     8,     3,     8,     5,     6,
      46,     5,     3,    41,     5,     6,    58,    11,    11,     5,
       5,    58,     8,     8,     8,    11,     8,    12,    58,    58,
      58,    45,    46,    47,     3,    20,     5,    22,    58,    58,
      58,    58,     8,     9,    58,    58,     0,    55,    56,    58,
      58,    58,    37,    58,    39,    58,    41,    58,   179,    55,
      56,    58,    58,     5,    99,    58,     8,    58,    53,    54,
      12,    13,    58,    58,    58,    58,    58,    58,    20,    58,
      22,    58,    48,    49,    50,   131,     8,     9,   123,   125,
      58,   126,    11,    55,    56,    37,    58,    39,    58,    41,
       3,     4,     5,    58,   140,     8,    51,    52,    53,    54,
       3,    58,     5,     6,    58,    58,    58,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    58,    58,    58,    58,    58,    58,    58,    58,    58,
      58,    58,    15,    16,    17,    18,    19,    20,    21,    22,
      58,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,     5,    58,    58,     8,
      58,    58,    58,    12,    39,    40,    41,    42,    43,    44,
      58,    20,    58,    22,    58,    58,    58,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,    37,     8,
      39,    58,    41,    58,     5,     5,    58,    58,    58,    58,
      58,    58,    58,    58,    58,     5,    58,    58,    58,   133
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    58,    60,    45,    46,    47,
      58,    58,     3,     4,     5,     8,    58,    65,    55,    56,
      58,    55,    56,    58,    58,    65,    69,     3,     5,     6,
      58,    67,    58,    67,    15,    16,    17,    18,    19,    20,
      21,    22,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    58,     8,     9,
      58,    61,     5,     8,    12,    20,    22,    37,    39,    41,
      53,    54,    58,    72,    73,    58,    58,    58,    65,    41,
      58,    65,    55,    56,    58,    61,     5,    58,     4,    58,
      68,     8,    58,     8,    58,     8,    58,     5,    11,    58,
      63,    39,    40,    41,    42,    43,    44,    58,     0,    61,
      61,    48,    49,    50,    61,    58,    58,    58,    58,    58,
      13,    58,    65,     5,     8,    11,    58,    71,    51,    52,
      53,    54,    58,    58,    58,    58,    58,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,     5,    13,
      58,    73,    11,    67,    58,    58,    58,    58,    58,    58,
      58,    58,    58,    11,    58,    58,    58,    67,     3,     5,
      66,    65,    67,     8,    70,    61,     5,    11,    64,    64,
      65,    58,    58,     5,     5,    58,    58,     5,    73,    58,
      58,    58,    58,    58,    58,    58,     5,    62,    58,    58,
      58
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 137 "gram.y"
    {
		param.number = OPEN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 141 "gram.y"
    {
		opendso((yyvsp[(3) - (6)].y_str), (yyvsp[(4) - (6)].y_str), (yyvsp[(5) - (6)].y_num));
		stmt_type = OPEN; YYACCEPT;
	    ;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 145 "gram.y"
    {
		openpmda((yyvsp[(3) - (4)].y_str));
		stmt_type = OPEN; YYACCEPT;
	    ;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 149 "gram.y"
    {
		open_unix_socket((yyvsp[(3) - (3)].y_str));
		stmt_type = OPEN; YYACCEPT;
	    ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 153 "gram.y"
    {
		open_unix_socket((yyvsp[(4) - (4)].y_str));
		stmt_type = OPEN; YYACCEPT;
	    ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 157 "gram.y"
    {
		open_inet_socket((yyvsp[(4) - (4)].y_num));
		stmt_type = OPEN; YYACCEPT;
	    ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 161 "gram.y"
    {
		open_ipv6_socket((yyvsp[(4) - (4)].y_num));
		stmt_type = OPEN; YYACCEPT;
	    ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 165 "gram.y"
    { 
		stmt_type = CLOSE; YYACCEPT; 
	    ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 168 "gram.y"
    {
		param.number = DESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 172 "gram.y"
    {
		param.pmid = (yyvsp[(2) - (3)].y_num);
		stmt_type = DESC; YYACCEPT;
	    ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 176 "gram.y"
    {
		param.number = FETCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 180 "gram.y"
    { 
		stmt_type = FETCH; YYACCEPT; 
	    ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 183 "gram.y"
    {
		param.number = STORE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 187 "gram.y"
    {
		param.name = (yyvsp[(3) - (4)].y_str);
		param.pmid = (pmID)(yyvsp[(2) - (4)].y_num);
		stmt_type = STORE; YYACCEPT;
	    ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 192 "gram.y"
    {
		param.number = INFO; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 196 "gram.y"
    {
		param.number = PM_TEXT_PMID;
		param.pmid = (pmID)(yyvsp[(2) - (3)].y_num);
		stmt_type = INFO; YYACCEPT;
	    ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 201 "gram.y"
    {
		param.number = PM_TEXT_INDOM;
		param.indom = indom.whole;
		stmt_type = INFO; YYACCEPT;
	    ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 206 "gram.y"
    {
		param.number = INSTANCE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 210 "gram.y"
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 216 "gram.y"
    {
		param.indom = indom.whole;
		param.number = (yyvsp[(3) - (4)].y_num);
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 222 "gram.y"
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = (yyvsp[(3) - (4)].y_str);
		stmt_type = INSTANCE; YYACCEPT;
	    ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 228 "gram.y"
    {
		param.number = PROFILE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 232 "gram.y"
    {
		int sts = pmAddProfile((yyvsp[(2) - (4)].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 242 "gram.y"
    {
		int sts = pmDelProfile((yyvsp[(2) - (4)].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 252 "gram.y"
    {
		int sts;
		inst = (yyvsp[(4) - (5)].y_num);
		sts = pmAddProfile((yyvsp[(2) - (5)].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 264 "gram.y"
    {
		int sts;
		inst = (yyvsp[(4) - (5)].y_num);
		sts = pmDelProfile((yyvsp[(2) - (5)].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 276 "gram.y"
    {
		param.number = WATCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 280 "gram.y"
    {
		watch((yyvsp[(2) - (3)].y_str));
		stmt_type = WATCH; YYACCEPT;
	    ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 284 "gram.y"
    {
		param.number = PMNS_NAME; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 288 "gram.y"
    {
		param.pmid = (yyvsp[(2) - (3)].y_num);
		stmt_type = PMNS_NAME; YYACCEPT;
	    ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 292 "gram.y"
    {
		param.number = PMNS_PMID; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 296 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = PMNS_PMID; YYACCEPT;
	    ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 300 "gram.y"
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 304 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = PMNS_CHILDREN; YYACCEPT;
	    ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 308 "gram.y"
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 312 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = PMNS_TRAVERSE; YYACCEPT;
	    ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 316 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = NAMESPACE; YYACCEPT;
	    ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 320 "gram.y"
    {
		param.number = ATTR; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 324 "gram.y"
    {
		param.number = (yyvsp[(2) - (3)].y_num);
		param.name = NULL;
		stmt_type = ATTR; YYACCEPT;
	    ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 329 "gram.y"
    {
		param.number = (yyvsp[(2) - (4)].y_num);
		param.name = (yyvsp[(3) - (4)].y_str);
		stmt_type = ATTR; YYACCEPT;
	    ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 334 "gram.y"
    {
		param.number = LABEL; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 338 "gram.y"
    {
		param.number = PM_LABEL_CONTEXT;
		stmt_type = LABEL; YYACCEPT;
	    ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 342 "gram.y"
    {
		param.number = PM_LABEL_DOMAIN;
		stmt_type = LABEL; YYACCEPT;
	    ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 346 "gram.y"
    {
		param.number = PM_LABEL_INDOM;
		param.indom = indom.whole;
		stmt_type = LABEL; YYACCEPT;
	    ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 351 "gram.y"
    {
		param.number = PM_LABEL_CLUSTER;
		param.pmid = (pmID)(yyvsp[(3) - (4)].y_num);
		stmt_type = LABEL; YYACCEPT;
	    ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 356 "gram.y"
    {
		param.number = PM_LABEL_ITEM;
		param.pmid = (pmID)(yyvsp[(3) - (4)].y_num);
		stmt_type = LABEL; YYACCEPT;
	    ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 361 "gram.y"
    {
		param.number = PM_LABEL_INSTANCES;
		param.indom = indom.whole;
		stmt_type = LABEL; YYACCEPT;
	    ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 367 "gram.y"
    { 
		param.number = -1; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT; 
	    ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 371 "gram.y"
    {
		param.number = ATTR; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 375 "gram.y"
    {
		param.number = CLOSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 379 "gram.y"
    {
		param.number = DBG; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 383 "gram.y"
    {
		param.number = DESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 387 "gram.y"
    {
		param.number = FETCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 391 "gram.y"
    {
		param.number = GETDESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 395 "gram.y"
    {
		param.number = GETINAME; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 399 "gram.y"
    {
		param.number = INFO; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 403 "gram.y"
    {
		param.number = INSTANCE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 407 "gram.y"
    {
		param.number = LABEL; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 411 "gram.y"
    {
		param.number = NAMESPACE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 415 "gram.y"
    {
		param.number = OPEN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 419 "gram.y"
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 423 "gram.y"
    {
		param.number = PMNS_NAME; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 427 "gram.y"
    {
		param.number = PMNS_PMID; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 431 "gram.y"
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 435 "gram.y"
    {
		param.number = PROFILE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 439 "gram.y"
    {
		param.number = QUIT; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 443 "gram.y"
    {
		param.number = STATUS; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 447 "gram.y"
    {
		param.number = STORE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 451 "gram.y"
    {
		param.number = TIMER; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 455 "gram.y"
    {
		param.number = WAIT; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 459 "gram.y"
    {
		param.number = WATCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 464 "gram.y"
    { stmt_type = QUIT; YYACCEPT; ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 465 "gram.y"
    {
		param.number = DBG; param.pmid = HELP_USAGE; 
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 469 "gram.y"
    {
		int sts = pmSetDebug("all");
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "pmSetDebug(\"all\") failed\n");
		    yywarn(warnStr);
		    YYERROR;
		}
		stmt_type = DBG; YYACCEPT;
	    ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 478 "gram.y"
    {
		int sts = pmClearDebug("all");
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "pmClearDebug(\"all\") failed\n");
		    yywarn(warnStr);
		    YYERROR;
		}
		stmt_type = DBG; YYACCEPT;
	    ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 487 "gram.y"
    {
	        stmt_type = DBG; YYACCEPT;
	    ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 490 "gram.y"
    { 
		stmt_type = STATUS; YYACCEPT; 
	    ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 493 "gram.y"
    {
		param.number = TIMER; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 497 "gram.y"
    { 
		timer = 1; stmt_type = EOL; YYACCEPT; 
	    ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 500 "gram.y"
    { 
		timer = 0; stmt_type = EOL; YYACCEPT; 
	    ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 503 "gram.y"
    {
		param.number = GETDESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 507 "gram.y"
    { 
		get_desc = 1; stmt_type = EOL; YYACCEPT; 
	    ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 510 "gram.y"
    { 
		get_desc = 0; stmt_type = EOL; YYACCEPT; 
	    ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 513 "gram.y"
    {
		param.number = GETINAME; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 517 "gram.y"
    { 
		get_iname = 1; stmt_type = EOL; YYACCEPT; 
	    ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 520 "gram.y"
    { 
		get_iname = 0; stmt_type = EOL; YYACCEPT; 
	    ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 523 "gram.y"
    {
		param.number = WAIT; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 527 "gram.y"
    { 
		stmt_type = EOL; sleep((yyvsp[(2) - (3)].y_num)); YYACCEPT;
	    ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 530 "gram.y"
    { stmt_type = EOL; YYACCEPT; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 531 "gram.y"
    {
		if (yywrap())
		    YYACCEPT;
		else {
		    yyerror("Unrecognized command");
		    YYERROR;
		}
	    ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 541 "gram.y"
    {
		    /* check for absolute path - *nix and Windows style */
		    if ((yyvsp[(1) - (1)].y_str)[0] == '/' ||
		        (strlen((yyvsp[(1) - (1)].y_str)) > 4 && (yyvsp[(1) - (1)].y_str)[1] == ':' && (yyvsp[(1) - (1)].y_str)[2] == '/'))
			(yyval.y_str) = (yyvsp[(1) - (1)].y_str);
		    else {
			/* relative path */
			(yyval.y_str) = strcons("./", (yyvsp[(1) - (1)].y_str));
			gc_add((yyval.y_str));
		    }
	    ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 552 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 555 "gram.y"
    { (yyval.y_num) = (yyvsp[(1) - (1)].y_num); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 556 "gram.y"
    { (yyval.y_num) = 0; ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 559 "gram.y"
    {
		int sts = __pmAttrKeyStr_r((yyvsp[(1) - (1)].y_num), warnStr, sizeof(warnStr));
		if (sts <= 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "Attribute (%d) is not recognised", (yyvsp[(1) - (1)].y_num));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = (yyvsp[(1) - (1)].y_num);
	    ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 568 "gram.y"
    { 
		int sts = __pmLookupAttrKey((yyvsp[(1) - (1)].y_str), strlen((yyvsp[(1) - (1)].y_str))+1);
		if (sts <= 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "Attribute (%s) is not recognised", (yyvsp[(1) - (1)].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = sts;
	    ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 579 "gram.y"
    { (yyval.y_num) = (yyvsp[(1) - (1)].y_num); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 580 "gram.y"
    {
		struct servent *srv = getservbyname((yyvsp[(1) - (1)].y_str), NULL);
		if (srv == NULL) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "Failed to map (%s) to a port number", (yyvsp[(1) - (1)].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		pmsprintf(warnStr, MYWARNSTRSZ, "Mapped %s to port number %d", (yyvsp[(1) - (1)].y_str), srv->s_port);
		yywarn(warnStr);
		(yyval.y_num) = srv->s_port;
	    ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 593 "gram.y"
    { 
		int sts;
		pmid.whole = (yyvsp[(1) - (1)].y_num);
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole; 
	    ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 606 "gram.y"
    {
		int sts;
		pmid.whole = 0;
		pmid.part.cluster = (yyvsp[(1) - (1)].y_2num).num1;
		pmid.part.item = (yyvsp[(1) - (1)].y_2num).num2;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 621 "gram.y"
    {
		int sts;
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[(1) - (1)].y_3num).num1;
		pmid.part.cluster = (yyvsp[(1) - (1)].y_3num).num2;
		pmid.part.item = (yyvsp[(1) - (1)].y_3num).num3;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 637 "gram.y"
    {
		int sts = pmLookupName(1, (const char **)&(yyvsp[(1) - (1)].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		sts = fix_dynamic_pmid((yyvsp[(1) - (1)].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		(yyval.y_num) = (int)pmid.whole;
	    ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 652 "gram.y"
    { 
		pmid.whole = (yyvsp[(1) - (1)].y_num);
	        (yyval.y_num) = (int)pmid.whole;
	    ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 656 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[(1) - (1)].y_2num).num1;
		pmid.part.cluster = (yyvsp[(1) - (1)].y_2num).num2;
		(yyval.y_num) = (int)pmid.whole;
	    ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 664 "gram.y"
    { 
		indom.whole = (yyvsp[(1) - (1)].y_num);
	        (yyval.y_num) = (int)indom.whole;
	    ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 668 "gram.y"
    { 
		indom.whole = (yyvsp[(1) - (1)].y_num);
		(yyval.y_num) = (int)indom.whole;
	    ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 672 "gram.y"
    {
		indom.whole = 0;
		indom.part.domain = (yyvsp[(1) - (1)].y_2num).num1;
		indom.part.serial = (yyvsp[(1) - (1)].y_2num).num2;
		(yyval.y_num) = (int)indom.whole;
	    ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 680 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[(1) - (1)].y_3num).num1;
		pmid.part.cluster = (yyvsp[(1) - (1)].y_3num).num2;
		pmid.part.item = (yyvsp[(1) - (1)].y_3num).num3;
		(yyval.y_num) = (int)pmid.whole;
	    ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 689 "gram.y"
    { addmetriclist((pmID)(yyvsp[(1) - (1)].y_num)); ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 690 "gram.y"
    { addmetriclist((pmID)(yyvsp[(2) - (2)].y_num)); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 691 "gram.y"
    { addmetriclist((pmID)(yyvsp[(3) - (3)].y_num)); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 695 "gram.y"
    { doargs(); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 698 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 699 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 702 "gram.y"
    {
			int	sts;
			char	nbuf[12];
			pmsprintf(nbuf, sizeof(nbuf), "%d", (yyvsp[(1) - (1)].y_num));
			sts = pmSetDebug(nbuf);
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", nbuf);
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 714 "gram.y"
    {
			int 	sts;
			if ((yyvsp[(1) - (1)].y_str)[0] == '-')
			    sts = pmClearDebug(&(yyvsp[(1) - (1)].y_str)[1]);
			else
			    sts = pmSetDebug((yyvsp[(1) - (1)].y_str));
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", (yyvsp[(1) - (1)].y_str));
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    ;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 727 "gram.y"
    {
			int 	sts;
			char	nbuf[12];
			pmsprintf(nbuf, sizeof(nbuf), "%d", (yyvsp[(2) - (2)].y_num));
			sts = pmSetDebug(nbuf);
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", nbuf);
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 739 "gram.y"
    {
			int 	sts;
			char	nbuf[12];
			pmsprintf(nbuf, sizeof(nbuf), "%d", (yyvsp[(3) - (3)].y_num));
			sts = pmSetDebug(nbuf);
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", nbuf);
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 751 "gram.y"
    {
			int 	sts;
			if ((yyvsp[(2) - (2)].y_str)[0] == '-')
			    sts = pmClearDebug(&(yyvsp[(2) - (2)].y_str)[1]);
			else
			    sts = pmSetDebug((yyvsp[(2) - (2)].y_str));
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", (yyvsp[(2) - (2)].y_str));
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 764 "gram.y"
    {
			int 	sts;
			if ((yyvsp[(3) - (3)].y_str)[0] == '-')
			    sts = pmClearDebug(&(yyvsp[(3) - (3)].y_str)[1]);
			else
			    sts = pmSetDebug((yyvsp[(3) - (3)].y_str));
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", (yyvsp[(3) - (3)].y_str));
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 784 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 785 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 786 "gram.y"
    { (yyval.y_str) = strdup("fetch"); gc_add((yyval.y_str)); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 787 "gram.y"
    { (yyval.y_str) = strdup("profile"); gc_add((yyval.y_str)); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 788 "gram.y"
    { (yyval.y_str) = strdup("context"); gc_add((yyval.y_str)); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 789 "gram.y"
    { (yyval.y_str) = strdup("indom"); gc_add((yyval.y_str)); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 790 "gram.y"
    { (yyval.y_str) = strdup("attr"); gc_add((yyval.y_str)); ;}
    break;



/* Line 1455 of yacc.c  */
#line 3049 "gram.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 793 "gram.y"


