
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 8 "query_parser.y"

/*
 * query_parser.y - yacc/bison grammar for the PCP time series language
 *
 * Copyright (c) 2017-2022 Red Hat.
 * Copyright (c) 2020 Yushan ZHANG.
 * Copyright (c) 2022 Shiyao CHEN.
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 */

#include <ctype.h>
#include "query.h"
#include "load.h"
#include "schema.h"
#include "util.h"
#include "libpcp.h"

typedef struct PARSER {
    char	*yy_input;
    char	*yy_lexicon;
    int		yy_lexpeek;
    int		yy_error;
    sds		yy_errstr;
    char	*yy_tokbuf;
    int 	yy_tokbuflen;
    meta_t	yy_meta;
    sds		yy_base;
    node_t	*yy_np;
    series_t	yy_series;
} PARSER;

typedef union {
    sds		s;
    node_t	*n;
    meta_t	m;
} YYSTYPE;

#define YYSTYPE_IS_DECLARED 1
static int yylex(YYSTYPE *, PARSER *);
static int yyerror(PARSER *, const char *);

static int series_lex(YYSTYPE *, PARSER *);
static int series_error(PARSER *, const char *);
static void gramerr(PARSER *, const char *, const char *, char *);

static node_t *newnode(int);
static node_t *newmetric(sds);
static node_t *newmetricquery(sds, node_t *);
static node_t *newtree(int, node_t *, node_t *);
static int newaligntime(PARSER *, sds);
static int newstarttime(PARSER *, sds);
static int newinterval(PARSER *, sds);
static int newendtime(PARSER *, sds);
static int newrange(PARSER *, sds);
static int newtimezone(PARSER *, sds);
static int newsamples(PARSER *, sds);
static int newoffset(PARSER *, sds);
static char *n_type_str(int);
static char *n_type_c(int);
static char *l_type_str(int);


/* Line 189 of yacc.c  */
#line 145 "query_parser.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     L_UNDEF = 258,
     L_ERROR = 259,
     L_EOS = 260,
     L_PLUS = 261,
     L_MINUS = 262,
     L_STAR = 263,
     L_SLASH = 264,
     L_COLON = 265,
     L_LPAREN = 266,
     L_RPAREN = 267,
     L_LBRACE = 268,
     L_RBRACE = 269,
     L_LSQUARE = 270,
     L_RSQUARE = 271,
     L_ABS = 272,
     L_FLOOR = 273,
     L_LOG = 274,
     L_SQRT = 275,
     L_ROUND = 276,
     L_AVG = 277,
     L_AVG_INST = 278,
     L_AVG_SAMPLE = 279,
     L_COUNT = 280,
     L_DELTA = 281,
     L_MAX = 282,
     L_MAX_INST = 283,
     L_MAX_SAMPLE = 284,
     L_MIN = 285,
     L_MIN_INST = 286,
     L_MIN_SAMPLE = 287,
     L_SUM = 288,
     L_SUM_INST = 289,
     L_SUM_SAMPLE = 290,
     L_STDEV_INST = 291,
     L_STDEV_SAMPLE = 292,
     L_TOPK_INST = 293,
     L_TOPK_SAMPLE = 294,
     L_NTH_PERCENTILE_INST = 295,
     L_NTH_PERCENTILE_SAMPLE = 296,
     L_ANON = 297,
     L_RATE = 298,
     L_INSTANT = 299,
     L_LT = 300,
     L_LEQ = 301,
     L_EQ = 302,
     L_GLOB = 303,
     L_GEQ = 304,
     L_GT = 305,
     L_NEQ = 306,
     L_REQ = 307,
     L_RNE = 308,
     L_AND = 309,
     L_OR = 310,
     L_MKCONST = 311,
     L_RESCALE = 312,
     L_DEFINED = 313,
     L_TYPE = 314,
     L_SEMANTICS = 315,
     L_UNITS = 316,
     L_ASSIGN = 317,
     L_COMMA = 318,
     L_INTERVAL = 319,
     L_TIMEZONE = 320,
     L_ALIGN = 321,
     L_START = 322,
     L_FINISH = 323,
     L_SAMPLES = 324,
     L_OFFSET = 325,
     EVENT_UNIT = 326,
     TIME_UNIT = 327,
     SPACE_UNIT = 328,
     L_INTEGER = 329,
     L_DOUBLE = 330,
     L_NAME = 331,
     L_STRING = 332,
     L_RANGE = 333
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 264 "query_parser.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  85
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1313

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  79
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  18
/* YYNRULES -- Number of rules.  */
#define YYNRULES  196
/* YYNRULES -- Number of states.  */
#define YYNSTATES  586

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   333

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    15,    24,    32,    37,    43,
      48,    51,    54,    57,    61,    63,    65,    67,    69,    71,
      73,    75,    77,    81,    83,    85,    87,    89,    93,    97,
     101,   105,   109,   113,   117,   119,   123,   127,   131,   135,
     139,   143,   147,   151,   155,   159,   163,   167,   175,   180,
     185,   187,   192,   197,   202,   207,   212,   217,   222,   227,
     232,   237,   242,   247,   252,   257,   264,   271,   276,   281,
     286,   291,   296,   301,   306,   311,   316,   321,   328,   335,
     342,   349,   356,   363,   370,   377,   382,   387,   392,   397,
     402,   407,   412,   417,   422,   427,   434,   441,   446,   451,
     456,   461,   466,   471,   473,   477,   481,   485,   489,   493,
     497,   501,   505,   509,   513,   517,   521,   525,   529,   533,
     537,   541,   545,   549,   553,   558,   563,   568,   573,   578,
     583,   588,   593,   598,   603,   608,   613,   618,   623,   630,
     637,   642,   647,   652,   657,   664,   671,   676,   681,   686,
     691,   696,   701,   706,   711,   716,   721,   726,   731,   736,
     741,   746,   751,   758,   765,   772,   779,   786,   793,   800,
     807,   812,   817,   822,   827,   832,   837,   839,   843,   847,
     851,   855,   859,   863,   867,   871,   875,   879,   883,   887,
     891,   895,   899,   903,   907,   911,   915
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      80,     0,    -1,    81,    -1,    76,    62,    81,    -1,    76,
      13,    82,    14,     5,    -1,    76,    13,    82,    14,    15,
      87,    16,     5,    -1,    13,    82,    14,    15,    87,    16,
       5,    -1,    13,    82,    14,     5,    -1,    76,    15,    87,
      16,     5,    -1,    15,    87,    16,     5,    -1,    76,     5,
      -1,    95,     5,    -1,    93,     5,    -1,    82,    63,    90,
      -1,    90,    -1,    84,    -1,    85,    -1,    77,    -1,    76,
      -1,    86,    -1,    75,    -1,    74,    -1,    87,    63,    89,
      -1,    89,    -1,    77,    -1,    74,    -1,    75,    -1,    64,
      10,    88,    -1,    65,    10,    77,    -1,    69,    10,    74,
      -1,    70,    10,    74,    -1,    66,    10,    88,    -1,    67,
      10,    88,    -1,    68,    10,    88,    -1,    78,    -1,    84,
      45,    85,    -1,    84,    46,    85,    -1,    84,    47,    83,
      -1,    84,    49,    85,    -1,    84,    50,    85,    -1,    84,
      51,    83,    -1,    84,    52,    84,    -1,    84,    53,    84,
      -1,    84,    10,    83,    -1,    84,    48,    83,    -1,    90,
      54,    90,    -1,    90,    55,    90,    -1,    76,    13,    82,
      14,    15,    87,    16,    -1,    76,    15,    87,    16,    -1,
      76,    13,    82,    14,    -1,    76,    -1,    43,    11,    92,
      12,    -1,    43,    11,    93,    12,    -1,    27,    11,    92,
      12,    -1,    27,    11,    93,    12,    -1,    28,    11,    92,
      12,    -1,    28,    11,    93,    12,    -1,    29,    11,    92,
      12,    -1,    29,    11,    93,    12,    -1,    30,    11,    92,
      12,    -1,    30,    11,    93,    12,    -1,    31,    11,    92,
      12,    -1,    31,    11,    93,    12,    -1,    32,    11,    92,
      12,    -1,    32,    11,    93,    12,    -1,    57,    11,    92,
      63,    77,    12,    -1,    57,    11,    93,    63,    77,    12,
      -1,    33,    11,    92,    12,    -1,    33,    11,    93,    12,
      -1,    34,    11,    92,    12,    -1,    34,    11,    93,    12,
      -1,    35,    11,    92,    12,    -1,    35,    11,    93,    12,
      -1,    36,    11,    92,    12,    -1,    36,    11,    93,    12,
      -1,    37,    11,    92,    12,    -1,    37,    11,    93,    12,
      -1,    38,    11,    92,    63,    86,    12,    -1,    38,    11,
      93,    63,    86,    12,    -1,    39,    11,    92,    63,    86,
      12,    -1,    39,    11,    93,    63,    86,    12,    -1,    40,
      11,    92,    63,    86,    12,    -1,    40,    11,    93,    63,
      86,    12,    -1,    41,    11,    92,    63,    86,    12,    -1,
      41,    11,    93,    63,    86,    12,    -1,    22,    11,    92,
      12,    -1,    22,    11,    93,    12,    -1,    23,    11,    92,
      12,    -1,    23,    11,    93,    12,    -1,    24,    11,    92,
      12,    -1,    24,    11,    93,    12,    -1,    17,    11,    92,
      12,    -1,    17,    11,    93,    12,    -1,    18,    11,    92,
      12,    -1,    18,    11,    93,    12,    -1,    19,    11,    92,
      63,    85,    12,    -1,    19,    11,    93,    63,    85,    12,
      -1,    19,    11,    92,    12,    -1,    19,    11,    93,    12,
      -1,    20,    11,    92,    12,    -1,    20,    11,    93,    12,
      -1,    21,    11,    92,    12,    -1,    21,    11,    93,    12,
      -1,    94,    -1,    92,     6,    92,    -1,    92,     6,    93,
      -1,    93,     6,    92,    -1,    93,     6,    93,    -1,    92,
       7,    92,    -1,    92,     7,    93,    -1,    93,     7,    92,
      -1,    93,     7,    93,    -1,    92,     8,    92,    -1,    92,
       8,    93,    -1,    93,     8,    92,    -1,    93,     8,    93,
      -1,    85,     8,    92,    -1,    92,     8,    85,    -1,    85,
       8,    93,    -1,    93,     8,    85,    -1,    92,     9,    92,
      -1,    92,     9,    93,    -1,    93,     9,    92,    -1,    93,
       9,    93,    -1,    43,    11,    91,    12,    -1,    43,    11,
      95,    12,    -1,    27,    11,    91,    12,    -1,    27,    11,
      95,    12,    -1,    28,    11,    91,    12,    -1,    28,    11,
      95,    12,    -1,    29,    11,    91,    12,    -1,    29,    11,
      95,    12,    -1,    30,    11,    91,    12,    -1,    30,    11,
      95,    12,    -1,    31,    11,    91,    12,    -1,    31,    11,
      95,    12,    -1,    32,    11,    91,    12,    -1,    32,    11,
      95,    12,    -1,    57,    11,    91,    63,    77,    12,    -1,
      57,    11,    95,    63,    77,    12,    -1,    17,    11,    91,
      12,    -1,    17,    11,    95,    12,    -1,    18,    11,    91,
      12,    -1,    18,    11,    95,    12,    -1,    19,    11,    91,
      63,    85,    12,    -1,    19,    11,    95,    63,    85,    12,
      -1,    19,    11,    91,    12,    -1,    19,    11,    95,    12,
      -1,    20,    11,    91,    12,    -1,    20,    11,    95,    12,
      -1,    21,    11,    91,    12,    -1,    21,    11,    95,    12,
      -1,    33,    11,    91,    12,    -1,    33,    11,    95,    12,
      -1,    34,    11,    91,    12,    -1,    34,    11,    95,    12,
      -1,    35,    11,    91,    12,    -1,    35,    11,    95,    12,
      -1,    36,    11,    91,    12,    -1,    36,    11,    95,    12,
      -1,    37,    11,    91,    12,    -1,    37,    11,    95,    12,
      -1,    38,    11,    91,    63,    86,    12,    -1,    38,    11,
      95,    63,    86,    12,    -1,    39,    11,    91,    63,    86,
      12,    -1,    39,    11,    95,    63,    86,    12,    -1,    40,
      11,    91,    63,    86,    12,    -1,    40,    11,    95,    63,
      86,    12,    -1,    41,    11,    91,    63,    86,    12,    -1,
      41,    11,    95,    63,    86,    12,    -1,    22,    11,    91,
      12,    -1,    22,    11,    95,    12,    -1,    23,    11,    91,
      12,    -1,    23,    11,    95,    12,    -1,    24,    11,    91,
      12,    -1,    24,    11,    95,    12,    -1,    96,    -1,    91,
       6,    91,    -1,    91,     6,    95,    -1,    95,     6,    91,
      -1,    95,     6,    95,    -1,    91,     7,    91,    -1,    91,
       7,    95,    -1,    95,     7,    91,    -1,    95,     7,    95,
      -1,    91,     8,    91,    -1,    91,     8,    95,    -1,    95,
       8,    91,    -1,    95,     8,    95,    -1,    85,     8,    91,
      -1,    91,     8,    85,    -1,    85,     8,    95,    -1,    95,
       8,    85,    -1,    91,     9,    91,    -1,    91,     9,    95,
      -1,    95,     9,    91,    -1,    95,     9,    95,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   196,   196,   197,   204,   210,   217,   219,   221,   228,
     231,   237,   242,   249,   256,   259,   260,   263,   269,   277,
     278,   286,   294,   295,   299,   300,   301,   305,   309,   313,
     317,   321,   325,   329,   333,   340,   344,   348,   352,   356,
     360,   366,   370,   374,   378,   384,   388,   395,   401,   410,
     415,   423,   429,   435,   441,   447,   453,   459,   465,   471,
     477,   484,   491,   497,   503,   509,   529,   549,   555,   561,
     567,   573,   579,   585,   591,   597,   603,   609,   616,   623,
     630,   637,   651,   665,   679,   693,   699,   705,   711,   717,
     723,   729,   735,   741,   747,   753,   760,   767,   773,   779,
     785,   791,   797,   803,   810,   817,   824,   831,   838,   845,
     852,   859,   866,   873,   880,   887,   894,   901,   908,   915,
     922,   929,   936,   943,   952,   958,   964,   970,   976,   983,
     989,   995,  1001,  1007,  1013,  1019,  1025,  1031,  1037,  1057,
    1077,  1083,  1089,  1095,  1101,  1108,  1115,  1121,  1127,  1133,
    1139,  1145,  1151,  1157,  1163,  1169,  1175,  1181,  1187,  1193,
    1199,  1205,  1211,  1218,  1225,  1232,  1239,  1253,  1267,  1281,
    1295,  1301,  1307,  1313,  1319,  1325,  1331,  1338,  1345,  1352,
    1359,  1366,  1373,  1380,  1387,  1394,  1401,  1408,  1415,  1422,
    1429,  1436,  1443,  1450,  1457,  1464,  1471
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "L_UNDEF", "L_ERROR", "L_EOS", "L_PLUS",
  "L_MINUS", "L_STAR", "L_SLASH", "L_COLON", "L_LPAREN", "L_RPAREN",
  "L_LBRACE", "L_RBRACE", "L_LSQUARE", "L_RSQUARE", "L_ABS", "L_FLOOR",
  "L_LOG", "L_SQRT", "L_ROUND", "L_AVG", "L_AVG_INST", "L_AVG_SAMPLE",
  "L_COUNT", "L_DELTA", "L_MAX", "L_MAX_INST", "L_MAX_SAMPLE", "L_MIN",
  "L_MIN_INST", "L_MIN_SAMPLE", "L_SUM", "L_SUM_INST", "L_SUM_SAMPLE",
  "L_STDEV_INST", "L_STDEV_SAMPLE", "L_TOPK_INST", "L_TOPK_SAMPLE",
  "L_NTH_PERCENTILE_INST", "L_NTH_PERCENTILE_SAMPLE", "L_ANON", "L_RATE",
  "L_INSTANT", "L_LT", "L_LEQ", "L_EQ", "L_GLOB", "L_GEQ", "L_GT", "L_NEQ",
  "L_REQ", "L_RNE", "L_AND", "L_OR", "L_MKCONST", "L_RESCALE", "L_DEFINED",
  "L_TYPE", "L_SEMANTICS", "L_UNITS", "L_ASSIGN", "L_COMMA", "L_INTERVAL",
  "L_TIMEZONE", "L_ALIGN", "L_START", "L_FINISH", "L_SAMPLES", "L_OFFSET",
  "EVENT_UNIT", "TIME_UNIT", "SPACE_UNIT", "L_INTEGER", "L_DOUBLE",
  "L_NAME", "L_STRING", "L_RANGE", "$accept", "query", "vector",
  "exprlist", "exprval", "string", "number", "integer", "timelist",
  "timespec", "timeexpr", "expr", "val_vec", "sid_vec", "func_sid",
  "arithmetic_expr_sid", "func", "arithmetic_expression", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    79,    80,    80,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    82,    82,    83,    83,    84,    84,    85,
      85,    86,    87,    87,    88,    88,    88,    89,    89,    89,
      89,    89,    89,    89,    89,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    91,    91,    92,
      92,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    94,    94,    94,    94,    94,    94,
      94,    94,    94,    94,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    96
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     5,     8,     7,     4,     5,     4,
       2,     2,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     7,     4,     4,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     6,     6,     6,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     4,     4,     4,
       4,     4,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     6,     6,
       4,     4,     4,     4,     6,     6,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     6,     6,     6,     6,     6,     6,     6,     6,
       4,     4,     4,     4,     4,     4,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,    20,
      50,     0,     2,     0,    19,     0,     0,     0,   103,     0,
     176,    18,    17,     0,     0,    14,     0,     0,     0,     0,
       0,     0,     0,    34,     0,    23,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    10,     0,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    12,     0,     0,     0,     0,
      11,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     3,   189,   116,   118,   191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   177,   178,   181,   182,   190,   185,
     186,   193,   194,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,     0,
     104,   105,   108,   109,   117,   112,   113,   120,   121,   106,
     107,   110,   111,   119,   114,   115,   122,   123,   179,   180,
     183,   184,   192,   187,   188,   195,   196,     7,     0,    13,
      43,    15,    16,    35,    36,    37,    44,    38,    39,    40,
      41,    42,    45,    46,    25,    26,    24,    27,    28,    31,
      32,    33,    29,    30,     9,    22,     0,     0,   140,    91,
      92,   141,   142,    93,    94,   143,   146,     0,    97,     0,
      98,     0,   147,     0,   148,    99,   100,   149,   150,   101,
     102,   151,   170,    85,    86,   171,   172,    87,    88,   173,
     174,    89,    90,   175,   126,    53,    54,   127,   128,    55,
      56,   129,   130,    57,    58,   131,   132,    59,    60,   133,
     134,    61,    62,   135,   136,    63,    64,   137,   152,    67,
      68,   153,   154,    69,    70,   155,   156,    71,    72,   157,
     158,    73,    74,   159,   160,    75,    76,   161,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   124,    51,    52,   125,     0,     0,
       0,     0,    49,    48,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     4,     0,     8,     0,     0,
       0,    49,    48,   144,    95,    96,   145,   162,    77,    78,
     163,   164,    79,    80,   165,   166,    81,    82,   167,   168,
      83,    84,   169,   138,    65,    66,   139,     0,     0,    49,
       6,     0,    47,     0,     5,    47
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    31,    32,    43,   330,    44,   263,    34,    54,   347,
      55,    45,    35,    36,    37,    38,    39,    40
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -92
static const yytype_int16 yypact[] =
{
     300,    24,   -57,    11,    31,   129,   143,   177,   179,   182,
     193,   229,   331,   344,   355,   357,   359,   361,   367,   369,
     403,   407,   409,   424,   426,   439,   449,   467,   -92,   -92,
     515,   304,   -92,   428,   -92,   203,  1300,   248,   -92,   339,
     -92,   -92,   -92,   -13,   406,   236,   469,   472,   473,   475,
     476,   477,   479,   -92,   -14,   -92,   682,   682,   682,   682,
     682,   682,   682,   682,   682,   682,   682,   682,   682,   682,
     682,   682,   682,   682,   682,   682,   682,   682,   682,   682,
     682,   -92,    24,   -57,   364,   -92,   682,   742,   742,   742,
     742,   802,   802,   802,   802,   -92,   802,   802,   802,   802,
     -92,   742,   742,   742,   742,   237,    24,  1236,   233,   233,
    1236,  1236,   233,   233,  1236,    24,    24,    24,    24,   371,
     340,   371,   371,   371,   416,   445,   516,   -57,     1,   435,
     572,   579,   720,   728,   735,   743,   780,    18,    25,    32,
      39,   788,   795,   803,   840,   848,   855,   862,   873,   880,
     887,   894,   901,   908,   915,   922,   929,   936,   943,   950,
     957,   964,   971,   978,   985,   992,   999,  1006,  1013,  1020,
    1027,  1034,  1041,  1048,  1055,  1062,  1069,  1076,  1083,  1090,
    1097,  1104,  1111,  1118,  1125,  1132,  1139,  1146,  1153,  1160,
    1167,  1174,  1181,  1188,  1195,  1202,  1209,  1216,  1223,  1230,
    1237,  1244,  1251,  1258,  1265,   135,   140,   178,   199,   242,
     293,   343,   352,   356,   402,   417,   421,   425,   455,   460,
     464,  1272,  1279,  1286,  1293,   468,   526,   530,   644,   -11,
      19,   301,   -92,   -92,   -92,   -92,   -92,   511,   513,   514,
     518,   531,   534,   535,   564,   571,   581,   608,   635,   637,
     638,   659,   660,   686,   697,   713,   719,   722,   727,   734,
     737,   756,    72,   533,   317,   345,   317,   345,   -92,   -92,
     -92,   -92,   -92,   757,   773,   779,   782,   787,   794,   797,
     816,   817,   833,   839,   842,   847,   854,   861,   864,   872,
     879,   886,   893,   900,   907,   914,   921,   928,   570,   582,
     381,   404,   381,   404,   -92,   -92,   -92,   -92,   -92,   381,
     404,   381,   404,   -92,   -92,   -92,   -92,   -92,   317,   345,
     317,   345,   -92,   -92,   -92,   -92,   -92,   -92,   -57,   236,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,    24,   -57,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   233,   -92,   233,
     -92,   233,   -92,   233,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   -92,   -92,   -92,   -92,   654,   669,
     676,   677,   288,   786,   742,   742,   742,   742,   742,   742,
     742,   742,   742,   742,   742,   742,   742,   742,   742,   742,
     742,   742,   742,   742,   742,   742,   742,   742,   742,    24,
     742,   802,   802,   802,   802,   802,   802,   802,   802,   802,
     802,   802,   802,   802,   802,   802,   802,   802,   802,   802,
     802,   802,   802,   802,   802,   802,    24,   802,    20,   -10,
      27,   801,   934,   935,   941,   942,   948,   949,   955,   956,
     962,   963,   969,   970,   976,   977,   983,   984,   990,   991,
     997,   998,  1004,  1005,  1011,   -92,   -57,   -92,    -9,    -8,
     809,   791,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,   -92,
     -92,   -92,   -92,   -92,   -92,   -92,   -92,   175,   791,   -92,
     -92,   -57,   846,   176,   -92,   -92
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -92,   -92,   789,   -67,   -91,   433,     0,   216,   -65,   -17,
     739,   -89,   157,    59,   103,   -92,   208,   -92
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      33,   105,   126,   462,   551,   578,   579,    46,    47,    48,
      49,    50,    51,    52,   356,   229,   357,   329,   230,   335,
     336,    53,    56,   339,    87,    88,    89,    90,   342,   343,
     366,    91,    92,    93,    94,   463,   550,   368,    96,    97,
      98,    99,    57,   552,   370,   101,   102,   103,   104,   127,
     106,   372,   106,   106,   106,   106,    33,    33,    33,    33,
      33,    33,    33,    33,    33,    33,    33,    33,    33,    33,
      33,    33,    33,    33,    33,    33,    33,    33,    33,    33,
      33,   367,   127,   127,    33,   489,    33,   357,   369,   268,
     127,   299,   299,   304,   299,   371,   299,   299,   313,   299,
      41,    42,   373,   322,   349,   350,   351,   332,   333,   334,
     332,   332,   337,   338,   332,   130,   134,   138,   142,   146,
     150,   154,   158,   162,   166,   170,   174,   178,   182,   186,
     190,   194,   198,   202,   206,   210,   214,   218,   222,   226,
      58,    87,    88,    89,    90,   234,    91,    92,    93,    94,
     300,   302,   305,   307,    59,   309,   311,   314,   316,   131,
     135,   139,   143,   147,   151,   155,   159,   163,   167,   171,
     175,   179,   183,   187,   191,   195,   199,   203,   207,   211,
     215,   219,   223,   227,    96,    97,    98,    99,    60,   235,
      61,   582,   585,    62,   301,   303,   306,   308,   438,   310,
     312,   315,   317,   439,    63,   101,   102,   103,   104,    87,
      88,    89,    90,   129,   133,   137,   141,   145,   149,   153,
     157,   161,   165,   169,   173,   177,   181,   185,   189,   193,
     197,   201,   205,   209,   213,   217,   221,   225,   127,   127,
      64,   440,   327,   233,   264,   266,   269,   271,    87,    88,
      89,    90,   328,    95,    96,    97,    98,    99,   318,   320,
     323,   325,   441,   518,   132,   136,   140,   144,   148,   152,
     156,   160,   164,   168,   172,   176,   180,   184,   188,   192,
     196,   200,   204,   208,   212,   216,   220,   224,   228,   519,
     117,   118,   520,   545,   236,   265,   267,   270,   272,    91,
      92,    93,    94,   546,    85,   442,    81,    28,    29,   319,
     321,   324,   326,     1,    82,     2,    83,     3,     4,     5,
       6,     7,     8,     9,    10,    89,    90,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    65,    26,   100,   101,   102,   103,   104,    96,
      97,    98,    99,   103,   104,    66,   443,    27,   101,   102,
     103,   104,    87,    88,    89,    90,    67,   521,    68,   522,
      69,   523,    70,   524,    28,    29,    30,     1,    71,     2,
      72,     3,     4,     5,     6,     7,     8,     9,    10,    93,
      94,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,   444,    26,    91,    92,
      93,    94,    98,    99,    73,   445,   107,   348,    74,   446,
      75,    27,   548,    96,    97,    98,    99,   101,   102,   103,
     104,    87,    88,    89,    90,    76,    86,    77,    28,    29,
     231,    87,    88,    89,    90,   344,   345,   358,   346,   549,
      78,   108,   109,   110,   111,   112,   113,   114,   115,   116,
      79,    91,    92,    93,    94,   447,    96,    97,    98,    99,
     101,   102,   103,   104,    87,    88,    89,    90,    80,   119,
     448,   577,   120,   121,   449,   122,   123,   124,   450,   125,
     352,   299,   299,   299,   299,   299,   299,   299,   299,   299,
     299,   299,   299,   299,   299,   299,   299,   299,   299,   299,
     299,   299,   299,   299,   299,   299,   583,   299,   451,   353,
      81,   354,   464,   452,   465,   466,    28,   453,    82,   467,
      83,   458,    91,    92,    93,    94,    96,    97,    98,    99,
     331,   490,   468,   331,   331,   469,   470,   331,   340,   341,
     130,   134,   138,   142,   146,   150,   154,   158,   162,   166,
     170,   174,   178,   182,   186,   190,   194,   198,   202,   206,
     210,   214,   218,   222,   226,   471,   234,    84,    91,    92,
      93,    94,   472,   516,   359,    96,    97,    98,    99,   459,
     517,   360,   473,   460,   131,   135,   139,   143,   147,   151,
     155,   159,   163,   167,   171,   175,   179,   183,   187,   191,
     195,   199,   203,   207,   211,   215,   219,   223,   227,   474,
     235,   129,   133,   137,   141,   145,   149,   153,   157,   161,
     165,   169,   173,   177,   181,   185,   189,   193,   197,   201,
     205,   209,   213,   217,   221,   225,   475,   233,   476,   477,
     101,   102,   103,   104,   525,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     478,   479,   132,   136,   140,   144,   148,   152,   156,   160,
     164,   168,   172,   176,   180,   184,   188,   192,   196,   200,
     204,   208,   212,   216,   220,   224,   228,   480,   236,     3,
       4,     5,     6,     7,     8,     9,    10,   461,   481,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,   482,    26,   101,   102,   103,   104,
     483,   541,   361,   484,    87,    88,    89,    90,   485,    27,
     362,    91,    92,    93,    94,   486,   542,   363,   487,    96,
      97,    98,    99,   543,   544,   364,    28,    29,   128,   237,
     238,   239,   240,   241,   242,   243,   244,   488,   491,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   492,   260,   101,   102,   103,   104,
     493,   547,   365,   494,    87,    88,    89,    90,   495,   261,
     374,    91,    92,    93,    94,   496,   581,   375,   497,    96,
      97,    98,    99,   553,   580,   376,    28,    29,   262,   273,
     274,   275,   276,   277,   278,   279,   280,   498,   499,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   500,   296,   101,   102,   103,   104,
     501,   584,   377,   502,    87,    88,    89,    90,   503,   297,
     378,    91,    92,    93,    94,   504,   355,   379,    96,    97,
      98,    99,   505,   232,   380,   506,    28,    29,   298,   101,
     102,   103,   104,   507,     0,   381,    87,    88,    89,    90,
     508,     0,   382,    91,    92,    93,    94,   509,     0,   383,
      96,    97,    98,    99,   510,     0,   384,   101,   102,   103,
     104,   511,     0,   385,    87,    88,    89,    90,   512,     0,
     386,    91,    92,    93,    94,   513,     0,   387,    96,    97,
      98,    99,   514,     0,   388,   101,   102,   103,   104,   515,
       0,   389,    87,    88,    89,    90,   554,   555,   390,    91,
      92,    93,    94,   556,   557,   391,    96,    97,    98,    99,
     558,   559,   392,   101,   102,   103,   104,   560,   561,   393,
      87,    88,    89,    90,   562,   563,   394,    91,    92,    93,
      94,   564,   565,   395,    96,    97,    98,    99,   566,   567,
     396,   101,   102,   103,   104,   568,   569,   397,    87,    88,
      89,    90,   570,   571,   398,    91,    92,    93,    94,   572,
     573,   399,    96,    97,    98,    99,   574,   575,   400,   101,
     102,   103,   104,   576,     0,   401,    87,    88,    89,    90,
       0,     0,   402,    91,    92,    93,    94,     0,     0,   403,
      96,    97,    98,    99,     0,     0,   404,   101,   102,   103,
     104,     0,     0,   405,    87,    88,    89,    90,     0,     0,
     406,    91,    92,    93,    94,     0,     0,   407,    96,    97,
      98,    99,     0,     0,   408,   101,   102,   103,   104,     0,
       0,   409,    87,    88,    89,    90,     0,     0,   410,    91,
      92,    93,    94,     0,     0,   411,    96,    97,    98,    99,
       0,     0,   412,   101,   102,   103,   104,     0,     0,   413,
      87,    88,    89,    90,     0,     0,   414,    91,    92,    93,
      94,     0,     0,   415,    96,    97,    98,    99,     0,     0,
     416,   101,   102,   103,   104,     0,     0,   417,    87,    88,
      89,    90,     0,     0,   418,    91,    92,    93,    94,     0,
       0,   419,    96,    97,    98,    99,     0,     0,   420,   101,
     102,   103,   104,     0,     0,   421,    87,    88,    89,    90,
       0,     0,   422,    91,    92,    93,    94,     0,     0,   423,
      96,    97,    98,    99,     0,     0,   424,   101,   102,   103,
     104,     0,     0,   425,    87,    88,    89,    90,     0,     0,
     426,    91,    92,    93,    94,     0,     0,   427,    96,    97,
      98,    99,     0,     0,   428,   101,   102,   103,   104,     0,
       0,   429,    87,    88,    89,    90,     0,     0,   430,    91,
      92,    93,    94,     0,     0,   431,    96,    97,    98,    99,
       0,     0,   432,   101,   102,   103,   104,     0,     0,   433,
      87,    88,    89,    90,     0,     0,   434,    91,    92,    93,
      94,     0,     0,   435,    96,    97,    98,    99,     0,     0,
     436,   101,   102,   103,   104,     0,     0,   437,    87,    88,
      89,    90,     0,     0,   454,    91,    92,    93,    94,     0,
       0,   455,    96,    97,    98,    99,     0,     0,   456,   101,
     102,   103,   104,     0,     0,   457,    91,    92,    93,    94,
      28,    29,    41,    42
};

static const yytype_int16 yycheck[] =
{
       0,    14,    16,    14,    14,    14,    14,    64,    65,    66,
      67,    68,    69,    70,    13,    82,    15,   106,    83,   110,
     111,    78,    11,   114,     6,     7,     8,     9,   117,   118,
      12,     6,     7,     8,     9,    16,    16,    12,     6,     7,
       8,     9,    11,    16,    12,     6,     7,     8,     9,    63,
      63,    12,    63,    63,    63,    63,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    63,    63,    63,    84,    13,    86,    15,    63,    89,
      63,    91,    92,    93,    94,    63,    96,    97,    98,    99,
      76,    77,    63,   103,   121,   122,   123,   107,   108,   109,
     110,   111,   112,   113,   114,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      11,     6,     7,     8,     9,    86,     6,     7,     8,     9,
      91,    92,    93,    94,    11,    96,    97,    98,    99,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,     6,     7,     8,     9,    11,    86,
      11,    16,    16,    11,    91,    92,    93,    94,    63,    96,
      97,    98,    99,    63,    11,     6,     7,     8,     9,     6,
       7,     8,     9,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    63,    63,
      11,    63,     5,    86,    87,    88,    89,    90,     6,     7,
       8,     9,    15,     5,     6,     7,     8,     9,   101,   102,
     103,   104,    63,   328,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,   356,
      54,    55,   357,     5,    86,    87,    88,    89,    90,     6,
       7,     8,     9,    15,     0,    63,     5,    74,    75,   101,
     102,   103,   104,    13,    13,    15,    15,    17,    18,    19,
      20,    21,    22,    23,    24,     8,     9,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    11,    43,     5,     6,     7,     8,     9,     6,
       7,     8,     9,     8,     9,    11,    63,    57,     6,     7,
       8,     9,     6,     7,     8,     9,    11,   367,    11,   369,
      11,   371,    11,   373,    74,    75,    76,    13,    11,    15,
      11,    17,    18,    19,    20,    21,    22,    23,    24,     8,
       9,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    63,    43,     6,     7,
       8,     9,     8,     9,    11,    63,    10,    77,    11,    63,
      11,    57,   489,     6,     7,     8,     9,     6,     7,     8,
       9,     6,     7,     8,     9,    11,     8,    11,    74,    75,
      76,     6,     7,     8,     9,    74,    75,    12,    77,   516,
      11,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      11,     6,     7,     8,     9,    63,     6,     7,     8,     9,
       6,     7,     8,     9,     6,     7,     8,     9,    11,    10,
      63,   546,    10,    10,    63,    10,    10,    10,    63,    10,
      74,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   581,   517,    63,    74,
       5,     5,    11,    63,    11,    11,    74,    63,    13,    11,
      15,    63,     6,     7,     8,     9,     6,     7,     8,     9,
     107,     8,    11,   110,   111,    11,    11,   114,   115,   116,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,    11,   517,    62,     6,     7,
       8,     9,    11,    13,    12,     6,     7,     8,     9,    63,
       8,    12,    11,    63,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,    11,
     517,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,    11,   490,    11,    11,
       6,     7,     8,     9,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
      11,    11,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,    11,   490,    17,
      18,    19,    20,    21,    22,    23,    24,    63,    11,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    11,    43,     6,     7,     8,     9,
      11,    77,    12,    11,     6,     7,     8,     9,    11,    57,
      12,     6,     7,     8,     9,    11,    77,    12,    11,     6,
       7,     8,     9,    77,    77,    12,    74,    75,    76,    17,
      18,    19,    20,    21,    22,    23,    24,    11,    11,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    11,    43,     6,     7,     8,     9,
      11,     5,    12,    11,     6,     7,     8,     9,    11,    57,
      12,     6,     7,     8,     9,    11,    15,    12,    11,     6,
       7,     8,     9,    12,     5,    12,    74,    75,    76,    17,
      18,    19,    20,    21,    22,    23,    24,    11,    11,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    11,    43,     6,     7,     8,     9,
      11,     5,    12,    11,     6,     7,     8,     9,    11,    57,
      12,     6,     7,     8,     9,    11,   127,    12,     6,     7,
       8,     9,    11,    84,    12,    11,    74,    75,    76,     6,
       7,     8,     9,    11,    -1,    12,     6,     7,     8,     9,
      11,    -1,    12,     6,     7,     8,     9,    11,    -1,    12,
       6,     7,     8,     9,    11,    -1,    12,     6,     7,     8,
       9,    11,    -1,    12,     6,     7,     8,     9,    11,    -1,
      12,     6,     7,     8,     9,    11,    -1,    12,     6,     7,
       8,     9,    11,    -1,    12,     6,     7,     8,     9,    11,
      -1,    12,     6,     7,     8,     9,    12,    12,    12,     6,
       7,     8,     9,    12,    12,    12,     6,     7,     8,     9,
      12,    12,    12,     6,     7,     8,     9,    12,    12,    12,
       6,     7,     8,     9,    12,    12,    12,     6,     7,     8,
       9,    12,    12,    12,     6,     7,     8,     9,    12,    12,
      12,     6,     7,     8,     9,    12,    12,    12,     6,     7,
       8,     9,    12,    12,    12,     6,     7,     8,     9,    12,
      12,    12,     6,     7,     8,     9,    12,    12,    12,     6,
       7,     8,     9,    12,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9,    -1,
      -1,    12,     6,     7,     8,     9,    -1,    -1,    12,     6,
       7,     8,     9,    -1,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9,    -1,
      -1,    12,     6,     7,     8,     9,    -1,    -1,    12,     6,
       7,     8,     9,    -1,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9,    -1,
      -1,    12,     6,     7,     8,     9,    -1,    -1,    12,     6,
       7,     8,     9,    -1,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9,    -1,
      -1,    12,     6,     7,     8,     9,    -1,    -1,    12,     6,
       7,     8,     9,    -1,    -1,    12,     6,     7,     8,     9,
      74,    75,    76,    77
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    13,    15,    17,    18,    19,    20,    21,    22,    23,
      24,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    43,    57,    74,    75,
      76,    80,    81,    85,    86,    91,    92,    93,    94,    95,
      96,    76,    77,    82,    84,    90,    64,    65,    66,    67,
      68,    69,    70,    78,    87,    89,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,     5,    13,    15,    62,     0,     8,     6,     7,     8,
       9,     6,     7,     8,     9,     5,     6,     7,     8,     9,
       5,     6,     7,     8,     9,    14,    63,    10,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    10,
      10,    10,    10,    10,    10,    10,    16,    63,    76,    91,
      92,    93,    95,    91,    92,    93,    95,    91,    92,    93,
      95,    91,    92,    93,    95,    91,    92,    93,    95,    91,
      92,    93,    95,    91,    92,    93,    95,    91,    92,    93,
      95,    91,    92,    93,    95,    91,    92,    93,    95,    91,
      92,    93,    95,    91,    92,    93,    95,    91,    92,    93,
      95,    91,    92,    93,    95,    91,    92,    93,    95,    91,
      92,    93,    95,    91,    92,    93,    95,    91,    92,    93,
      95,    91,    92,    93,    95,    91,    92,    93,    95,    91,
      92,    93,    95,    91,    92,    93,    95,    91,    92,    93,
      95,    91,    92,    93,    95,    91,    92,    93,    95,    82,
      87,    76,    81,    91,    92,    93,    95,    17,    18,    19,
      20,    21,    22,    23,    24,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      43,    57,    76,    85,    91,    95,    91,    95,    85,    91,
      95,    91,    95,    17,    18,    19,    20,    21,    22,    23,
      24,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    43,    57,    76,    85,
      92,    93,    92,    93,    85,    92,    93,    92,    93,    92,
      93,    92,    93,    85,    92,    93,    92,    93,    91,    95,
      91,    95,    85,    91,    95,    91,    95,     5,    15,    90,
      83,    84,    85,    85,    85,    83,    83,    85,    85,    83,
      84,    84,    90,    90,    74,    75,    77,    88,    77,    88,
      88,    88,    74,    74,     5,    89,    13,    15,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    63,    12,    63,
      12,    63,    12,    63,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    63,    63,
      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      63,    63,    63,    63,    12,    12,    12,    12,    63,    63,
      63,    63,    14,    16,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    13,
       8,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    13,     8,    87,    82,
      87,    85,    85,    85,    85,    86,    86,    86,    86,    86,
      86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
      86,    77,    77,    77,    77,     5,    15,     5,    82,    82,
      16,    14,    16,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    87,    14,    14,
       5,    15,    16,    87,     5,    16
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (lp, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, lp)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, lp); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, PARSER *lp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, lp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    PARSER *lp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (lp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, PARSER *lp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, lp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    PARSER *lp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, lp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, PARSER *lp)
#else
static void
yy_reduce_print (yyvsp, yyrule, lp)
    YYSTYPE *yyvsp;
    int yyrule;
    PARSER *lp;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , lp);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, lp); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, PARSER *lp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, lp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    PARSER *lp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (lp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (PARSER *lp);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (PARSER *lp)
#else
int
yyparse (lp)
    PARSER *lp;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 198 "query_parser.y"
    { lp->yy_series.name = (yyvsp[(1) - (3)].s);
		  (yyval.n) = lp->yy_series.expr;
		  YYACCEPT;
		;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 205 "query_parser.y"
    { if ((lp->yy_np = newmetricquery((yyvsp[(1) - (5)].s), (yyvsp[(3) - (5)].n))) == NULL)
		      return -1;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 211 "query_parser.y"
    { if ((lp->yy_np = newmetricquery((yyvsp[(1) - (8)].s), (yyvsp[(3) - (8)].n))) == NULL)
		      return -1;
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 218 "query_parser.y"
    { lp->yy_np = lp->yy_series.expr = (yyvsp[(2) - (7)].n); YYACCEPT; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 220 "query_parser.y"
    { lp->yy_np = lp->yy_series.expr = (yyvsp[(2) - (4)].n); YYACCEPT; ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 222 "query_parser.y"
    { if ((lp->yy_np = newmetric((yyvsp[(1) - (5)].s))) == NULL)
		      return -1;
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 229 "query_parser.y"
    { YYACCEPT;
		;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 232 "query_parser.y"
    { if ((lp->yy_np = newmetric((yyvsp[(1) - (2)].s))) == NULL)
		      return -1;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 238 "query_parser.y"
    { lp->yy_np = (yyvsp[(1) - (2)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 243 "query_parser.y"
    { lp->yy_np = (yyvsp[(1) - (2)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 250 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AND)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_np;
		;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 264 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STRING)) == NULL)
		      return -1;
		  lp->yy_np->value = (yyvsp[(1) - (1)].s);
		  (yyval.n) = lp->yy_np;
		;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 270 "query_parser.y"
    { if ((lp->yy_np = newnode(N_NAME)) == NULL)
		      return -1;
		  lp->yy_np->value = (yyvsp[(1) - (1)].s);
		  (yyval.n) = lp->yy_np;
		;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 279 "query_parser.y"
    { if ((lp->yy_np = newnode(N_DOUBLE)) == NULL)
		      return -1;
		  lp->yy_np->value = (yyvsp[(1) - (1)].s);
		  (yyval.n) = lp->yy_np;
		;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 287 "query_parser.y"
    { if ((lp->yy_np = newnode(N_INTEGER)) == NULL)
		      return -1;
		  lp->yy_np->value = (yyvsp[(1) - (1)].s);
		  (yyval.n) = lp->yy_np;
		;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 306 "query_parser.y"
    { if (newinterval(lp, (yyvsp[(3) - (3)].s)) < 0)
		      return -1;
		;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 310 "query_parser.y"
    { if (newtimezone(lp, (yyvsp[(3) - (3)].s)) < 0)
		      return -1;
		;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 314 "query_parser.y"
    { if (newsamples(lp, (yyvsp[(3) - (3)].s)) < 0)
		      return -1;
		;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 318 "query_parser.y"
    { if (newoffset(lp, (yyvsp[(3) - (3)].s)) < 0)
		      return -1;
		;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 322 "query_parser.y"
    { if (newaligntime(lp, (yyvsp[(3) - (3)].s)) < 0)
		      return -1;
		;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 326 "query_parser.y"
    { if (newstarttime(lp, (yyvsp[(3) - (3)].s)) < 0)
		      return -1;
		;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 330 "query_parser.y"
    { if (newendtime(lp, (yyvsp[(3) - (3)].s)) < 0)
		      return -1;
		;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 334 "query_parser.y"
    { if (newrange(lp, (yyvsp[(1) - (1)].s)) < 0)
		      return -1;
		;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 341 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_LT, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		    return -1;
		;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 345 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_LEQ, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		    return -1;
		;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 349 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_EQ, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		    return -1;
		;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 353 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_GEQ, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		    return -1;
		;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 357 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_GT, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		    return -1;
		;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 361 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_NEQ, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		    return -1;
		;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 367 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_REQ, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		     return -1;
		;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 371 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_RNE, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		     return -1;
		;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 375 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		     return -1;
		;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 379 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		     return -1;
		;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 385 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_AND, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		      return -1;
		;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 389 "query_parser.y"
    { if (((yyval.n) = lp->yy_np = newtree(N_OR, (yyvsp[(1) - (3)].n), (yyvsp[(3) - (3)].n))) == NULL)
		      return -1;
		;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 396 "query_parser.y"
    { if ((lp->yy_np = newmetricquery((yyvsp[(1) - (7)].s), (yyvsp[(3) - (7)].n))) == NULL)
		      return -1;
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 402 "query_parser.y"
    { if ((lp->yy_np = newmetric((yyvsp[(1) - (4)].s))) == NULL)
		      return -1;
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 411 "query_parser.y"
    { if ((lp->yy_np = newmetricquery((yyvsp[(1) - (4)].s), (yyvsp[(3) - (4)].n))) == NULL)
		      return -1;
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 416 "query_parser.y"
    { if ((lp->yy_np = newmetric((yyvsp[(1) - (1)].s))) == NULL)
		      return -1;
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 424 "query_parser.y"
    { if ((lp->yy_np = newnode(N_RATE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 430 "query_parser.y"
    { if ((lp->yy_np = newnode(N_RATE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 436 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 442 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 448 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 454 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 460 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 466 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 472 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 478 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 485 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 492 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 498 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 504 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 510 "query_parser.y"
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  if ((lp->yy_np = newnode(N_RESCALE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  if (pmParseUnitsStr((yyvsp[(5) - (6)].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  if ((lp->yy_np->right = newnode(N_SCALE)) == NULL)
		      return -1;
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[(5) - (6)].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 530 "query_parser.y"
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  if ((lp->yy_np = newnode(N_RESCALE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  if (pmParseUnitsStr((yyvsp[(5) - (6)].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  if ((lp->yy_np->right = newnode(N_SCALE)) == NULL)
		      return -1;
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[(5) - (6)].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 550 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 556 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 562 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 568 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 574 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 580 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 586 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 592 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 598 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 604 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 610 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 617 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_INST)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 624 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 631 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_SAMPLE)) == NULL)
		      return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 638 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 652 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 666 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 680 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 694 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 700 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 706 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 712 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 718 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 724 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 730 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ABS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 736 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ABS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 742 "query_parser.y"
    { if ((lp->yy_np = newnode(N_FLOOR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 748 "query_parser.y"
    { if ((lp->yy_np = newnode(N_FLOOR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 754 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 761 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 768 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 774 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 780 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SQRT)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 786 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SQRT)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 792 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ROUND)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 798 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ROUND)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 804 "query_parser.y"
    { lp->yy_np = (yyvsp[(1) - (1)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 811 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 818 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 825 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 832 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 839 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 846 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 853 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 860 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 867 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 874 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 881 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 888 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 895 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 902 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 909 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 916 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 923 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 930 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 937 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 944 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 953 "query_parser.y"
    { if ((lp->yy_np = newnode(N_RATE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 959 "query_parser.y"
    { if ((lp->yy_np = newnode(N_RATE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 965 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 971 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 977 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 984 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 990 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 996 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MAX_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1002 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1008 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1014 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1020 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1026 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1032 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MIN_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1038 "query_parser.y"
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  if ((lp->yy_np = newnode(N_RESCALE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  if (pmParseUnitsStr((yyvsp[(5) - (6)].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  if ((lp->yy_np->right = newnode(N_SCALE)) == NULL)
			return -1;
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[(5) - (6)].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1058 "query_parser.y"
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  if ((lp->yy_np = newnode(N_RESCALE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  if (pmParseUnitsStr((yyvsp[(5) - (6)].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  if ((lp->yy_np->right = newnode(N_SCALE)) == NULL)
			return -1;
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[(5) - (6)].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1078 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ABS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1084 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ABS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1090 "query_parser.y"
    { if ((lp->yy_np = newnode(N_FLOOR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1096 "query_parser.y"
    { if ((lp->yy_np = newnode(N_FLOOR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1102 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1109 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1116 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1122 "query_parser.y"
    { if ((lp->yy_np = newnode(N_LOG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1128 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SQRT)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1134 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SQRT)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1140 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ROUND)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1146 "query_parser.y"
    { if ((lp->yy_np = newnode(N_ROUND)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1152 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1158 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1164 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1170 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1176 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1182 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SUM_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1188 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1194 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1200 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1206 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STDEV_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1212 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1219 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1226 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1233 "query_parser.y"
    { if ((lp->yy_np = newnode(N_TOPK_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1240 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1254 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1268 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1282 "query_parser.y"
    { char *ptr;
		  long ret;
		  ret = strtoul((yyvsp[(5) - (6)].n)->value, &ptr, 10);
		  if (*ptr != '\0' || ret < 0 || ret > 100){
			series_error(lp, NULL);
			return -1;
		  }
		  if ((lp->yy_np = newnode(N_NTH_PERCENTILE_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (6)].n);
		  lp->yy_np->right = (yyvsp[(5) - (6)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1296 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1302 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1308 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1314 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_INST)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1320 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1326 "query_parser.y"
    { if ((lp->yy_np = newnode(N_AVG_SAMPLE)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(3) - (4)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1332 "query_parser.y"
    { lp->yy_np = (yyvsp[(1) - (1)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1339 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1346 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1353 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1360 "query_parser.y"
    { if ((lp->yy_np = newnode(N_PLUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1367 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1374 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1381 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1388 "query_parser.y"
    { if ((lp->yy_np = newnode(N_MINUS)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1395 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1402 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1409 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1416 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1423 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1430 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1437 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1444 "query_parser.y"
    { if ((lp->yy_np = newnode(N_STAR)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1451 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1458 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1465 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1472 "query_parser.y"
    { if ((lp->yy_np = newnode(N_SLASH)) == NULL)
			return -1;
		  lp->yy_np->left = (yyvsp[(1) - (3)].n);
		  lp->yy_np->right = (yyvsp[(3) - (3)].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		;}
    break;



/* Line 1455 of yacc.c  */
#line 4234 "query_parser.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (lp, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (lp, yymsg);
	  }
	else
	  {
	    yyerror (lp, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, lp);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, lp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (lp, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, lp);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, lp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1480 "query_parser.y"


/* function table for lexer */
static const struct {
    int		f_type;
    int		f_namelen;
    char	*f_name;
} func[] = {
    { L_AVG,		sizeof("avg")-1,	"avg" },
    { L_AVG_INST,	sizeof("avg_inst")-1,	"avg_inst" },
    { L_AVG_SAMPLE,	sizeof("avg_sample")-1,	"avg_sample" },
    { L_COUNT,		sizeof("count")-1,	"count" },
    { L_MAX,		sizeof("max")-1,	"max" },
    { L_MAX_INST,	sizeof("max_inst")-1,	"max_inst" },
    { L_MAX_SAMPLE,	sizeof("max_sample")-1,	"max_sample" },
    { L_MIN,		sizeof("min")-1,	"min" },
    { L_MIN_INST,	sizeof("min_inst")-1,	"min_inst" },
    { L_MIN_SAMPLE,	sizeof("min_sample")-1,	"min_sample" },
    { L_SUM,		sizeof("sum")-1,	"sum" },
    { L_SUM_INST,	sizeof("sum_inst")-1,	"sum_inst" },
    { L_SUM_SAMPLE,	sizeof("sum_sample")-1,	"sum_sample" },
    { L_STDEV_INST,	sizeof("stdev_inst")-1,	"stdev_inst" },
    { L_STDEV_SAMPLE,	sizeof("stdev_sample")-1,	"stdev_sample" },
    { L_TOPK_INST,	sizeof("topk_inst")-1,	"topk_inst" },
    { L_TOPK_SAMPLE,	sizeof("topk_sample")-1,	"topk_sample" },
    { L_NTH_PERCENTILE_INST,	sizeof("nth_percentile_inst")-1,	"nth_percentile_inst" },
    { L_NTH_PERCENTILE_SAMPLE,	sizeof("nth_percentile_sample")-1,	"nth_percentile_sample" },
    { L_RATE,		sizeof("rate")-1,	"rate" },
    { L_ABS,		sizeof("abs")-1,	"abs" },
    { L_FLOOR,		sizeof("floor")-1,	"floor" },
    { L_LOG,		sizeof("log")-1,	"log" },
    { L_SQRT,		sizeof("sqrt")-1,	"sqrt" },
    { L_ROUND,		sizeof("round")-1,	"round" },
    { L_RESCALE,	sizeof("rescale")-1,	"rescale" },
    { L_UNDEF,		0,			NULL }
};

static struct {
    int         ltype;
    int         ntype;
    char        *long_name;
    char        *short_name;
} typetab[] = {
    { L_UNDEF,		0,		"UNDEF",	NULL },
    { L_ERROR,		0,		"ERROR",	NULL },
    { L_EOS,		0,		"EOS",		NULL },
    { L_INTEGER,	N_INTEGER,	"INTEGER",	NULL },
    { L_DOUBLE,		N_DOUBLE,	"DOUBLE",	NULL },
    { L_NAME,		N_NAME,		"NAME",		NULL },
    { L_NAME,		N_METRIC,	"METRIC",	NULL },
    { L_NAME,		N_QUERY,	"QUERY",	NULL },
    { L_PLUS,		N_PLUS,		"PLUS",		"+" },
    { L_MINUS,		N_MINUS,	"MINUS",	"-" },
    { L_STAR,		N_STAR,		"STAR",		"*" },
    { L_SLASH,		N_SLASH,	"SLASH",	"/" },
    { L_LPAREN,		0,		"LPAREN",	"(" },
    { L_RPAREN,		0,		"RPAREN",	")" },
    { L_LBRACE,		0,		"LBRACE",	"{" },
    { L_RBRACE,		0,		"RBRACE",	"}" },
    { L_TYPE,		0,		"TYPE",		NULL },
    { L_SEMANTICS,	0,		"SEMANTICS",	NULL },
    { L_UNITS,		0,		"UNITS",	NULL },
    { L_ASSIGN,		0,		"ASSIGN",	"=" },
    { L_COMMA,		0,		"COMMA",	"," },
    { L_STRING,		0,		"STRING",	"\"" },
    { L_ABS,		N_ABS,		"ABS",		NULL },
    { L_FLOOR,		N_FLOOR,	"FLOOR",	NULL },
    { N_LOG,		N_LOG,		"LOG",		NULL },
    { N_SQRT,		N_SQRT,		"SQRT",		NULL },
    { N_ROUND,		N_ROUND,	"ROUND",	NULL },
    { L_AVG,		N_AVG,		"AVG",		NULL },
    { L_AVG_INST,	N_AVG_INST,	"AVG_INST",	NULL },
    { L_AVG_SAMPLE,	N_AVG_SAMPLE,	"AVG_SAMPLE",	NULL },
    { L_COUNT,		N_COUNT,	"COUNT",	NULL },
    { L_DELTA,		N_DELTA,	"DELTA",	NULL },
    { L_MAX,		N_MAX,		"MAX",		NULL },
    { L_MAX_INST,	N_MAX_INST,	"MAX_INST",	NULL },
    { L_MAX_SAMPLE,	N_MAX_SAMPLE,	"MAX_SAMPLE",	NULL },
    { L_MIN,		N_MIN,		"MIN",		NULL },
    { L_MIN_INST,	N_MIN_INST,	"MIN_INST",	NULL },
    { L_MIN_SAMPLE,	N_MIN_SAMPLE,	"MIN_SAMPLE",	NULL },
    { L_SUM,		N_SUM,		"SUM",		NULL },
    { L_SUM_INST,	N_SUM_INST,	"SUM_INST",	NULL },
    { L_SUM_SAMPLE,	N_SUM_SAMPLE,	"SUM_SAMPLE",	NULL },
    { L_STDEV_INST,	N_STDEV_INST,	"STDEV_INST",	NULL },
    { L_STDEV_SAMPLE,	N_STDEV_SAMPLE,	"STDEV_SAMPLE",	NULL },
    { L_TOPK_INST,	N_TOPK_INST,	"TOPK_INST",	NULL },
    { L_TOPK_SAMPLE,	N_TOPK_SAMPLE,	"TOPK_SAMPLE",	NULL },
    { L_NTH_PERCENTILE_INST,	N_NTH_PERCENTILE_INST,	"NTH_PERCENTILE_INST",	NULL },
    { L_NTH_PERCENTILE_SAMPLE, N_NTH_PERCENTILE_SAMPLE, "NTH_PERCENTILE_SAMPLE", NULL },
    { L_ANON,		N_ANON,		"ANON",		NULL },
    { L_RATE,		N_RATE,		"RATE",		NULL },
    { L_INSTANT,	N_INSTANT,	"INSTANT",	NULL },
    { L_MKCONST,	0,		"MKCONST",	NULL },
    { L_RESCALE,	N_RESCALE,	"RESCALE",	NULL },
    { 0,		N_SCALE,	"SCALE",	NULL },
    { L_DEFINED,	N_DEFINED,	"DEFINED",	NULL },
    { L_INTERVAL,	N_INTERVAL,	"INTERVAL",	NULL },
    { L_START,		N_START,	"START",	NULL },
    { L_FINISH,		N_FINISH,	"FINISH",	NULL },
    { L_TIMEZONE,	N_TIMEZONE,	"TIMEZONE",	"TZ" },
    { L_SAMPLES,	N_SAMPLES,	"SAMPLES",	NULL },
    { L_OFFSET,		N_OFFSET,	"OFFSET",	NULL },
    { L_LT,		N_LT,		"LT",		"<" },
    { L_LEQ,		N_LEQ,		"LEQ",		"<=" },
    { L_EQ,		N_EQ,		"EQ",		"==" },
    { L_GLOB,		N_GLOB,		"GLOB",		"~~" },
    { L_GEQ,		N_GEQ,		"GEQ",		">=" },
    { L_GT,		N_GT,		"GT",		">" },
    { L_NEQ,		N_NEQ,		"NEQ",		"!=" },
    { L_REQ,		N_REQ,		"REQ",		"=~" },
    { L_RNE,		N_RNE,		"RNE",		"!~" },
    { L_AND,		N_AND,		"AND",		"&&" },
    { L_OR,		N_OR,		"OR",		"||" },
    { 0,		N_NEG,		"NEG",		"-" },
    { -1,		-1,		NULL,		NULL }
};

/* full name for all node types */
static char *
n_type_str(int type)
{
    int		i;
    static char n_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].long_name;
    pmsprintf(n_eh_str, sizeof(n_eh_str), "unknown type %d!", type);
    return n_eh_str;
}

/* short string for the operator node types */
static char *
n_type_c(int type)
{
    int		i;
    static char n_eh_c[20]; /* big enough for "op XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].short_name;
    pmsprintf(n_eh_c, sizeof(n_eh_c), "op %d!", type);
    return n_eh_c;
}

/* full name for all lex types */
static char *
l_type_str(int type)
{
    int		i;
    static char l_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ltype != -1; i++)
	if (type == typetab[i].ltype)
	    return typetab[i].long_name;
    pmsprintf(l_eh_str, sizeof(l_eh_str), "unknown type %d!", type);
    return l_eh_str;
}

static node_t *
newnode(int type)
{
    node_t	*np;

    if ((np = (node_t *)calloc(1, sizeof(node_t))) == NULL) {
	pmNoMem("pmSeries: newnode", sizeof(node_t), PM_RECOV_ERR);
	return NULL;
    }
    np->type = type;
    return np;
}

static node_t *
newtree(int type, node_t *left, node_t *right)
{
    node_t	*tree = newnode(type);

    if (tree) {
	tree->left = left;
	tree->right = right;
    }
    return tree;
}

static node_t *
newmetric(sds name)
{
    node_t	*node;
    char	*re;

    /* enable globbing if string contains a non-escaped '*' */
    if ((re = strchr(name, '*')) != NULL &&
	(re == name || (re[-1] != '%' && re[-1] != '\\')))
	node = newnode(N_GLOB);
    else
	node = newnode(N_EQ);

    if (node) {
	if ((node->left = newnode(N_NAME)) == NULL) {
	    sdsfree(name);
	    free(node);
	    return NULL;
	}
	if ((node->right = newnode(N_STRING)) == NULL) {
	    sdsfree(name);
	    free(node->left);
	    free(node);
	    return NULL;
	}
	node->left->value = sdsnew("metric.name");
	node->right->value = name;
    } else {
	sdsfree(name);
    }
    return node;
}

static node_t *
newmetricquery(sds name, node_t *query)
{
    node_t	*root, *metric;

    if ((root = newnode(N_AND)) == NULL)
	return NULL;
    if ((metric = newmetric(name)) == NULL) {
	free(root);
	return NULL;
    }
    root->left = metric;
    root->right = query;
    return root;
}

static int
newinterval(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseHighResInterval(string, &tp->delta, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time delta with %s:\n%s", "pmParseHighResInterval", error);
	sdsfree(string);
	free(error);
	return -1;
    } else if (tp->window.delta) {
	if (sdscmp(string, tp->window.delta) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		    "Invalid second time delta requested - \"%S\" vs \"%S\"",
		    tp->window.delta, string);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.delta);
    }
    tp->window.delta = string;
    return 0;
}

static int
parsetime(PARSER *lp, struct timespec *result, sds string)
{
    struct timespec start = { 0, 0 };
    struct timespec end = { PM_MAX_TIME_T, 0 };
    char	*error;
    int		sts;

    if ((sts = __pmParseHighResTime(string, &start, &end, result, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time with %s:\n%s",
		"__pmParseHighResTime", error);
	sdsfree(string);
	free(error);
	return -1;
    }
    return 0;
}

static int
newstarttime(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;

    if (parsetime(lp, &tp->start, string) != 0)
	return -1;

    if (tp->window.start) {
	if (sdscmp(tp->window.start, string) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		    "Invalid second start time requested - \"%S\" vs \"%S\"",
		    tp->window.start, string);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.start);
    }
    tp->window.start = string;
    return 0;
}

static int
newendtime(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;

    if (parsetime(lp, &tp->end, string) != 0)
	return -1;

    if (tp->window.end) {
	if (sdscmp(tp->window.end, string) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		    "Invalid second end time requested - \"%S\" vs \"%S\"",
		    tp->window.end, string);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.end);
    }
    tp->window.end = string;
    return 0;
}

static int
newrange(PARSER *lp, sds string)
{
    struct timespec offset;
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseHighResInterval(string, &tp->start, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse range with %s:\n%s", "pmParseHighResInterval", error);
	lp->yy_error = sts;
	sdsfree(string);
	free(error);
	return -1;
    }
    if (tp->window.range) {
	if (sdscmp(tp->window.range, string) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		    "Invalid second time range requested - \"%S\" vs \"%S\"",
		    tp->window.range, string);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.range);
    }
    pmtimespecNow(&offset);
    pmtimespecDec(&offset, &tp->start);
    tp->start = offset;
    tp->end.tv_sec = PM_MAX_TIME_T;
    tp->window.range = string;
    return 0;
}

static int
newaligntime(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;

    if (parsetime(lp, &tp->align, string) != 0)
	return -1;

    if (tp->window.align) {
	if (sdscmp(tp->window.align, string) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		    "Invalid second alignment requested - \"%S\" vs \"%S\"",
		    tp->window.align, string);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.align);
    }
    tp->window.align = string;
    return 0;
}

static int
newtimezone(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	e[PM_MAXERRMSGLEN];
    int		sts;

    if ((sts = pmNewZone(string)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse timezone with pmNewZone:\n\"%S\" - %s",
		string, pmErrStr_r(sts, e, sizeof(e)));
	sdsfree(string);
	return -1;
    } else if (tp->window.zone) {
	if (sdscmp(tp->window.zone, string) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		    "Invalid second timezone requested - \"%S\" vs \"%S\"",
		    tp->window.zone, string);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.zone);
    }
    tp->zone = sts;
    tp->window.zone = string;
    return 0;
}

static int
newsamples(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample count requested - \"%S\"", string);
	sdsfree(string);
	return -1;
    } else if (tp->window.count) {
	if (sdscmp(string, tp->window.count) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid second sample count requested - \"%S\" vs \"%S\"",
		string, tp->window.count);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.count);
    }
    tp->window.count = string;
    tp->count = sts;
    return 0;
}

static int
newoffset(PARSER *lp, sds string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample offset requested - \"%S\"", string);
	sdsfree(string);
    } else if (tp->window.offset) {
	if (sdscmp(string, tp->window.offset) != 0) {
	    lp->yy_error = -EINVAL;
	    lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid second time offset requested - \"%S\" vs \"%S\"",
		string, tp->window.offset);
	    sdsfree(string);
	    return -1;
	}
	sdsfree(tp->window.offset);
    }
    tp->offset = sts;
    tp->window.offset = string;
    return 0;
}

static void
gramerr(PARSER *lp, const char *phrase, const char *pos, char *arg)
{
   char errmsg[256];

   /* unless lexer has already found something amiss ... */
   if (lp->yy_errstr == NULL) {
	if (pos == NULL)
	    pmsprintf(errmsg, sizeof(errmsg), "%s '%s'", phrase, arg);
	else
	    pmsprintf(errmsg, sizeof(errmsg), "%s expected to %s %s", phrase, pos, arg);
	lp->yy_errstr = sdsnew(errmsg);
	if (lp->yy_error == 0)
	    lp->yy_error = -EINVAL;
   }
}

/* Construct error message buffer for syntactic error */
static char *
parseError(const char *spec, const char *point, const char *msg)
{
    size_t	need = 2 * strlen(spec) + strlen(msg) + 8;
    const char	*p;
    char	*q, *result;

    if ((result = malloc(need)) == NULL)
	return NULL;
    q = result;

    for (p = spec; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    for (p = spec; p != point; p++)
	*q++ = isgraph((int)*p) ? ' ' : *p;
    snprintf(q, need - (q - result), "^ -- ");
    q += 5;
    for (p = msg; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    *q = '\0';
    return result;
}

static int
series_error(PARSER *lp, const char *s)
{
    char	*msg;

    msg = parseError(lp->yy_base, lp->yy_lexicon, s ? s : "syntax error");
    lp->yy_errstr = sdscatfmt(sdsempty(), "cannot parse given string\n\n%s", msg);
    free(msg);

    lp->yy_series.expr = NULL;
    lp->yy_error = -EINVAL;
    return 0;
}

static int
yyerror(PARSER *lp, const char *s)
{
    return series_error(lp, s);
}

static void
unget(PARSER *lp, int c)
{
    lp->yy_lexpeek = c;
}

static int
get(PARSER *lp)
{
    int		c;

    if (lp->yy_lexpeek != 0) {
	c = lp->yy_lexpeek;
	lp->yy_lexpeek = 0;
	return c;
    }
    c = *lp->yy_input;
    if (c == '\0')
	return EOF;
    lp->yy_input++;
    return c;
}

static int
series_lex(YYSTYPE *lvalp, PARSER *lp)
{
    char	*p = lp->yy_tokbuf;
    int		ltype = L_UNDEF;
    int		c, i, len;
    int		firstch = 1;
    int		ret = L_UNDEF;

    for ( ; ret == L_UNDEF; ) {
	c = get(lp);
	if (firstch) {
	    if (isspace((int)c)) continue;
	    lp->yy_lexicon = &lp->yy_input[-1];
	    firstch = 0;
	}
	if (c == EOF) {
	    if (ltype != L_UNDEF) {
		/* force end of last token */
		c = 0;
	    }
	    else {
		/* really the end of the input buffer */
		ret = L_EOS;
		break;
	    }
	}
	if (p == NULL) {
	    lp->yy_tokbuflen = 128;
	    if ((p = (char *)malloc(lp->yy_tokbuflen+1)) == NULL) { /* CID287946 */
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot allocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	}
	else if (p >= &lp->yy_tokbuf[lp->yy_tokbuflen]) {
	    len = p - lp->yy_tokbuf;
	    lp->yy_tokbuflen *= 2;
	    if (!(p = (char *)realloc(lp->yy_tokbuf, lp->yy_tokbuflen+1))) { /* CID287946 */
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot reallocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	    p = &lp->yy_tokbuf[len];
	}

	*p++ = (char)c;

	if (ltype == L_UNDEF) {
	    if (isdigit((int)c))
		ltype = L_INTEGER;
	    else if (c == '.')
		ltype = L_DOUBLE;
	    else if (isalpha((int)c))
		ltype = L_NAME;
	    else {
		switch (c) {
		    case '+':
			*p = '\0';
			ret = L_PLUS;
			break;

		    case '-':
			*p = '\0';
			ret = L_MINUS;
			break;

		    case '*':
			*p = '\0';
			ret = L_STAR;
			break;

		    case '/':
			*p = '\0';
			ret = L_SLASH;
			break;

		    case '(':
			*p = '\0';
			ret = L_LPAREN;
			break;

		    case ')':
			*p = '\0';
			ret = L_RPAREN;
			break;

		    case '{':
			*p = '\0';
			ret = L_LBRACE;
			break;

		    case '}':
			*p = '\0';
			ret = L_RBRACE;
			break;

		    case '[':
			*p = '\0';
			ret = L_LSQUARE;
			break;

		    case ']':
			*p = '\0';
			ret = L_RSQUARE;
			break;

		    case '<':
			ltype = L_LT;
			break;

		    case '=':
			ltype = L_EQ;
			break;

		    case '~':
			ltype = L_GLOB;
			break;

		    case '>':
			ltype = L_GT;
			break;

		    case '!':
			ltype = L_NEQ;
			break;

		    case '&':
			ltype = L_AND;
			break;

		    case '|':
			ltype = L_OR;
			break;

		    case ':':
			*p = '\0';
			ret = L_COLON;
			break;

		    case ',':
			*p = '\0';
			ret = L_COMMA;
			break;

		    case '"':
			ltype = L_STRING;
			break;

		    default:
			*p = '\0';
			lp->yy_errstr = sdsnew("Illegal character");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		}
	    }
	}
	else {
	    if (ltype == L_INTEGER) {
		if (c == '.') {
		    ltype = L_DOUBLE;
		}
		else if (isalpha((int)c)) {
		    ltype = L_RANGE;
		}
		else if (!isdigit((int)c)) {
		    char	*endptr;
		    __uint64_t	check;

		    unget(lp, c);
		    p[-1] = '\0';
		    check = strtoull(lp->yy_tokbuf, &endptr, 10);
		    if (*endptr != '\0' || check > 0xffffffffUL) {
			lp->yy_errstr = sdsnew("Constant value too large");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		    }
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for INTEGER failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_INTEGER;
		    break;
		}
	    }
	    else if (ltype == L_RANGE) {
		if (!isalpha((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for RANGE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_RANGE;
		    break;
		}
	    }
	    else if (ltype == L_DOUBLE) {
		if (!isdigit((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for DOUBLE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_DOUBLE;
		    break;
		}
	    }
	    else if (ltype == L_NAME) {
		if (isalpha((int)c) || isdigit((int)c) ||
		    c == '_' || c == '.' || c == '*' || c == '%' || c == '\\')
		    continue;
		if (c == '(') {
		    /* check for functions ... */
		    len = p - lp->yy_tokbuf - 1;
		    for (i = 0; func[i].f_name != NULL; i++) {
			if (len == func[i].f_namelen &&
			    strncmp(lp->yy_tokbuf, func[i].f_name, len) == 0) {
			    unget(lp, c);
			    p[-1] = '\0';
			    ret = func[i].f_type;
			    break;
			}
		    }
		    if (func[i].f_name != NULL) {
			/* match func name */
			break;
		    }
		}

		/* current character is end of name */
		unget(lp, c);
		p[-1] = '\0';
		if (strcmp(lp->yy_tokbuf, "type") == 0) {
		    ret = L_TYPE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "semantics") == 0) {
		    ret = L_SEMANTICS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "units") == 0) {
		    ret = L_UNITS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "interval") == 0 ||
			 strcmp(lp->yy_tokbuf, "delta") == 0) {
		    ret = L_INTERVAL;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "timezone") == 0 ||
			 strcmp(lp->yy_tokbuf, "tz") == 0) {
		    ret = L_TIMEZONE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "start") == 0 ||
			 strcmp(lp->yy_tokbuf, "begin") == 0) {
		    ret = L_START;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "finish") == 0 ||
			 strcmp(lp->yy_tokbuf, "end") == 0) {
		    ret = L_FINISH;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "samples") == 0 ||
			 strcmp(lp->yy_tokbuf, "count") == 0) {
		    ret = L_SAMPLES;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "offset") == 0 ||
			 strcmp(lp->yy_tokbuf, "from") == 0) {
		    ret = L_OFFSET;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "align") == 0 ||
			 strcmp(lp->yy_tokbuf, "alignment") == 0) {
		    ret = L_ALIGN;
		    break;
		}
		if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for NAME failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_NAME;
		break;
	    }
	    else if (ltype == L_STRING) {
		if (c != '"')
		    continue;
		/* [-1] and [1] to strip quotes */
		p[-1] = '\0';
		if ((lvalp->s = sdsnew(&lp->yy_tokbuf[1])) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for STRING failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_STRING;
		break;
	    }
	    else if (ltype == L_LT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_LEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_LT;
		    break;
		}
	    }
	    else if (ltype == L_GT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_GEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_GT;
		    break;
		}
	    }
	    else if (ltype == L_GLOB) {
		if (c == '~') {
		    *p = '\0';
		    ret = L_GLOB;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_EQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_EQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_REQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_ASSIGN;
		    break;
		}
	    }
	    else if (ltype == L_NEQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_NEQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_RNE;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_AND) {
		if (c == '&') {
		    *p = '\0';
		    ret = L_AND;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_OR) {
		if (c == '|') {
		    *p = '\0';
		    ret = L_OR;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	}
    }

    if (pmDebugOptions.series && pmDebugOptions.appl0)
	fprintf(stderr, "series_lex() -> type=L_%s \"%s\"\n",
		l_type_str(ret), ret == L_EOS ? "" : lp->yy_tokbuf);

    return ret;
}

static int
yylex(YYSTYPE *lvalp, PARSER *lp)
{
    return series_lex(lvalp, lp);
}

static void
series_freetime(timing_t *tp)
{
    sdsfree(tp->window.delta);
    sdsfree(tp->window.align);
    sdsfree(tp->window.start);
    sdsfree(tp->window.end);
    sdsfree(tp->window.range);
    sdsfree(tp->window.count);
    sdsfree(tp->window.offset);
    sdsfree(tp->window.zone);
}

static void
series_dumpexpr(node_t *np, int level)
{
    if (np == NULL)
	return;

    series_dumpexpr(np->left, level+1);

    switch (np->type) {
    case N_NAME: case N_INTEGER: case N_DOUBLE:
	fprintf(stderr, "%*s%s", level*4, "", np->value);
	break;
    case N_STRING:
	fprintf(stderr, "%*s\"%s\"", level*4, "", np->value);
	break;
    case N_LT:  case N_LEQ: case N_EQ:  case N_GEQ: case N_GT:  case N_NEQ:
    case N_AND: case N_OR:  case N_RNE: case N_REQ: case N_NEG: case N_GLOB:
    case N_PLUS: case N_MINUS: case N_STAR: case N_SLASH:
	fprintf(stderr, "%*s%s", level*4, "", n_type_c(np->type));
	break;
    case N_AVG: case N_COUNT:   case N_DELTA:   case N_MAX:     case N_MIN:
    case N_SUM: case N_ANON:    case N_RATE:    case N_INSTANT: case N_RESCALE:
    case N_MAX_INST: case N_MAX_SAMPLE: case N_MIN_INST: case N_MIN_SAMPLE:
    case N_AVG_INST: case N_AVG_SAMPLE: case N_SUM_INST: case N_SUM_SAMPLE:
    case N_STDEV_INST: case N_STDEV_SAMPLE: case N_NTH_PERCENTILE_INST:
    case N_NTH_PERCENTILE_SAMPLE: case N_TOPK_INST: case N_TOPK_SAMPLE: 
	fprintf(stderr, "%*s%s()", level*4, "", n_type_str(np->type));
	break;
    case N_SCALE: {
	char	strbuf[60];

	if (pmUnitsStr_r(&np->meta.units, strbuf, sizeof(strbuf)) == NULL)
	    fprintf(stderr, " [bad units: %d %d %d %d %d %d]",
			np->meta.units.scaleCount, np->meta.units.scaleTime,
			np->meta.units.scaleSpace,
			np->meta.units.dimCount, np->meta.units.dimTime,
			np->meta.units.dimSpace);
	else
	    fprintf(stderr, " [%s]", strbuf);
	break;
	}
    default:
	break;
    }
    fputc('\n', stderr);

    series_dumpexpr(np->right, level+1);
}

int
series_parse(sds query, series_t *sp, sds *err)
{
    PARSER	yp = { .yy_base = query, .yy_input = (char *)query };
    int		sts;

    sts = yyparse(&yp);
    if (yp.yy_tokbuf)
	free(yp.yy_tokbuf);

    if (sts != 0) {
	*err = yp.yy_errstr;
	return yp.yy_error;
    }
    if (yp.yy_series.expr == NULL) {	/* only a window? */
	*err = sdsnew("Invalid series query specification");
	return -EINVAL;
    }

    if (pmDebugOptions.query) {
	fprintf(stderr, "parsed query: %s\n", query);
	series_dumpexpr(yp.yy_series.expr, 0);
	fputc('\n', stderr);
    }

    *sp = yp.yy_series; /* struct copy */
    return sts;
}

int
pmSeriesQuery(pmSeriesSettings *settings, sds query, pmSeriesFlags flags, void *arg)
{
    series_t	sp = {0};
    sds		errstr;
    int		sts;

    series_stats_inc(settings, SERIES_QUERY_CALLS);

    if ((sts = series_parse(query, &sp, &errstr)) != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, errstr, arg);
	return sts;
    }

    sts = series_solve(settings, sp.expr, &sp.time, flags, arg);
    series_freetime(&sp.time);
    return sts;
}

int
pmSeriesLoad(pmSeriesSettings *settings, sds source, pmSeriesFlags flags, void *arg)
{
    series_t	sp = {0};
    sds		errstr;
    int		sts;

    series_stats_inc(settings, SERIES_LOAD_CALLS);

    if ((sts = series_parse(source, &sp, &errstr)) != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, errstr, arg);
	return sts;
    }

    sts = series_load(settings, sp.expr, &sp.time, flags, arg);
    series_freetime(&sp.time);
    return sts;
}

int
pmSeriesWindow(pmSeriesSettings *settings, sds window, pmSeriesTimeWindow *wp, void *arg)
{
    PARSER	yp = { .yy_base = window, .yy_input = (char *)window };
    timing_t	*tp = &yp.yy_series.time;
    sds		error;
    int		sts;

    sts = yyparse(&yp);
    if (yp.yy_tokbuf)
	free(yp.yy_tokbuf);

    if (sts != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, yp.yy_errstr, arg);
	series_freetime(tp);
	return yp.yy_error;
    }
    if (yp.yy_series.expr != NULL) {
	error = sdsnew("Invalid time window specification");
	moduleinfo(&settings->module, PMLOG_ERROR, error, arg);
	series_freetime(tp);
	return -EINVAL;
    }

    *wp = tp->window; /* struct copy */
    return sts;
}

