
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 17 "gram.y"

/*
 *  pmlogrewrite parser
 */
#include "pmapi.h"
#include "libpcp.h"
#include "logger.h"
#include <errno.h>
#include <assert.h>

#define PM_TEXT_TYPE_MASK (PM_TEXT_ONELINE | PM_TEXT_HELP)

static indomspec_t	*current_indomspec;
static int		current_star_indom;
static int		do_walk_indom;
static int		star_domain;

static metricspec_t	*current_metricspec;
static int		current_star_metric;
static int		star_cluster;
static int		do_walk_metric;
static int		output = OUTPUT_ALL;
static int		one_inst;
static char		*one_name;

static textspec_t	*current_textspec;
static int		do_walk_text;

static int		current_label_id;
static char *		current_label_name;
static char *		current_label_value;
static int		current_label_instance;
static char *		current_label_instance_name;
static labelspec_t	*current_labelspec;
static int		do_walk_label;

indomspec_t *
walk_indom(int mode)
{
    static indomspec_t	*ip;

    if (do_walk_indom) {
	if (mode == W_START)
	    ip = indom_root;
	else
	    ip = ip->i_next;
	while (ip != NULL && pmInDom_domain(ip->old_indom) != star_domain)
	    ip = ip->i_next;
    }
    else {
	if (mode == W_START)
	    ip = current_indomspec;
	else
	    ip = NULL;
    }

    return ip;
}

metricspec_t *
walk_metric(int mode, int flag, char *which, int dupok)
{
    static metricspec_t	*mp;

    if (do_walk_metric) {
	if (mode == W_START)
	    mp = metric_root;
	else
	    mp = mp->m_next;
	while (mp != NULL) {
	    if (pmID_domain(mp->old_desc.pmid) == star_domain &&
		(star_cluster == PM_ID_NULL || star_cluster == pmID_cluster(mp->old_desc.pmid)))
		break;
	    mp = mp->m_next;
	}
    }
    else {
	if (mode == W_START)
	    mp = current_metricspec;
	else
	    mp = NULL;
    }

    if (mp != NULL) {
	if (!dupok && (mp->flags & flag)) {
	    pmsprintf(mess, sizeof(mess), "Duplicate %s clause for metric %s", which, mp->old_name);
	    yyerror(mess);
	}
	if (flag != METRIC_DELETE) {
	    if (mp->flags & METRIC_DELETE) {
		pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted metric %s", which, mp->old_name);
		yyerror(mess);
	    }
	}
	else {
	    if (mp->flags & (~METRIC_DELETE)) {
		pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for metric %s", mp->old_name);
		yyerror(mess);
	    }
	}
    }

    return mp;
}

static const char *
textTypeStr(int type)
{
    switch(type)
	{
	case PM_TEXT_ONELINE:
	    return "one line";
	case PM_TEXT_HELP:
	    return "help";
	default:
	    break;
	}

    return "unknown";
}
 
textspec_t *
walk_text(int mode, int flag, char *which, int dupok)
{
    static textspec_t	*tp;

    if (do_walk_text) {
	if (mode == W_START)
	    tp = text_root;
	else
	    tp = tp->t_next;

	/* Only consider the active specs. */
	while (tp != NULL && (tp->flags & TEXT_ACTIVE) == 0)
	    tp = tp->t_next;
    }
    else {
	if (mode == W_START) {
	    tp = current_textspec;
	    if (tp)
		assert ((tp->flags & TEXT_ACTIVE));
	}
	else
	    tp = NULL;
    }

    if (tp != NULL) {
	tp->flags &= ~TEXT_ACTIVE;
	
	if (!dupok && (tp->flags & flag)) {
	    if ((tp->old_type & PM_TEXT_PMID)) {
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for %s text for metric %s",
			  which, textTypeStr(tp->old_type), pmIDStr(tp->old_id));
	    }
	    else {
		assert((tp->old_type & PM_TEXT_INDOM));
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for %s text for indom %s",
			  which, textTypeStr(tp->old_type), pmInDomStr(tp->old_id));
	    }
	    yyerror(mess);
	}
	if (flag != TEXT_DELETE) {
	    if (tp->flags & TEXT_DELETE) {
		if ((tp->old_type & PM_TEXT_PMID)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted %s text for metric %s",
			      which, textTypeStr(tp->old_type), pmIDStr(tp->old_id));
		}
		else {
		    assert((tp->old_type & PM_TEXT_INDOM));
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted %s text for indom %s",
			      which, textTypeStr(tp->old_type), pmInDomStr(tp->old_id));
		}
		yyerror(mess);
	    }
	}
	else {
	    if (tp->flags & (~TEXT_DELETE)) {
		if ((tp->old_type & PM_TEXT_PMID)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for %s text for metric %s",
			      textTypeStr(tp->old_type), pmIDStr(tp->old_id));
		}
		else {
		    assert((tp->old_type & PM_TEXT_INDOM));
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for %s text for indom %s",
			      textTypeStr(tp->old_type), pmInDomStr(tp->old_id));
		}
		yyerror(mess);
	    }
	}
    }

    return tp;
}

labelspec_t *
walk_label(int mode, int flag, char *which, int dupok)
{
    static labelspec_t	*lp;

    if (do_walk_label > 1) {
	if (mode == W_START)
	    lp = label_root;
	else
	    lp = lp->l_next;

	/* Only consider the active specs. */
	while (lp != NULL && (lp->flags & LABEL_ACTIVE) == 0)
	    lp = lp->l_next;
    }
    else {
	if (mode == W_START)
	    lp = current_labelspec;
	else
	    lp = NULL;
    }

    if (lp != NULL) {
	lp->flags &= ~LABEL_ACTIVE;
	
	if (!dupok && (lp->flags & flag)) {
	    if ((lp->old_type & PM_LABEL_CONTEXT)) {
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for context label",
			  which);
	    }
	    else if ((lp->old_type & PM_LABEL_DOMAIN)) {
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for label for domain %d",
			  which, pmID_domain(lp->old_id));
	    }
	    else if ((lp->old_type & PM_LABEL_CLUSTER)) {
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for label for cluster %d.%d",
			  which, pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
	    }
	    else if ((lp->old_type & PM_LABEL_ITEM)) {
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for label for metric %s",
			  which, pmIDStr(lp->old_id));
	    }
	    else if ((lp->old_type & PM_LABEL_INDOM)) {
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for label for indom %s",
			  which, pmInDomStr(lp->old_id));
	    }
	    else if ((lp->old_type & PM_LABEL_INSTANCES)) {
		pmsprintf(mess, sizeof(mess), "Duplicate %s clause for label for the instances of indom %s",
			  which, pmInDomStr(lp->old_id));
	    }
	    yyerror(mess);
	}
	if (flag != LABEL_DELETE) {
	    if (lp->flags & LABEL_DELETE) {
		if ((lp->old_type & PM_LABEL_CONTEXT)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted context label",
			      which);
		}
		else if ((lp->old_type & PM_LABEL_DOMAIN)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted label for domain %d",
			      which, pmID_domain(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_CLUSTER)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted label for cluster %d.%d",
			      which, pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_ITEM)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted label for metric %s",
			      which, pmIDStr(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_INDOM)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted label for indom %s",
			      which, pmInDomStr(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_INSTANCES)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting %s clause for deleted label for the instances of indom %s",
			      which, pmInDomStr(lp->old_id));
		}
		yyerror(mess);
	    }
	}
	else {
	    if (lp->flags & (~LABEL_DELETE)) {
		if ((lp->old_type & PM_LABEL_CONTEXT)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for context label");
		}
		else if ((lp->old_type & PM_LABEL_DOMAIN)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for label for domain %d",
			      pmID_domain(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_CLUSTER)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for label for cluster %d.%d",
			      pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_ITEM)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for label for metric %s",
			      pmIDStr(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_INDOM)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for label for indom %s",
			      pmInDomStr(lp->old_id));
		}
		else if ((lp->old_type & PM_LABEL_INSTANCES)) {
		    pmsprintf(mess, sizeof(mess), "Conflicting delete and other clauses for label for the instances of indom %s",
			      pmInDomStr(lp->old_id));
		}
		yyerror(mess);
	    }
	}
    }

    return lp;
}

void
deactivate_labels(void)
{
    labelspec_t	*lp;
    for (lp = walk_label(W_START, LABEL_ACTIVE, "active", 0); lp != NULL; lp = walk_label(W_NEXT, 0, "", 0)) {
	lp->flags &= ~LABEL_ACTIVE;
    }
}

void
new_context_label()
{
    labelspec_t	*lp;
    int		sts;
    char	buf[PM_MAXLABELJSONLEN];

    /*
     * Ignore the other change specs which were identified and
     * add the new label to the generic context label change spec.
     * Search for an existing one first.
     */
    deactivate_labels();
    for (lp = label_root; lp != NULL; lp = lp->l_next) {
	if (lp->old_type == PM_LABEL_CONTEXT) {
	    assert (lp->old_id == PM_ID_NULL);
	    if (lp->old_label == NULL)
		break;
	}
    }

    /* Create one if none exists. */
    if (lp == NULL)
	lp = create_label(PM_LABEL_CONTEXT, PM_ID_NULL, 0, NULL, NULL);

    /* Add the new label to the label change spec. */
    pmsprintf(buf, sizeof(buf), "{%s:%s}",
	      current_label_name, current_label_value);
    if ((sts = __pmAddLabels(&lp->new_labels, buf, PM_LABEL_CONTEXT)) < 0) {
	pmsprintf(mess, sizeof(mess),
		  "Unable to add new context label %s: %s",
		  buf, pmErrStr(sts));
	yyerror(mess);
    }
    lp->new_labels->inst = 0;
    lp->flags |= LABEL_NEW;
}

void
new_domain_label(int domain)
{
    labelspec_t		*lp;
    int			sts;
    int			found = 0;
    __pmContext		*ctxp;
    __pmHashCtl		*hcp;
    __pmHashNode	*node;
    char		buf[PM_MAXLABELJSONLEN];

    /*
     * Ignore the change specs which were previously identified and instead
     * search the metadata for metrics in the given domain.
     * Create or re-use the change record for each one found. 
     */
    deactivate_labels();

    ctxp = __pmHandleToPtr(pmWhichContext());
    assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
    PM_UNLOCK(ctxp->c_lock);

    /* Prepare the JSON for the new label. */
    pmsprintf(buf, sizeof(buf), "{%s:%s}",
	      current_label_name, current_label_value);

    hcp = &ctxp->c_archctl->ac_log->hashpmid;
    for (node = __pmHashWalk(hcp, PM_HASH_WALK_START);
	 node != NULL;
	 node = __pmHashWalk(hcp, PM_HASH_WALK_NEXT)) {
	if (pmID_domain(node->key) != domain)
	    continue;

	/*
	 * A metric in this domain exists.
	 * Add the new label to the generic label change spec for this
	 * domain. Search for an existing one first.
	 */
	found = 1;
	for (lp = label_root; lp != NULL; lp = lp->l_next) {
	    if (lp->old_type != PM_LABEL_DOMAIN)
		continue;
	    if (lp->old_id != domain)
		continue;
	    if (lp->old_label == NULL)
		break;
	}

	/* Create one if none exists. */
	if (lp == NULL)
	    lp = create_label(PM_LABEL_DOMAIN, domain, 0, NULL, NULL);

	/* Add the new label to the label change spec. */
	if ((sts = __pmAddLabels(&lp->new_labels, buf, PM_LABEL_DOMAIN)) < 0) {
	    pmsprintf(mess, sizeof(mess),
		      "Unable to add new domain label %s: %s",
		      buf, pmErrStr(sts));
	    yyerror(mess);
	}
	lp->new_labels->inst = 0;
	lp->flags |= LABEL_NEW;

	/* We only need to find one metric in the specified domain. */
	break;
    }

    /* Did we find any clusters matching the spec? */
    if (! found) {
	pmsprintf(mess, sizeof(mess),
		  "No matching domain for new label %s", buf);
	yywarn(mess);
    }
}

void
new_cluster_label(int cluster)
{
    labelspec_t		*lp;
    int			sts;
    int			found = 0;
    __pmContext		*ctxp;
    __pmHashCtl		*hcp;
    __pmHashNode	*node;
    char		buf[PM_MAXLABELJSONLEN] = "";

    /*
     * Ignore the change specs which were previously identified and instead
     * search the metadata for metrics in the given domain.
     * Create or re-use the change record for each one found. 
     */
    deactivate_labels();

    ctxp = __pmHandleToPtr(pmWhichContext());
    assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
    PM_UNLOCK(ctxp->c_lock);

    /* Prepare the JSON for the new label. */
    pmsprintf(buf, sizeof(buf), "{%s:%s}",
	      current_label_name, current_label_value);

    hcp = &ctxp->c_archctl->ac_log->hashpmid;
    for (node = __pmHashWalk(hcp, PM_HASH_WALK_START);
	 node != NULL;
	 node = __pmHashWalk(hcp, PM_HASH_WALK_NEXT)) {
	if (pmID_domain(node->key) != pmID_domain(cluster))
	    continue;
	if (! current_star_metric && 
	    pmID_cluster(node->key) != pmID_cluster(cluster))
	    continue;

	/*
	 * A metric in this cluster exists.
	 * Add the new label to the generic label change spec for the
	 * identified cluster. Search for an existing one first.
	 */
	found = 1;
	for (lp = label_root; lp != NULL; lp = lp->l_next) {
	    if (lp->old_type != PM_LABEL_CLUSTER)
		continue;
	    if (pmID_domain(lp->old_id) != pmID_domain((pmID)(node->key)))
		continue;
	    if (pmID_cluster(lp->old_id) != pmID_cluster((pmID)(node->key)))
		continue;
	    if (lp->old_label == NULL)
		break;
	}

	if (lp == NULL) {
	    pmID current_cluster =
		pmID_build(pmID_domain(node->key), pmID_cluster(node->key), 0);
	    lp = create_label(PM_LABEL_CLUSTER, current_cluster, 0, NULL, NULL);
	}

	/* Add the new label to the label change spec. */
	if ((sts = __pmAddLabels(&lp->new_labels, buf, PM_LABEL_CLUSTER)) < 0) {
	    pmsprintf(mess, sizeof(mess),
		      "Unable to add new cluster label %s: %s",
		      buf, pmErrStr(sts));
	    yyerror(mess);
	}
	lp->new_labels->inst = 0;
	lp->flags |= LABEL_NEW;

	/* Do we need to look for more clusters? */
	if (! current_star_metric)
	    break;
    }

    /* Did we find any clusters matching the spec? */
    if (! found) {
	pmsprintf(mess, sizeof(mess),
		  "No matching cluster for new label %s", buf);
	yywarn(mess);
    }
}

void
new_item_label(int item)
{
    labelspec_t		*lp;
    int			sts;
    int			found = 0;
    __pmContext		*ctxp;
    __pmHashCtl		*hcp;
    __pmHashNode	*node;
    char		buf[PM_MAXLABELJSONLEN] = "";

    /*
     * Ignore the change specs which were previously identified and instead
     * search the metadata for metrics in the given domain.
     * Create or re-use the change record for each one found. 
     */
    deactivate_labels();

    ctxp = __pmHandleToPtr(pmWhichContext());
    assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
    PM_UNLOCK(ctxp->c_lock);

    /* Prepare the JSON for the new label. */
    pmsprintf(buf, sizeof(buf), "{%s:%s}",
	      current_label_name, current_label_value);

    hcp = &ctxp->c_archctl->ac_log->hashpmid;
    for (node = __pmHashWalk(hcp, PM_HASH_WALK_START);
	 node != NULL;
	 node = __pmHashWalk(hcp, PM_HASH_WALK_NEXT)) {
	if (pmID_domain(node->key) != pmID_domain(item))
	    continue;
	if (current_star_metric < 2) {
	    if (pmID_cluster(node->key) != pmID_cluster(item))
		continue;
	    if (! current_star_metric && (pmID)(node->key) != (pmID)item)
		continue;
	}

	/*
	 * A metric with this pmID exists.
	 * Add the new label to the generic label change spec for the
	 * identified item. Search for an existing one first.
	 */
	found = 1;
	for (lp = label_root; lp != NULL; lp = lp->l_next) {
	    if (lp->old_type != PM_LABEL_ITEM)
		continue;
	    if ((pmID)(lp->old_id) != (pmID)(node->key))
		continue;
	    if (lp->old_label == NULL)
		break;
	}

	if (lp == NULL)
	    lp = create_label(PM_LABEL_ITEM, (pmID)node->key, 0, NULL, NULL);

	/* Add the new label to the label change spec. */
	if ((sts = __pmAddLabels(&lp->new_labels, buf, PM_LABEL_ITEM)) < 0) {
	    pmsprintf(mess, sizeof(mess),
		      "Unable to add new metric item label %s: %s",
		      buf, pmErrStr(sts));
	    yyerror(mess);
	}
	lp->new_labels->inst = 0;
	lp->flags |= LABEL_NEW;

	/* Do we need to look for more items? */
	if (! current_star_metric)
	    break;
    }

    /* Did we find any items matching the spec? */
    if (! found) {
	pmsprintf(mess, sizeof(mess),
		  "No matching metric for new label %s", buf);
	yywarn(mess);
    }
}

void
new_indom_label(int indom)
{
    labelspec_t		*lp;
    int			sts;
    int			found = 0;
    __pmContext		*ctxp;
    __pmHashCtl		*hcp;
    __pmHashNode	*node;
    char		buf[PM_MAXLABELJSONLEN] = "";

    /*
     * Ignore the change specs which were previously identified and instead
     * search the metadata for metrics in the given domain.
     * Create or re-use the change record for each one found. 
     */
    deactivate_labels();

    ctxp = __pmHandleToPtr(pmWhichContext());
    assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
    PM_UNLOCK(ctxp->c_lock);

    /* Prepare the JSON for the new label. */
    pmsprintf(buf, sizeof(buf), "{%s:%s}",
	      current_label_name, current_label_value);

    hcp = &ctxp->c_archctl->ac_log->hashindom;
    for (node = __pmHashWalk(hcp, PM_HASH_WALK_START);
	 node != NULL;
	 node = __pmHashWalk(hcp, PM_HASH_WALK_NEXT)) {
	if (pmInDom_domain(node->key) != pmInDom_domain(indom))
	    continue;
	if (! current_star_indom && 
	    pmInDom_serial(node->key) != pmInDom_serial(indom))
	    continue;

	/*
	 * A metric in this indom exists.
	 * Add the new label to the generic label change spec for the
	 * identified indom. Search for an existing one first.
	 */
	found = 1;
	for (lp = label_root; lp != NULL; lp = lp->l_next) {
	    if (lp->old_type != PM_LABEL_INDOM)
		continue;
	    if (pmInDom_domain(lp->old_id) != pmInDom_domain((pmInDom)(node->key)))
		continue;
	    if (pmInDom_serial(lp->old_id) != pmInDom_serial((pmInDom)(node->key)))
		continue;
	    if (lp->old_instance != -1)
		continue;
	    if (lp->old_label == NULL)
		break;
	}

	if (lp == NULL) {
	    pmInDom current_indom =
		pmInDom_build(pmInDom_domain(node->key), pmInDom_serial(node->key));
	    lp = create_label(PM_LABEL_INDOM, current_indom, 0, NULL, NULL);
	}

	/* Add the new label to the label change spec. */
	if ((sts = __pmAddLabels(&lp->new_labels, buf, PM_LABEL_INDOM)) < 0) {
	    pmsprintf(mess, sizeof(mess),
		      "Unable to add new indom label %s: %s",
		      buf, pmErrStr(sts));
	    yyerror(mess);
	}
	lp->new_labels->inst = 0;
	lp->flags |= LABEL_NEW;

	/* Do we need to look for more indoms? */
	if (! current_star_indom)
	    break;
    }

    /* Did we find any indoms matching the spec? */
    if (! found) {
	pmsprintf(mess, sizeof(mess),
		  "No matching indom for new label %s", buf);
	yywarn(mess);
    }
}

void
new_indom_instance_label(int indom)
{
    labelspec_t		*lp;
    int			sts;
    int			found = 0;
    __pmContext		*ctxp;
    __pmHashCtl		*hcp;
    __pmHashNode	*node;
    __pmLogInDom	*idp;
    char		buf[PM_MAXLABELJSONLEN] = "";

    /*
     * Ignore the change specs which were previously identified and instead
     * search the metadata for metrics in the given domain.
     * Create or re-use the change record for each one found. 
     */
    deactivate_labels();

    ctxp = __pmHandleToPtr(pmWhichContext());
    assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
    PM_UNLOCK(ctxp->c_lock);

    /* Prepare the JSON for the new label. */
    pmsprintf(buf, sizeof(buf), "{%s:%s}",
	      current_label_name, current_label_value);

    hcp = &ctxp->c_archctl->ac_log->hashindom;
    for (node = __pmHashWalk(hcp, PM_HASH_WALK_START);
	 node != NULL;
	 node = __pmHashWalk(hcp, PM_HASH_WALK_NEXT)) {
	if (pmInDom_domain(node->key) != pmInDom_domain(indom))
	    continue;
	if (! current_star_indom && 
	    pmInDom_serial(node->key) != pmInDom_serial(indom))
	    continue;

	/*
	 * A metric in this indom exists.
	 * Add the new label to the generic label change specs for the
	 * identified indom instances. Search for existing ones first.
	 */
	for (idp = (__pmLogInDom *)node->data; idp != NULL; idp = idp->next) {
	    int indom_ix;
	    for (indom_ix = 0; indom_ix < idp->numinst; ++indom_ix) {
		int instance = idp->instlist[indom_ix];
		if (current_label_instance != -1 && instance != current_label_instance)
		    continue;
		found = 1;
		for (lp = label_root; lp != NULL; lp = lp->l_next) {
		    if (lp->old_type != PM_LABEL_INSTANCES)
			continue;
		    if (pmInDom_domain(lp->old_id) != pmInDom_domain((pmInDom)(node->key)))
			continue;
		    if (pmInDom_serial(lp->old_id) != pmInDom_serial((pmInDom)(node->key)))
			continue;
		    if (lp->old_instance != instance)
			continue;
		    if (lp->old_label == NULL)
			break;
		}

		if (lp == NULL) {
		    pmInDom current_indom =
			pmInDom_build(pmInDom_domain(node->key), pmInDom_serial(node->key));
		    lp = create_label(PM_LABEL_INSTANCES, current_indom,
				      instance, NULL, NULL);
		}

		/* Add the new label to the label change spec. */
		if ((sts = __pmAddLabels(&lp->new_labels, buf, PM_LABEL_INSTANCES)) < 0) {
		    pmsprintf(mess, sizeof(mess),
			      "Unable to add new indom instance label %s: %s",
			      buf, pmErrStr(sts));
		    yyerror(mess);
		}
		lp->new_labels->inst = instance;
		lp->flags |= LABEL_NEW;
	    }
	}

	/* Do we need to look for more indoms? */
	if (! current_star_indom)
	    break;
    }

    /* Did we find any indom instances matching the spec? */
    if (! found) {
	pmsprintf(mess, sizeof(mess),
		  "No matching indom instance for new label %s", buf);
	yywarn(mess);
    }
}



/* Line 189 of yacc.c  */
#line 880 "gram.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_LBRACE = 258,
     TOK_RBRACE = 259,
     TOK_PLUS = 260,
     TOK_MINUS = 261,
     TOK_COLON = 262,
     TOK_COMMA = 263,
     TOK_LPAREN = 264,
     TOK_RPAREN = 265,
     TOK_ASSIGN = 266,
     TOK_GLOBAL = 267,
     TOK_INDOM = 268,
     TOK_DUPLICATE = 269,
     TOK_METRIC = 270,
     TOK_HOSTNAME = 271,
     TOK_TIMEZONE = 272,
     TOK_ZONEINFO = 273,
     TOK_FEATURES = 274,
     TOK_TIME = 275,
     TOK_NAME = 276,
     TOK_INST = 277,
     TOK_INAME = 278,
     TOK_DELETE = 279,
     TOK_REDACT = 280,
     TOK_REPLACE = 281,
     TOK_PMID = 282,
     TOK_NULL_INT = 283,
     TOK_TYPE = 284,
     TOK_IF = 285,
     TOK_SEM = 286,
     TOK_UNITS = 287,
     TOK_METRIC_VALUE = 288,
     TOK_OUTPUT = 289,
     TOK_RESCALE = 290,
     TOK_TEXT = 291,
     TOK_ONELINE = 292,
     TOK_HELP = 293,
     TOK_TEXT_STAR = 294,
     TOK_LABEL = 295,
     TOK_CONTEXT = 296,
     TOK_LABEL_STAR = 297,
     TOK_DOMAIN = 298,
     TOK_CLUSTER = 299,
     TOK_ITEM = 300,
     TOK_INSTANCES = 301,
     TOK_INSTANCE = 302,
     TOK_NEW = 303,
     TOK_VALUE = 304,
     TOK_BITS = 305,
     TOK_GNAME = 306,
     TOK_NUMBER = 307,
     TOK_STRING = 308,
     TOK_TEXT_STRING = 309,
     TOK_HNAME = 310,
     TOK_FLOAT = 311,
     TOK_PATTERN = 312,
     TOK_JSON_STRING = 313,
     TOK_JSON_NUMBER = 314,
     TOK_JSON_TRUE = 315,
     TOK_JSON_FALSE = 316,
     TOK_JSON_NULL = 317,
     TOK_INDOM_STAR = 318,
     TOK_PMID_INT = 319,
     TOK_PMID_STAR = 320,
     TOK_TYPE_NAME = 321,
     TOK_SEM_NAME = 322,
     TOK_SPACE_NAME = 323,
     TOK_TIME_NAME = 324,
     TOK_COUNT_NAME = 325,
     TOK_OUTPUT_TYPE = 326
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 823 "gram.y"

    char		*str;
    int			ival;
    unsigned int	uival;
    double		dval;
    pmInDom		indom;
    pmID		pmid;



/* Line 214 of yacc.c  */
#line 998 "gram.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1010 "gram.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  41
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   362

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  72
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  93
/* YYNRULES -- Number of rules.  */
#define YYNRULES  262
/* YYNRULES -- Number of states.  */
#define YYNSTATES  376

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   326

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    16,    18,
      20,    25,    29,    31,    34,    38,    42,    46,    50,    54,
      57,    59,    62,    64,    67,    69,    72,    74,    77,    79,
      81,    86,    90,    93,    95,    97,   101,   103,   105,   107,
     109,   111,   114,   117,   119,   121,   123,   126,   129,   131,
     137,   143,   147,   151,   153,   155,   156,   163,   165,   167,
     169,   171,   172,   174,   177,   182,   187,   192,   195,   201,
     206,   211,   214,   216,   220,   223,   225,   229,   232,   234,
     239,   243,   246,   248,   249,   250,   257,   259,   261,   263,
     265,   267,   269,   270,   272,   275,   279,   283,   287,   293,
     298,   302,   317,   323,   325,   328,   331,   334,   337,   342,
     345,   348,   351,   360,   371,   384,   389,   393,   396,   398,
     399,   401,   403,   407,   411,   414,   416,   417,   419,   420,
     423,   425,   427,   428,   437,   439,   440,   442,   445,   447,
     449,   451,   453,   454,   456,   457,   459,   462,   464,   468,
     472,   474,   476,   478,   480,   482,   484,   485,   494,   496,
     497,   499,   502,   504,   508,   512,   515,   517,   519,   521,
     523,   525,   527,   528,   535,   538,   541,   542,   544,   546,
     548,   550,   551,   553,   555,   557,   559,   561,   564,   566,
     569,   571,   573,   574,   576,   579,   581,   585,   589,   591,
     595,   596,   604,   606,   608,   609,   611,   614,   616,   620,
     624,   628,   630,   631,   639,   641,   643,   645,   646,   648,
     651,   653,   657,   661,   665,   667,   668,   676,   678,   679,
     681,   684,   686,   690,   694,   698,   700,   701,   709,   711,
     712,   714,   717,   719,   723,   727,   731,   733,   734,   742,
     745,   748,   751,   752,   754,   755,   757,   760,   762,   766,
     770,   774,   778
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      73,     0,    -1,    74,    -1,    75,    -1,    75,    74,    -1,
      76,    -1,    87,    -1,    94,    -1,   105,    -1,   124,    -1,
      12,     3,    77,     4,    -1,    12,     3,     4,    -1,    78,
      -1,    78,    77,    -1,    16,    11,    81,    -1,    17,    11,
      53,    -1,    18,    11,    53,    -1,    19,    11,    79,    -1,
      20,    11,    85,    -1,    16,    11,    -1,    16,    -1,    17,
      11,    -1,    17,    -1,    18,    11,    -1,    18,    -1,    19,
      11,    -1,    19,    -1,    20,    11,    -1,    20,    -1,    52,
      -1,    50,     9,    80,    10,    -1,    50,     9,    80,    -1,
      50,     9,    -1,    50,    -1,    52,    -1,    80,     8,    52,
      -1,    55,    -1,    51,    -1,    52,    -1,    56,    -1,    53,
      -1,     5,    52,    -1,     6,    52,    -1,    52,    -1,    52,
      -1,    56,    -1,     5,    86,    -1,     6,    86,    -1,    86,
      -1,    83,     7,    83,     7,    84,    -1,    83,     7,    83,
       7,    83,    -1,    83,     7,    84,    -1,    83,     7,    83,
      -1,    84,    -1,    83,    -1,    -1,    13,    89,    88,     3,
      90,     4,    -1,    13,    -1,    56,    -1,    63,    -1,    91,
      -1,    -1,    92,    -1,    92,    91,    -1,    13,    11,    93,
      89,    -1,    23,    53,    11,    53,    -1,    23,    53,    11,
      24,    -1,    23,    25,    -1,    23,    26,   117,    11,   118,
      -1,    22,    83,    11,    83,    -1,    22,    83,    11,    24,
      -1,    13,    11,    -1,    13,    -1,    23,    53,    11,    -1,
      23,    53,    -1,    23,    -1,    22,    83,    11,    -1,    22,
      83,    -1,    22,    -1,    23,    26,   117,    11,    -1,    23,
      26,   117,    -1,    23,    26,    -1,    14,    -1,    -1,    -1,
      15,    96,    95,     3,    98,     4,    -1,    15,    -1,    97,
      -1,    51,    -1,    64,    -1,    65,    -1,    99,    -1,    -1,
     100,    -1,   100,    99,    -1,    27,    11,    97,    -1,    21,
      11,    51,    -1,    29,    11,    66,    -1,    29,    30,    66,
      11,    66,    -1,    13,    11,   102,   103,    -1,    31,    11,
      67,    -1,    32,    11,    82,     8,    82,     8,    82,     8,
      68,     8,    69,     8,    70,   104,    -1,    33,   101,   117,
      11,   118,    -1,    24,    -1,    27,    11,    -1,    21,    11,
      -1,    29,    11,    -1,    29,    30,    -1,    29,    30,    66,
      11,    -1,    13,    11,    -1,    31,    11,    -1,    32,    11,
      -1,    32,    11,    82,     8,    82,     8,    82,     8,    -1,
      32,    11,    82,     8,    82,     8,    82,     8,    68,     8,
      -1,    32,    11,    82,     8,    82,     8,    82,     8,    68,
       8,    69,     8,    -1,    33,   101,   117,    11,    -1,    33,
     101,   117,    -1,    33,   101,    -1,    26,    -1,    -1,    89,
      -1,    28,    -1,    34,    22,    83,    -1,    34,    23,    53,
      -1,    34,    71,    -1,    34,    -1,    -1,    35,    -1,    -1,
      36,   106,    -1,   107,    -1,   119,    -1,    -1,    15,    96,
     109,   112,   108,     3,   113,     4,    -1,   110,    -1,    -1,
     111,    -1,   111,   110,    -1,    39,    -1,    38,    -1,    37,
      -1,   116,    -1,    -1,   114,    -1,    -1,   115,    -1,   115,
     114,    -1,    24,    -1,    36,    11,   116,    -1,    15,    11,
      97,    -1,    53,    -1,    54,    -1,    57,    -1,    53,    -1,
      53,    -1,    57,    -1,    -1,    13,    89,   109,   112,   120,
       3,   121,     4,    -1,   122,    -1,    -1,   123,    -1,   123,
     122,    -1,    24,    -1,    36,    11,   116,    -1,    13,    11,
      89,    -1,    40,   125,    -1,   126,    -1,   137,    -1,   143,
      -1,   149,    -1,   154,    -1,   159,    -1,    -1,    41,   128,
     127,     3,   133,     4,    -1,   129,   130,    -1,    42,   130,
      -1,    -1,    58,    -1,    53,    -1,   131,    -1,    42,    -1,
      -1,   129,    -1,   132,    -1,    60,    -1,    61,    -1,    62,
      -1,     6,    52,    -1,    52,    -1,     6,    59,    -1,    59,
      -1,   134,    -1,    -1,   135,    -1,   135,   134,    -1,    24,
      -1,    40,    11,   129,    -1,    49,    11,   131,    -1,   136,
      -1,    48,   129,   131,    -1,    -1,    43,   139,   128,   138,
       3,   140,     4,    -1,    52,    -1,   141,    -1,    -1,   142,
      -1,   142,   141,    -1,    24,    -1,    43,    11,    52,    -1,
      40,    11,   129,    -1,    49,    11,   131,    -1,   136,    -1,
      -1,    44,   145,   128,   144,     3,   146,     4,    -1,    56,
      -1,    63,    -1,   147,    -1,    -1,   148,    -1,   148,   147,
      -1,    24,    -1,    44,    11,   145,    -1,    40,    11,   129,
      -1,    49,    11,   131,    -1,   136,    -1,    -1,    45,    96,
     128,   150,     3,   151,     4,    -1,   152,    -1,    -1,   153,
      -1,   153,   152,    -1,    24,    -1,    45,    11,    97,    -1,
      40,    11,   129,    -1,    49,    11,   131,    -1,   136,    -1,
      -1,    13,    89,   128,   155,     3,   156,     4,    -1,   157,
      -1,    -1,   158,    -1,   158,   157,    -1,    24,    -1,    13,
      11,    89,    -1,    40,    11,   129,    -1,    49,    11,   131,
      -1,   136,    -1,    -1,    46,    89,   161,   160,     3,   162,
       4,    -1,    53,   128,    -1,    52,   128,    -1,    42,   128,
      -1,    -1,   163,    -1,    -1,   164,    -1,   164,   163,    -1,
      24,    -1,    46,    11,    89,    -1,    47,    11,    52,    -1,
      40,    11,   129,    -1,    49,    11,   131,    -1,   136,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   901,   901,   904,   905,   908,   909,   910,   911,   912,
     915,   916,   919,   920,   923,   942,   961,   984,  1006,  1022,
    1027,  1032,  1037,  1042,  1047,  1052,  1057,  1062,  1067,  1074,
    1080,  1084,  1089,  1094,  1101,  1112,  1132,  1133,  1134,  1135,
    1136,  1139,  1144,  1149,  1156,  1163,  1170,  1171,  1172,  1175,
    1188,  1200,  1213,  1225,  1234,  1246,  1245,  1278,  1285,  1307,
    1321,  1322,  1325,  1326,  1329,  1354,  1364,  1373,  1381,  1407,
    1415,  1423,  1428,  1433,  1438,  1443,  1448,  1453,  1458,  1463,
    1468,  1473,  1481,  1482,  1486,  1485,  1528,  1535,  1536,  1554,
    1582,  1612,  1613,  1616,  1617,  1620,  1644,  1672,  1700,  1731,
    1805,  1822,  1868,  1906,  1913,  1918,  1923,  1928,  1933,  1938,
    1943,  1948,  1953,  1958,  1963,  1968,  1973,  1978,  1985,  1986,
    1989,  1990,  1996,  2002,  2008,  2012,  2017,  2020,  2022,  2025,
    2028,  2029,  2033,  2032,  2132,  2135,  2138,  2140,  2144,  2146,
    2148,  2152,  2155,  2158,  2160,  2168,  2169,  2172,  2179,  2208,
    2257,  2259,  2263,  2265,  2269,  2271,  2276,  2275,  2368,  2370,
    2378,  2379,  2382,  2389,  2418,  2446,  2449,  2450,  2451,  2452,
    2453,  2454,  2458,  2457,  2512,  2514,  2517,  2523,  2525,  2532,
    2534,  2537,  2540,  2542,  2544,  2546,  2548,  2552,  2557,  2559,
    2564,  2568,  2570,  2575,  2576,  2579,  2586,  2610,  2635,  2640,
    2656,  2655,  2715,  2735,  2737,  2742,  2743,  2746,  2753,  2779,
    2803,  2827,  2834,  2833,  2912,  2935,  2955,  2957,  2962,  2963,
    2966,  2973,  2999,  3022,  3045,  3052,  3051,  3141,  3143,  3148,
    3149,  3152,  3159,  3187,  3210,  3233,  3240,  3239,  3322,  3324,
    3329,  3330,  3333,  3340,  3366,  3389,  3412,  3419,  3418,  3503,
    3508,  3514,  3520,  3528,  3530,  3535,  3536,  3539,  3546,  3572,
    3597,  3620,  3643
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_LBRACE", "TOK_RBRACE", "TOK_PLUS",
  "TOK_MINUS", "TOK_COLON", "TOK_COMMA", "TOK_LPAREN", "TOK_RPAREN",
  "TOK_ASSIGN", "TOK_GLOBAL", "TOK_INDOM", "TOK_DUPLICATE", "TOK_METRIC",
  "TOK_HOSTNAME", "TOK_TIMEZONE", "TOK_ZONEINFO", "TOK_FEATURES",
  "TOK_TIME", "TOK_NAME", "TOK_INST", "TOK_INAME", "TOK_DELETE",
  "TOK_REDACT", "TOK_REPLACE", "TOK_PMID", "TOK_NULL_INT", "TOK_TYPE",
  "TOK_IF", "TOK_SEM", "TOK_UNITS", "TOK_METRIC_VALUE", "TOK_OUTPUT",
  "TOK_RESCALE", "TOK_TEXT", "TOK_ONELINE", "TOK_HELP", "TOK_TEXT_STAR",
  "TOK_LABEL", "TOK_CONTEXT", "TOK_LABEL_STAR", "TOK_DOMAIN",
  "TOK_CLUSTER", "TOK_ITEM", "TOK_INSTANCES", "TOK_INSTANCE", "TOK_NEW",
  "TOK_VALUE", "TOK_BITS", "TOK_GNAME", "TOK_NUMBER", "TOK_STRING",
  "TOK_TEXT_STRING", "TOK_HNAME", "TOK_FLOAT", "TOK_PATTERN",
  "TOK_JSON_STRING", "TOK_JSON_NUMBER", "TOK_JSON_TRUE", "TOK_JSON_FALSE",
  "TOK_JSON_NULL", "TOK_INDOM_STAR", "TOK_PMID_INT", "TOK_PMID_STAR",
  "TOK_TYPE_NAME", "TOK_SEM_NAME", "TOK_SPACE_NAME", "TOK_TIME_NAME",
  "TOK_COUNT_NAME", "TOK_OUTPUT_TYPE", "$accept", "config", "speclist",
  "spec", "globalspec", "globaloptlist", "globalopt", "feature_bits",
  "bits_list", "hname", "signnumber", "number", "float", "signtime",
  "time", "indomspec", "$@1", "indom_int", "optindomopt", "indomoptlist",
  "indomopt", "duplicateopt", "metricspec", "$@2", "pmid_or_name",
  "pmid_int", "optmetricoptlist", "metricoptlist", "metricopt",
  "optreplace", "null_or_indom", "pick", "rescaleopt", "textspec",
  "textmetricorindomspec", "textmetricspec", "$@3", "opttexttypes",
  "texttypes", "texttype", "opttextvalue", "opttextmetricoptlist",
  "textmetricoptlist", "textmetricopt", "textstring", "pattern",
  "replacement", "textindomspec", "$@4", "opttextindomoptlist",
  "textindomoptlist", "textindomopt", "labelspec",
  "labelcontextormetricorindomspec", "labelcontextspec", "$@5",
  "optlabeldetails", "jsonname", "optlabelvalue", "jsonvalue",
  "jsonnumber", "optlabelcontextoptlist", "labelcontextoptlist",
  "labelcontextopt", "newlabelspec", "labeldomainspec", "$@6",
  "pmid_domain", "optlabeldomainoptlist", "labeldomainoptlist",
  "labeldomainopt", "labelclusterspec", "$@7", "pmid_cluster",
  "optlabelclusteroptlist", "labelclusteroptlist", "labelclusteropt",
  "labelitemspec", "$@8", "optlabelitemoptlist", "labelitemoptlist",
  "labelitemopt", "labelindomspec", "$@9", "optlabelindomoptlist",
  "labelindomoptlist", "labelindomopt", "labelinstancesspec", "$@10",
  "optinstancelabeldetails", "optlabelinstancesoptlist",
  "labelinstancesoptlist", "labelinstancesopt", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    72,    73,    74,    74,    75,    75,    75,    75,    75,
      76,    76,    77,    77,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    79,
      79,    79,    79,    79,    80,    80,    81,    81,    81,    81,
      81,    82,    82,    82,    83,    84,    85,    85,    85,    86,
      86,    86,    86,    86,    86,    88,    87,    87,    89,    89,
      90,    90,    91,    91,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    93,    93,    95,    94,    94,    96,    96,    97,
      97,    98,    98,    99,    99,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   101,   101,
     102,   102,   103,   103,   103,   103,   103,   104,   104,   105,
     106,   106,   108,   107,   109,   109,   110,   110,   111,   111,
     111,   112,   112,   113,   113,   114,   114,   115,   115,   115,
     116,   116,   117,   117,   118,   118,   120,   119,   121,   121,
     122,   122,   123,   123,   123,   124,   125,   125,   125,   125,
     125,   125,   127,   126,   128,   128,   128,   129,   129,   130,
     130,   130,   131,   131,   131,   131,   131,   132,   132,   132,
     132,   133,   133,   134,   134,   135,   135,   135,   135,   136,
     138,   137,   139,   140,   140,   141,   141,   142,   142,   142,
     142,   142,   144,   143,   145,   145,   146,   146,   147,   147,
     148,   148,   148,   148,   148,   150,   149,   151,   151,   152,
     152,   153,   153,   153,   153,   153,   155,   154,   156,   156,
     157,   157,   158,   158,   158,   158,   158,   160,   159,   161,
     161,   161,   161,   162,   162,   163,   163,   164,   164,   164,
     164,   164,   164
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       4,     3,     1,     2,     3,     3,     3,     3,     3,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     1,
       4,     3,     2,     1,     1,     3,     1,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     2,     2,     1,     5,
       5,     3,     3,     1,     1,     0,     6,     1,     1,     1,
       1,     0,     1,     2,     4,     4,     4,     2,     5,     4,
       4,     2,     1,     3,     2,     1,     3,     2,     1,     4,
       3,     2,     1,     0,     0,     6,     1,     1,     1,     1,
       1,     1,     0,     1,     2,     3,     3,     3,     5,     4,
       3,    14,     5,     1,     2,     2,     2,     2,     4,     2,
       2,     2,     8,    10,    12,     4,     3,     2,     1,     0,
       1,     1,     3,     3,     2,     1,     0,     1,     0,     2,
       1,     1,     0,     8,     1,     0,     1,     2,     1,     1,
       1,     1,     0,     1,     0,     1,     2,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     0,     8,     1,     0,
       1,     2,     1,     3,     3,     2,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     2,     0,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     1,     0,     1,     2,     1,     3,     3,     1,     3,
       0,     7,     1,     1,     0,     1,     2,     1,     3,     3,
       3,     1,     0,     7,     1,     1,     1,     0,     1,     2,
       1,     3,     3,     3,     1,     0,     7,     1,     0,     1,
       2,     1,     3,     3,     3,     1,     0,     7,     1,     0,
       1,     2,     1,     3,     3,     3,     1,     0,     7,     2,
       2,     2,     0,     1,     0,     1,     2,     1,     3,     3,
       3,     3,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,    57,    86,     0,     0,     0,     2,     3,     5,
       6,     7,     8,     9,     0,    58,    59,    55,    88,    89,
      90,    84,    87,     0,     0,   129,   130,   131,     0,   176,
       0,     0,     0,     0,   165,   166,   167,   168,   169,   170,
     171,     1,     4,    11,    20,    22,    24,    26,    28,     0,
      12,     0,     0,   135,   135,   176,   181,   178,   177,   172,
     181,   202,   176,   214,   215,   176,   176,   252,    19,    21,
      23,    25,    27,    10,    13,    61,    92,   140,   139,   138,
     142,   134,   136,   142,   236,     0,   180,   188,   190,   184,
     185,   186,   182,   175,   179,   183,     0,   174,   200,   212,
     225,   176,   176,   176,   247,    37,    38,    40,    36,    39,
      14,    15,    16,    33,    29,    17,     0,     0,    44,    45,
      54,    53,    18,    48,    72,    78,    75,     0,    60,    62,
       0,     0,   103,     0,     0,     0,     0,   119,     0,    91,
      93,   150,   151,   156,   141,   137,   132,     0,   187,   189,
     192,     0,     0,     0,   251,   250,   249,     0,    32,    46,
      47,     0,    71,    77,    67,    81,    74,    56,    63,   109,
     105,   104,   106,   107,   110,   111,   118,   117,    85,    94,
       0,     0,   239,   195,     0,     0,     0,     0,   191,   193,
     198,   204,   217,   228,   254,    34,    31,    52,    51,    82,
       0,    76,   153,   152,    80,    73,   121,   120,   126,    96,
      95,    97,     0,   100,     0,     0,    43,     0,   116,   159,
     144,     0,   242,     0,     0,   246,     0,   238,   240,     0,
       0,     0,   173,   194,   207,     0,     0,     0,   211,     0,
     203,   205,   220,     0,     0,     0,   224,     0,   216,   218,
     231,     0,     0,     0,   235,     0,   227,   229,   257,     0,
       0,     0,     0,   262,     0,   253,   255,     0,    30,     0,
      64,    70,    69,    79,    66,    65,   125,    99,   108,    41,
      42,     0,   115,     0,   162,     0,     0,   158,   160,     0,
     147,     0,     0,   143,   145,     0,     0,     0,   237,   241,
     196,   199,   197,     0,     0,     0,   201,   206,     0,     0,
       0,   213,   219,     0,     0,     0,   226,   230,     0,     0,
       0,     0,   248,   256,    35,    50,    49,   154,   155,    68,
       0,     0,   124,    98,     0,   102,     0,     0,   157,   161,
       0,     0,   133,   146,   243,   244,   245,   209,   208,   210,
     222,   221,   223,   233,   232,   234,   260,   258,   259,   261,
     122,   123,     0,   164,   163,   149,   148,     0,   112,     0,
     113,     0,   114,   128,   127,   101
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     6,     7,     8,     9,    49,    50,   115,   196,   110,
     217,   120,   121,   122,   123,    10,    51,    17,   127,   128,
     129,   200,    11,    52,    21,    22,   138,   139,   140,   177,
     208,   277,   375,    12,    25,    26,   181,    80,    81,    82,
     143,   292,   293,   294,   144,   204,   329,    27,   180,   286,
     287,   288,    13,    34,    35,    96,    59,    92,    93,    94,
      95,   187,   188,   189,   190,    36,   151,    62,   239,   240,
     241,    37,   152,    65,   247,   248,   249,    38,   153,   255,
     256,   257,    39,   147,   226,   227,   228,    40,   157,   104,
     264,   265,   266
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -276
static const yytype_int16 yypact[] =
{
      98,    82,    32,    65,   148,    79,   127,  -276,    98,  -276,
    -276,  -276,  -276,  -276,   177,  -276,  -276,  -276,  -276,  -276,
    -276,  -276,  -276,    32,    65,  -276,  -276,  -276,    32,   -17,
     117,    58,    65,    32,  -276,  -276,  -276,  -276,  -276,  -276,
    -276,  -276,  -276,  -276,   139,   171,   176,   178,   196,   174,
     193,   212,   216,   167,   167,   -17,     1,  -276,  -276,  -276,
       1,  -276,   -17,  -276,  -276,   -17,   -17,    30,   147,   168,
     169,    85,    25,  -276,  -276,    67,   159,  -276,  -276,  -276,
      46,  -276,   167,    46,  -276,    99,  -276,  -276,  -276,  -276,
    -276,  -276,  -276,  -276,  -276,  -276,   217,  -276,  -276,  -276,
    -276,   -17,   -17,   -17,  -276,  -276,  -276,  -276,  -276,  -276,
    -276,  -276,  -276,   214,  -276,  -276,   -24,   -24,  -276,  -276,
     218,  -276,  -276,  -276,   213,   175,    41,   222,  -276,    67,
     219,   220,  -276,   221,    35,   223,   224,   202,   225,  -276,
     159,  -276,  -276,  -276,  -276,  -276,  -276,   230,  -276,  -276,
     136,   233,   234,   235,  -276,  -276,  -276,   236,   188,  -276,
    -276,   -24,    -6,   231,  -276,   122,   232,  -276,  -276,   -11,
     190,     6,   179,   180,   181,    17,  -276,   122,  -276,  -276,
     241,   244,     0,  -276,   238,    73,   239,   247,  -276,   136,
    -276,   119,   104,   125,    93,  -276,   156,   245,  -276,  -276,
      32,   -10,  -276,  -276,   242,     5,  -276,  -276,   226,  -276,
    -276,  -276,   243,  -276,   203,   204,  -276,   249,   248,    20,
      11,   250,  -276,   251,   252,  -276,   254,  -276,     0,    73,
      45,    45,  -276,  -276,  -276,   253,   255,   256,  -276,   261,
    -276,   119,  -276,   258,   259,   260,  -276,   269,  -276,   104,
    -276,   263,   265,   266,  -276,   274,  -276,   125,  -276,   268,
     270,   271,   272,  -276,   280,  -276,    93,   237,  -276,   -24,
    -276,  -276,  -276,   161,  -276,  -276,    -7,  -276,   227,  -276,
    -276,    17,   161,   275,  -276,   276,   284,  -276,    20,   281,
    -276,   283,   287,  -276,    11,    32,    73,    45,  -276,  -276,
    -276,  -276,  -276,    73,   246,    45,  -276,  -276,    73,    58,
      45,  -276,  -276,    73,     6,    45,  -276,  -276,    73,    32,
     257,    45,  -276,  -276,  -276,  -276,  -276,  -276,  -276,  -276,
     175,   262,  -276,  -276,   289,  -276,    32,    46,  -276,  -276,
       6,    46,  -276,  -276,  -276,  -276,  -276,  -276,  -276,  -276,
    -276,  -276,  -276,  -276,  -276,  -276,  -276,  -276,  -276,  -276,
    -276,  -276,    17,  -276,  -276,  -276,  -276,   291,   240,   292,
     264,   293,   267,   277,  -276,  -276
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -276,  -276,   294,  -276,  -276,   273,  -276,  -276,  -276,  -276,
    -275,  -122,  -157,  -276,   100,  -276,  -276,   -23,  -276,   166,
    -276,  -276,  -276,  -276,    77,  -169,  -276,   163,  -276,  -276,
    -276,  -276,  -276,  -276,  -276,  -276,  -276,   278,   228,  -276,
     279,  -276,    10,  -276,  -205,   128,    24,  -276,  -276,  -276,
      19,  -276,  -276,  -276,  -276,  -276,    53,   -28,   282,  -219,
    -276,  -276,   129,  -276,  -173,  -276,  -276,  -276,  -276,    70,
    -276,  -276,  -276,     7,  -276,    68,  -276,  -276,  -276,  -276,
      57,  -276,  -276,  -276,  -276,    91,  -276,  -276,  -276,  -276,
    -276,    54,  -276
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -84
static const yytype_int16 yytable[] =
{
      53,    60,   210,   163,   198,    55,   334,    85,   199,   225,
      67,   301,   302,   221,   271,   330,   331,   206,   238,   246,
     254,   263,   214,   215,   222,    56,   289,    60,   118,   274,
     116,   117,   119,   283,    60,   290,    57,    60,    60,   197,
     223,    58,   118,    86,   284,    15,   172,   291,   185,   224,
     -83,    85,    16,    87,    57,   225,   285,   -83,   275,    58,
      88,    89,    90,    91,   332,   173,   164,   165,   238,   216,
      19,    20,   101,    60,    60,    60,   246,   118,   346,   272,
     124,   119,   102,   103,   254,    14,   349,   367,    15,   125,
     126,   352,    28,   263,   166,    16,   355,    87,    57,   141,
     142,    54,   359,    58,    88,    89,    90,    91,    84,    66,
       1,     2,   326,     3,    63,    98,    18,   258,    99,   100,
      29,    64,    30,    31,    32,    33,    57,    41,   242,    19,
      20,    58,   364,   259,     4,   113,   366,   114,     5,   260,
     261,   185,   262,   234,   243,   354,   207,   325,   244,   250,
      68,   148,   185,   245,   154,   155,   156,   230,   149,   235,
     183,    23,   236,    24,   267,   251,   268,   185,   237,    61,
     252,   365,   130,   185,   253,   202,   184,   270,    73,   203,
     131,    43,    69,   132,   185,   186,   133,    70,   134,    71,
     135,   136,   137,    44,    45,    46,    47,    48,   105,   106,
     107,   300,   108,   109,    77,    78,    79,    72,   360,    44,
      45,    46,    47,    48,   327,    75,   159,   160,   328,    76,
     150,   111,   112,   158,   162,   161,   167,   118,   176,   178,
     169,   170,   171,   182,   174,   175,   191,   192,   193,   194,
     195,   209,   201,   205,   219,   211,   212,   220,   213,   229,
     231,   232,   269,   273,   278,   279,   280,   281,   298,   282,
     276,   295,   296,   297,   303,   306,   304,   305,   345,   308,
     309,   310,   344,   311,   313,   347,   314,   315,   316,   318,
     350,   319,   320,   321,   322,   353,   336,   337,   338,   324,
     356,   342,   340,   333,   341,   168,   357,   362,   348,   368,
     370,   372,    42,   179,   343,   218,   335,   339,   369,   358,
     145,   307,   374,   363,   317,   361,   351,   312,   233,   299,
     323,     0,     0,    74,     0,     0,     0,     0,     0,     0,
       0,     0,    83,   371,     0,     0,     0,   373,     0,     0,
       0,     0,    97,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   146
};

static const yytype_int16 yycheck[] =
{
      23,    29,   171,   125,   161,    28,   281,     6,    14,   182,
      33,   230,   231,    13,    24,    22,    23,    28,   191,   192,
     193,   194,     5,     6,    24,    42,    15,    55,    52,    24,
       5,     6,    56,    13,    62,    24,    53,    65,    66,   161,
      40,    58,    52,    42,    24,    56,    11,    36,    48,    49,
      56,     6,    63,    52,    53,   228,    36,    63,    53,    58,
      59,    60,    61,    62,    71,    30,    25,    26,   241,    52,
      64,    65,    42,   101,   102,   103,   249,    52,   297,   201,
      13,    56,    52,    53,   257,     3,   305,   362,    56,    22,
      23,   310,    13,   266,    53,    63,   315,    52,    53,    53,
      54,    24,   321,    58,    59,    60,    61,    62,    55,    32,
      12,    13,   269,    15,    56,    62,    51,    24,    65,    66,
      41,    63,    43,    44,    45,    46,    53,     0,    24,    64,
      65,    58,   337,    40,    36,    50,   341,    52,    40,    46,
      47,    48,    49,    24,    40,   314,   169,   269,    44,    24,
      11,    52,    48,    49,   101,   102,   103,   185,    59,    40,
      24,    13,    43,    15,     8,    40,    10,    48,    49,    52,
      45,   340,    13,    48,    49,    53,    40,   200,     4,    57,
      21,     4,    11,    24,    48,    49,    27,    11,    29,    11,
      31,    32,    33,    16,    17,    18,    19,    20,    51,    52,
      53,   229,    55,    56,    37,    38,    39,    11,   330,    16,
      17,    18,    19,    20,    53,     3,   116,   117,    57,     3,
       3,    53,    53,     9,    11,     7,     4,    52,    26,     4,
      11,    11,    11,     3,    11,    11,     3,     3,     3,     3,
      52,    51,    11,    11,     3,    66,    66,     3,    67,    11,
      11,     4,     7,    11,    11,    52,    52,     8,     4,    11,
      34,    11,    11,    11,    11,     4,    11,    11,   296,    11,
      11,    11,   295,     4,    11,   303,    11,    11,     4,    11,
     308,    11,    11,    11,     4,   313,    11,    11,     4,    52,
     318,     4,    11,    66,    11,   129,   319,     8,    52,     8,
       8,     8,     8,   140,   294,   177,   282,   288,    68,    52,
      82,   241,    35,   336,   257,    53,   309,   249,   189,   228,
     266,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,    69,    -1,    -1,    -1,    70,    -1,    -1,
      -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    83
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    12,    13,    15,    36,    40,    73,    74,    75,    76,
      87,    94,   105,   124,     3,    56,    63,    89,    51,    64,
      65,    96,    97,    13,    15,   106,   107,   119,    13,    41,
      43,    44,    45,    46,   125,   126,   137,   143,   149,   154,
     159,     0,    74,     4,    16,    17,    18,    19,    20,    77,
      78,    88,    95,    89,    96,    89,    42,    53,    58,   128,
     129,    52,   139,    56,    63,   145,    96,    89,    11,    11,
      11,    11,    11,     4,    77,     3,     3,    37,    38,    39,
     109,   110,   111,   109,   128,     6,    42,    52,    59,    60,
      61,    62,   129,   130,   131,   132,   127,   130,   128,   128,
     128,    42,    52,    53,   161,    51,    52,    53,    55,    56,
      81,    53,    53,    50,    52,    79,     5,     6,    52,    56,
      83,    84,    85,    86,    13,    22,    23,    90,    91,    92,
      13,    21,    24,    27,    29,    31,    32,    33,    98,    99,
     100,    53,    54,   112,   116,   110,   112,   155,    52,    59,
       3,   138,   144,   150,   128,   128,   128,   160,     9,    86,
      86,     7,    11,    83,    25,    26,    53,     4,    91,    11,
      11,    11,    11,    30,    11,    11,    26,   101,     4,    99,
     120,   108,     3,    24,    40,    48,    49,   133,   134,   135,
     136,     3,     3,     3,     3,    52,    80,    83,    84,    14,
      93,    11,    53,    57,   117,    11,    28,    89,   102,    51,
      97,    66,    66,    67,     5,     6,    52,    82,   117,     3,
       3,    13,    24,    40,    49,   136,   156,   157,   158,    11,
     129,    11,     4,   134,    24,    40,    43,    49,   136,   140,
     141,   142,    24,    40,    44,    49,   136,   146,   147,   148,
      24,    40,    45,    49,   136,   151,   152,   153,    24,    40,
      46,    47,    49,   136,   162,   163,   164,     8,    10,     7,
      89,    24,    83,    11,    24,    53,    34,   103,    11,    52,
      52,     8,    11,    13,    24,    36,   121,   122,   123,    15,
      24,    36,   113,   114,   115,    11,    11,    11,     4,   157,
     129,   131,   131,    11,    11,    11,     4,   141,    11,    11,
      11,     4,   147,    11,    11,    11,     4,   152,    11,    11,
      11,    11,     4,   163,    52,    83,    84,    53,    57,   118,
      22,    23,    71,    66,    82,   118,    11,    11,     4,   122,
      11,    11,     4,   114,    89,   129,   131,   129,    52,   131,
     129,   145,   131,   129,    97,   131,   129,    89,    52,   131,
      83,    53,     8,    89,   116,    97,   116,    82,     8,    68,
       8,    69,     8,    70,    35,   104
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 14:

/* Line 1455 of yacc.c  */
#line 924 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_HOSTNAME) {
			    pmsprintf(mess, sizeof(mess), "Duplicate global hostname clause");
			    yyerror(mess);
			}
			if (inarch.label.hostname != NULL && strcmp(inarch.label.hostname, (yyvsp[(3) - (3)].str)) == 0) {
			    /* no change ... */
			    if (wflag) {
				pmsprintf(mess, sizeof(mess), "Global hostname (%s): No change", inarch.label.hostname);
				yywarn(mess);
			    }
			    free((yyvsp[(3) - (3)].str));
			}
			else {
			    global.hostname = (yyvsp[(3) - (3)].str);
			    global.flags |= GLOBAL_CHANGE_HOSTNAME;
			}
		    ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 943 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_TIMEZONE) {
			    pmsprintf(mess, sizeof(mess), "Duplicate global timezone clause");
			    yyerror(mess);
			}
			if (inarch.label.timezone != NULL && strcmp(inarch.label.timezone, (yyvsp[(3) - (3)].str)) == 0) {
			    /* no change ... */
			    if (wflag) {
				pmsprintf(mess, sizeof(mess), "Global timezone (%s): No change", inarch.label.timezone);
				yywarn(mess);
			    }
			    free((yyvsp[(3) - (3)].str));
			}
			else {
			    global.timezone =  (yyvsp[(3) - (3)].str);
			    global.flags |= GLOBAL_CHANGE_TIMEZONE;
			}
		    ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 962 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_ZONEINFO) {
			    pmsprintf(mess, sizeof(mess), "Duplicate global zoneinfo clause");
			    yyerror(mess);
			}
			if (outarch.version < PM_LOG_VERS03) {
			    pmsprintf(mess, sizeof(mess), "Global zoneinfo clause requires output archive version of 3 or greater");
			    yyerror(mess);
			}
			if (inarch.label.zoneinfo != NULL && strcmp(inarch.label.zoneinfo, (yyvsp[(3) - (3)].str)) == 0) {
			    /* no change ... */
			    if (wflag) {
				pmsprintf(mess, sizeof(mess), "Global zoneinfo (%s): No change", inarch.label.zoneinfo);
				yywarn(mess);
			    }
			    free((yyvsp[(3) - (3)].str));
			}
			else {
			    global.zoneinfo = (yyvsp[(3) - (3)].str);
			    global.flags |= GLOBAL_CHANGE_ZONEINFO;
			}
		    ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 985 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_FEATURES) {
			    pmsprintf(mess, sizeof(mess), "Duplicate global features clause");
			    yyerror(mess);
			}
			if (outarch.version < PM_LOG_VERS03) {
			    pmsprintf(mess, sizeof(mess), "Global features clause requires output archive version of 3 or greater");
			    yyerror(mess);
			}
			if (inarch.label.features == (yyvsp[(3) - (3)].uival)) {
			    /* no change ... */
			    if (wflag) {
				pmsprintf(mess, sizeof(mess), "Global features (%d): No change", inarch.label.features);
				yywarn(mess);
			    }
			}
			else {
			    global.features = (yyvsp[(3) - (3)].uival);
			    global.flags |= GLOBAL_CHANGE_FEATURES;
			}
		    ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 1007 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_TIME) {
			    pmsprintf(mess, sizeof(mess), "Duplicate global time clause");
			    yyerror(mess);
			}
			if (global.time.sec == 0 && global.time.nsec == 0) {
			    /* no change ... */
			    if (wflag) {
				pmsprintf(mess, sizeof(mess), "Global time: No change");
				yywarn(mess);
			    }
			}
			else
			    global.flags |= GLOBAL_CHANGE_TIME;
		    ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 1023 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <hostname> in hostname clause");
			yyerror(mess);
		    ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 1028 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in hostname clause");
			yyerror(mess);
		    ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 1033 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <timezone_string> in timezone clause");
			yyerror(mess);
		    ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 1038 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in timezone clause");
			yyerror(mess);
		    ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 1043 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <zoneinfo_string> in zoneinfo clause");
			yyerror(mess);
		    ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 1048 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in zoneinfo clause");
			yyerror(mess);
		    ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 1053 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <features_value> in features clause");
			yyerror(mess);
		    ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 1058 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in features clause");
			yyerror(mess);
		    ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 1063 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <delta> of the form [+-][HH:[MM:]]SS[.d...] in time clause");
			yyerror(mess);
		    ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 1068 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in time clause");
			yyerror(mess);
		    ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 1075 "gram.y"
    {
			char	*q;
			(yyval.uival) = (unsigned int)strtoul((yyvsp[(1) - (1)].str), &q, 10);
			free((yyvsp[(1) - (1)].str));
		    ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 1081 "gram.y"
    {
			(yyval.uival) = (yyvsp[(3) - (4)].uival);
		    ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 1085 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting ) after \"bits(\" in features clause");
			yyerror(mess);
		    ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 1090 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <list_of_bit_numbers> after \"bits(\" in features clause");
			yyerror(mess);
		    ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 1095 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting ( after \"bits\" in features clause");
			yyerror(mess);
		    ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 1102 "gram.y"
    {
			int	b;
			b = atoi((yyvsp[(1) - (1)].str));
			if (b < 0 || b > 31) {
			    pmsprintf(mess, sizeof(mess), "Bit \"%s\" not in the range 0..31", (yyvsp[(1) - (1)].str));
			    yyerror(mess);
			}
			(yyval.uival) = (unsigned int)1 << b;
			free((yyvsp[(1) - (1)].str));
		    ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 1113 "gram.y"
    {
			int	b;
			b = atoi((yyvsp[(3) - (3)].str));
			if (b < 0 || b > 31) {
			    pmsprintf(mess, sizeof(mess), "Bit \"%s\" not in the range 0..31", (yyvsp[(3) - (3)].str));
			    yyerror(mess);
			}
			(yyval.uival) = (unsigned int)(yyvsp[(1) - (3)].uival) | ((unsigned int)1 << b);
			free((yyvsp[(3) - (3)].str));
		    ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 1140 "gram.y"
    {
			(yyval.ival) = atoi((yyvsp[(2) - (2)].str));
			free((yyvsp[(2) - (2)].str));
		    ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 1145 "gram.y"
    {
			(yyval.ival) = -atoi((yyvsp[(2) - (2)].str));
			free((yyvsp[(2) - (2)].str));
		    ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 1150 "gram.y"
    {
			(yyval.ival) = atoi((yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
		    ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 1157 "gram.y"
    {
			(yyval.ival) = atoi((yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
		    ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 1164 "gram.y"
    {
			(yyval.dval) = atof((yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
		    ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 1171 "gram.y"
    { global.time.sec = -global.time.sec; ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 1176 "gram.y"
    { 
			if ((yyvsp[(3) - (5)].ival) > 59) {
			    pmsprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(3) - (5)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(5) - (5)].dval) > 59) {
			    pmsprintf(mess, sizeof(mess), "Seconds (%.6f) in time clause more than 59", (yyvsp[(5) - (5)].dval));
			    yywarn(mess);
			}
			global.time.sec = (yyvsp[(1) - (5)].ival) * 3600 + (yyvsp[(3) - (5)].ival) * 60 + (int)(yyvsp[(5) - (5)].dval);
			global.time.nsec = (int)(1000000000*(((yyvsp[(5) - (5)].dval) - (int)(yyvsp[(5) - (5)].dval)))+0.5);
		    ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 1189 "gram.y"
    { 
			if ((yyvsp[(3) - (5)].ival) > 59) {
			    pmsprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(3) - (5)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(5) - (5)].ival) > 59) {
			    pmsprintf(mess, sizeof(mess), "Seconds (%d) in time clause more than 59", (yyvsp[(5) - (5)].ival));
			    yywarn(mess);
			}
			global.time.sec = (yyvsp[(1) - (5)].ival) * 3600 + (yyvsp[(3) - (5)].ival) * 60 + (yyvsp[(5) - (5)].ival);
		    ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 1201 "gram.y"
    { 
			if ((yyvsp[(1) - (3)].ival) > 59) {
			    pmsprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(1) - (3)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(3) - (3)].dval) > 59) {
			    pmsprintf(mess, sizeof(mess), "Seconds (%.6f) in time clause more than 59", (yyvsp[(3) - (3)].dval));
			    yywarn(mess);
			}
			global.time.sec = (yyvsp[(1) - (3)].ival) * 60 + (int)(yyvsp[(3) - (3)].dval);
			global.time.nsec = (int)(1000000000*(((yyvsp[(3) - (3)].dval) - (int)(yyvsp[(3) - (3)].dval)))+0.5);
		    ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 1214 "gram.y"
    { 
			if ((yyvsp[(1) - (3)].ival) > 59) {
			    pmsprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(1) - (3)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(3) - (3)].ival) > 59) {
			    pmsprintf(mess, sizeof(mess), "Seconds (%d) in time clause more than 59", (yyvsp[(3) - (3)].ival));
			    yywarn(mess);
			}
			global.time.sec = (yyvsp[(1) - (3)].ival) * 60 + (yyvsp[(3) - (3)].ival);
		    ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 1226 "gram.y"
    {
			if ((yyvsp[(1) - (1)].dval) > 59) {
			    pmsprintf(mess, sizeof(mess), "Seconds (%.6f) in time clause more than 59", (yyvsp[(1) - (1)].dval));
			    yywarn(mess);
			}
			global.time.sec = (int)(yyvsp[(1) - (1)].dval);
			global.time.nsec = (int)(1000000000*(((yyvsp[(1) - (1)].dval) - (int)(yyvsp[(1) - (1)].dval)))+0.5);
		    ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 1235 "gram.y"
    {
			if ((yyvsp[(1) - (1)].ival) > 59) {
			    pmsprintf(mess, sizeof(mess), "Seconds (%d) in time clause more than 59", (yyvsp[(1) - (1)].ival));
			    yywarn(mess);
			}
			global.time.sec = (yyvsp[(1) - (1)].ival);
			global.time.nsec = 0;
		    ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 1246 "gram.y"
    {
			if (current_star_indom) {
			    __pmContext		*ctxp;
			    __pmHashCtl		*hcp;
			    __pmHashNode	*node;

			    ctxp = __pmHandleToPtr(pmWhichContext());
			    assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			    PM_UNLOCK(ctxp->c_lock);
			    hcp = &ctxp->c_archctl->ac_log->hashindom;
			    star_domain = pmInDom_domain((yyvsp[(2) - (2)].indom));
			    for (node = __pmHashWalk(hcp, PM_HASH_WALK_START);
				 node != NULL;
				 node = __pmHashWalk(hcp, PM_HASH_WALK_NEXT)) {
				if (pmInDom_domain((pmInDom)(node->key)) == star_domain)
				    current_indomspec = start_indom((pmInDom)(node->key), 0);
			    }
			    do_walk_indom = 1;
			}
			else {
			    current_indomspec = start_indom((yyvsp[(2) - (2)].indom), 0);
			    do_walk_indom = 0;
			}
		    ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 1279 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <domain>.<serial> or <domain>.* in indom rule");
			yyerror(mess);
		    ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 1286 "gram.y"
    {
			int		domain;
			int		serial;
			int		sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.%d", &domain, &serial);
			if (sts < 2) {
			    pmsprintf(mess, sizeof(mess), "Missing serial field for indom");
			    yyerror(mess);
			}
			if (domain < 1 || domain >= DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Illegal domain field (%d) for indom", domain);
			    yyerror(mess);
			}
			if (serial < 0 || serial >= 4194304) {
			    pmsprintf(mess, sizeof(mess), "Illegal serial field (%d) for indom", serial);
			    yyerror(mess);
			}
			current_star_indom = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.indom) = pmInDom_build(domain, serial);
		    ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1308 "gram.y"
    {
			int		domain;
			sscanf((yyvsp[(1) - (1)].str), "%d.", &domain);
			if (domain < 1 || domain >= DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Illegal domain field (%d) for indom", domain);
			    yyerror(mess);
			}
			current_star_indom = 1;
			free((yyvsp[(1) - (1)].str));
			(yyval.indom) = pmInDom_build(domain, 0);
		    ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1330 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    pmInDom	indom;
			    if (indom_root->new_indom != indom_root->old_indom) {
				pmsprintf(mess, sizeof(mess), "Duplicate indom clause for indom %s", pmInDomStr(indom_root->old_indom));
				yyerror(mess);
			    }
			    if (current_star_indom)
				indom = pmInDom_build(pmInDom_domain((yyvsp[(4) - (4)].indom)), pmInDom_serial(ip->old_indom));
			    else
				indom = (yyvsp[(4) - (4)].indom);
			    if (indom != ip->old_indom)
				ip->new_indom = indom;
			    else {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Instance domain %s: indom: No change", pmInDomStr(ip->old_indom));
				    yywarn(mess);
				}
			    }
			    ip->indom_flags |= (yyvsp[(3) - (4)].ival);
			}
		    ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1355 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_name(ip->old_indom, (yyvsp[(2) - (4)].str), (yyvsp[(4) - (4)].str)) < 0)
				yyerror(mess);
			}
			free((yyvsp[(2) - (4)].str));
			/* Note: $4 referenced from new_iname[] */
		    ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1365 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_name(ip->old_indom, (yyvsp[(2) - (4)].str), NULL) < 0)
			    	yyerror(mess);
			}
			free((yyvsp[(2) - (4)].str));
		    ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1374 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (redact_indom(ip->old_indom) < 0)
			    	yyerror(mess);
			}
		    ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1382 "gram.y"
    {
			int		sts;
			indomspec_t	*ip;
			value_change_t	vc;
			vc.pat = (yyvsp[(3) - (5)].str);
			if (pmDebugOptions.appl5)
			    fprintf(stderr, "compiling iname regex /%s/\n", vc.pat);
			if ((sts = regcomp(&vc.regex, vc.pat, REG_EXTENDED)) != 0) {
			    size_t	pfx;
			    strncat(mess, "regcomp error: ", sizeof(mess)-1);
			    pfx = strlen(mess);
			    regerror(sts, &vc.regex, &mess[pfx], sizeof(mess)-pfx-1);
			    yyerror(mess);
			}
			vc.replace = (yyvsp[(5) - (5)].str);
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (replace_indom(ip->old_indom, &vc) < 0) {
				/* mess[] set in replace_indom() for errors */
			    	yyerror(mess);
			    }
			}
			regfree(&vc.regex);
			free((yyvsp[(3) - (5)].str));
			free((yyvsp[(5) - (5)].str));
		    ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1408 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_inst(ip->old_indom, (yyvsp[(2) - (4)].ival), (yyvsp[(4) - (4)].ival)) < 0)
				yyerror(mess);
			}
		    ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1416 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_inst(ip->old_indom, (yyvsp[(2) - (4)].ival), PM_IN_NULL) < 0)
				yyerror(mess);
			}
		    ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1424 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <domain>.<serial> or <domain>.* in indom clause");
			yyerror(mess);
		    ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1429 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in indom clause");
			yyerror(mess);
		    ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1434 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting new <external_instance_name> or DELETE in iname clause");
			yyerror(mess);
		    ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1439 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in iname clause");
			yyerror(mess);
		    ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1444 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting old <external_instance_name> or REDACT or REPLACE in iname clause");
			yyerror(mess);
		    ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1449 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting new <internal_instance_identifier> or DELETE in inst clause");
			yyerror(mess);
		    ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1454 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in inst clause");
			yyerror(mess);
		    ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1459 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting old <internal_instance_identifier> in inst clause");
			yyerror(mess);
		    ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1464 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <replacement> in iname clause");
			yyerror(mess);
		    ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1469 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in iname clause");
			yyerror(mess);
		    ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1474 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <regular expression> in iname clause");
			yyerror(mess);
		    ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1481 "gram.y"
    { (yyval.ival) = INDOM_DUPLICATE; ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1482 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1486 "gram.y"
    {
			if (current_star_metric) {
			    __pmContext		*ctxp;
			    __pmHashCtl		*hcp;
			    __pmHashNode	*node;

			    ctxp = __pmHandleToPtr(pmWhichContext());
			    assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			    PM_UNLOCK(ctxp->c_lock);
			    hcp = &ctxp->c_archctl->ac_log->hashpmid;
			    star_domain = pmID_domain((yyvsp[(2) - (2)].pmid));
			    if (current_star_metric == 1)
				star_cluster = pmID_cluster((yyvsp[(2) - (2)].pmid));
			    else
				star_cluster = PM_ID_NULL;
			    for (node = __pmHashWalk(hcp, PM_HASH_WALK_START);
				 node != NULL;
				 node = __pmHashWalk(hcp, PM_HASH_WALK_NEXT)) {
				if (pmID_domain((pmID)(node->key)) == star_domain &&
				    (star_cluster == PM_ID_NULL ||
				     star_cluster == pmID_cluster((pmID)(node->key))))
				    current_metricspec = start_metric((pmID)(node->key));
			    }
			    do_walk_metric = 1;
			}
			else {
			    if ((yyvsp[(2) - (2)].pmid) == PM_ID_NULL)
				/* metric not in archive */
				current_metricspec = NULL;
			    else
				current_metricspec = start_metric((yyvsp[(2) - (2)].pmid));
			    do_walk_metric = 0;
			}
		    ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1529 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <metric_name> or <domain>.<cluster>.<item> or <domain>.<cluster>.* or <domain>.*.* in metric rule");
			yyerror(mess);
		    ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1537 "gram.y"
    {
			int	sts;
			pmID	pmid;
			sts = pmLookupName(1, (const char **)&(yyvsp[(1) - (1)].str), &pmid);
			if (sts < 0) {
			    if (wflag) {
				pmsprintf(mess, sizeof(mess), "Metric: %s: %s", (yyvsp[(1) - (1)].str), pmErrStr(sts));
				yywarn(mess);
			    }
			    pmid = PM_ID_NULL;
			}
			current_star_metric = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.pmid) = pmid;
		    ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1555 "gram.y"
    {
			int	domain;
			int	cluster;
			int	item;
			int	sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.%d.%d", &domain, &cluster, &item);
			assert(sts == 3);
			if (domain < 1 || domain > DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Illegal domain field (%d) for pmid", domain);
			    yyerror(mess);
			}
			else if (domain == DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Dynamic metric domain field (%d) for pmid", domain);
			    yywarn(mess);
			}
			if (cluster < 0 || cluster >= 4096) {
			    pmsprintf(mess, sizeof(mess), "Illegal cluster field (%d) for pmid", cluster);
			    yyerror(mess);
			}
			if (item < 0 || item >= 1024) {
			    pmsprintf(mess, sizeof(mess), "Illegal item field (%d) for pmid", item);
			    yyerror(mess);
			}
			current_star_metric = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.pmid) = pmID_build(domain, cluster, item);
		    ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1583 "gram.y"
    {
			int	domain;
			int	cluster;
			int	sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.%d.", &domain, &cluster);
			if (domain < 1 || domain > DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Illegal domain field (%d) for pmid", domain);
			    yyerror(mess);
			}
			else if (domain == DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Dynamic metric domain field (%d) for pmid", domain);
			    yywarn(mess);
			}
			if (sts == 2) {
			    if (cluster >= 4096) {
				pmsprintf(mess, sizeof(mess), "Illegal cluster field (%d) for pmid", cluster);
				yyerror(mess);
			    }
			    current_star_metric = 1;
			}
			else {
			    cluster = 0;
			    current_star_metric = 2;
			}
			free((yyvsp[(1) - (1)].str));
			(yyval.pmid) = pmID_build(domain, cluster, 0);
		    ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1621 "gram.y"
    {
			metricspec_t	*mp;
			pmID		pmid;
			for (mp = walk_metric(W_START, METRIC_CHANGE_PMID, "pmid", 0); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_PMID, "pmid", 0)) {
			    if (current_star_metric == 1)
				pmid = pmID_build(pmID_domain((yyvsp[(3) - (3)].pmid)), pmID_cluster((yyvsp[(3) - (3)].pmid)), pmID_item(mp->old_desc.pmid));
			    else if (current_star_metric == 2)
				pmid = pmID_build(pmID_domain((yyvsp[(3) - (3)].pmid)), pmID_cluster(mp->old_desc.pmid), pmID_item(mp->old_desc.pmid));
			    else
				pmid = (yyvsp[(3) - (3)].pmid);
			    if (pmid == mp->old_desc.pmid) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): pmid: No change", mp->old_name, pmIDStr(mp->old_desc.pmid));
				    yywarn(mess);
				}
			    }
			    else {
				mp->new_desc.pmid = pmid;
				mp->flags |= METRIC_CHANGE_PMID;
			    }
			}
		    ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1645 "gram.y"
    {
			metricspec_t	*mp;
			int		picked = 0;
			for (mp = walk_metric(W_START, METRIC_CHANGE_NAME, "name", 0); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_NAME, "name", 0)) {
			    if (strcmp((yyvsp[(3) - (3)].str), mp->old_name) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): name: No change", mp->old_name, pmIDStr(mp->old_desc.pmid));
				    yywarn(mess);
				}
			    }
			    else {
				int	sts;
				pmID	pmid;
				sts = pmLookupName(1, (const char **)&(yyvsp[(3) - (3)].str), &pmid);
				if (sts >= 0) {
				    pmsprintf(mess, sizeof(mess), "Metric name %s already assigned for PMID %s", (yyvsp[(3) - (3)].str), pmIDStr(pmid));
				    yyerror(mess);
				}
				mp->new_name = (yyvsp[(3) - (3)].str);
				mp->flags |= METRIC_CHANGE_NAME;
				picked = 1;
			    }
			}
			if (!picked)
			    free((yyvsp[(3) - (3)].str));
		    ;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1673 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_TYPE, "type", 0); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_TYPE, "type", 0)) {
			    if ((yyvsp[(3) - (3)].ival) == mp->old_desc.type) {
				/* old == new, so no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): type: PM_TYPE_%s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), pmTypeStr(mp->old_desc.type));
				    yywarn(mess);
				}
			    }
			    else {
				if (mp->old_desc.type == PM_TYPE_32 ||
				    mp->old_desc.type == PM_TYPE_U32 ||
				    mp->old_desc.type == PM_TYPE_64 ||
				    mp->old_desc.type == PM_TYPE_U64 ||
				    mp->old_desc.type == PM_TYPE_FLOAT ||
				    mp->old_desc.type == PM_TYPE_DOUBLE) {
				    mp->new_desc.type = (yyvsp[(3) - (3)].ival);
				    mp->flags |= METRIC_CHANGE_TYPE;
				}
				else {
				    pmsprintf(mess, sizeof(mess), "Old type (PM_TYPE_%s) must be numeric", pmTypeStr(mp->old_desc.type));
				    yyerror(mess);
				}
			    }
			}
		    ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1701 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_TYPE, "type", 1); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_TYPE, "type", 1)) {
			    if (mp->old_desc.type != (yyvsp[(3) - (5)].ival)) {
				if (wflag) {
				    char	tbuf0[20];
				    char	tbuf1[20];
				    pmTypeStr_r(mp->old_desc.type, tbuf0, sizeof(tbuf0));
				    pmTypeStr_r((yyvsp[(5) - (5)].ival), tbuf1, sizeof(tbuf1));
				    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): type: PM_TYPE_%s: No conditional change to PM_TYPE_%s", mp->old_name, pmIDStr(mp->old_desc.pmid), tbuf0, tbuf1);
				    yywarn(mess);
				}
			    }
			    else {
				if (mp->old_desc.type == PM_TYPE_32 ||
				    mp->old_desc.type == PM_TYPE_U32 ||
				    mp->old_desc.type == PM_TYPE_64 ||
				    mp->old_desc.type == PM_TYPE_U64 ||
				    mp->old_desc.type == PM_TYPE_FLOAT ||
				    mp->old_desc.type == PM_TYPE_DOUBLE) {
				    mp->new_desc.type = (yyvsp[(5) - (5)].ival);
				    mp->flags |= METRIC_CHANGE_TYPE;
				}
				else {
				    pmsprintf(mess, sizeof(mess), "Old type (PM_TYPE_%s) must be numeric", pmTypeStr(mp->old_desc.type));
				    yyerror(mess);
				}
			    }
			}
		    ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1732 "gram.y"
    {
			metricspec_t	*mp;
			pmInDom		indom;
			for (mp = walk_metric(W_START, METRIC_CHANGE_INDOM, "indom", 0); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_INDOM, "indom", 0)) {
			    if (current_star_indom)
				indom = pmInDom_build(pmInDom_domain((yyvsp[(3) - (4)].indom)), pmInDom_serial(mp->old_desc.indom));
			    else
				indom = (yyvsp[(3) - (4)].indom);
			    if (indom == mp->old_desc.indom) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): indom: %s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), pmInDomStr(mp->old_desc.indom));
				    yywarn(mess);
				}
			    }
			    else {
				if ((output == OUTPUT_MIN ||
					  output == OUTPUT_MAX ||
					  output == OUTPUT_SUM ||
					  output == OUTPUT_AVG) &&
					 mp->old_desc.type != PM_TYPE_32 &&
					 mp->old_desc.type != PM_TYPE_U32 &&
					 mp->old_desc.type != PM_TYPE_64 &&
					 mp->old_desc.type != PM_TYPE_U64 &&
					 mp->old_desc.type != PM_TYPE_FLOAT &&
					 mp->old_desc.type != PM_TYPE_DOUBLE) {
				    pmsprintf(mess, sizeof(mess), "OUTPUT option MIN, MAX, AVG or SUM requires type to be numeric, not PM_TYPE_%s", pmTypeStr(mp->old_desc.type));
				    yyerror(mess);
				}
				mp->new_desc.indom = indom;
				mp->flags |= METRIC_CHANGE_INDOM;
				mp->output = output;
				if (output == OUTPUT_ONE) {
				    mp->one_name = one_name;
				    mp->one_inst = one_inst;
				    if (mp->old_desc.indom == PM_INDOM_NULL)
					/*
					 * singular input, pick first (only)
					 * value, not one_inst matching ...
					 * one_inst used for output instance
					 * id
					 */
					mp->output = OUTPUT_FIRST;
				}
				if (output == OUTPUT_ALL) {
				    /*
				     * No OUTPUT clause, set up the defaults
				     * based on indom types:
				     * non-NULL -> NULL
				     *		OUTPUT_FIRST, inst PM_IN_NULL
				     * NULL -> non-NULL
				     *		OUTPUT_FIRST, inst 0
				     * non-NULL -> non-NULL
				     * 		all instances selected
				     *		(nothing to do for defaults)
				     * NULL -> NULL
				     *		caught above in no change case
				     */
				    if (mp->old_desc.indom != PM_INDOM_NULL &&
				        mp->new_desc.indom == PM_INDOM_NULL) {
					mp->output = OUTPUT_FIRST;
					mp->one_inst = PM_IN_NULL;
				    }
				    else if (mp->old_desc.indom == PM_INDOM_NULL &&
				             mp->new_desc.indom != PM_INDOM_NULL) {
					mp->output = OUTPUT_FIRST;
					mp->one_inst = 0;
				    }
				}
			    }
			}
			output = OUTPUT_ALL;	/* for next time */
		    ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1806 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_SEM, "sem", 0); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_SEM, "sem", 0)) {
			    if ((yyvsp[(3) - (3)].ival) == mp->old_desc.sem) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): sem: %s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), SemStr(mp->old_desc.sem));
				    yywarn(mess);
				}
			    }
			    else {
				mp->new_desc.sem = (yyvsp[(3) - (3)].ival);
				mp->flags |= METRIC_CHANGE_SEM;
			    }
			}
		    ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1823 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_UNITS, "units", 0); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_UNITS, "units", 0)) {
			    if ((yyvsp[(3) - (14)].ival) == mp->old_desc.units.dimSpace &&
			        (yyvsp[(5) - (14)].ival) == mp->old_desc.units.dimTime &&
			        (yyvsp[(7) - (14)].ival) == mp->old_desc.units.dimCount &&
			        (yyvsp[(9) - (14)].ival) == mp->old_desc.units.scaleSpace &&
			        (yyvsp[(11) - (14)].ival) == mp->old_desc.units.scaleTime &&
			        (yyvsp[(13) - (14)].ival) == mp->old_desc.units.scaleCount) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): units: %s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), pmUnitsStr(&mp->old_desc.units));
				    yywarn(mess);
				}
			    }
			    else {
				mp->new_desc.units.dimSpace = (yyvsp[(3) - (14)].ival);
				mp->new_desc.units.dimTime = (yyvsp[(5) - (14)].ival);
				mp->new_desc.units.dimCount = (yyvsp[(7) - (14)].ival);
				mp->new_desc.units.scaleSpace = (yyvsp[(9) - (14)].ival);
				mp->new_desc.units.scaleTime = (yyvsp[(11) - (14)].ival);
				mp->new_desc.units.scaleCount = (yyvsp[(13) - (14)].ival);
				mp->flags |= METRIC_CHANGE_UNITS;
				if ((yyvsp[(14) - (14)].ival) == 1) {
				    if ((yyvsp[(3) - (14)].ival) == mp->old_desc.units.dimSpace &&
					(yyvsp[(5) - (14)].ival) == mp->old_desc.units.dimTime &&
					(yyvsp[(7) - (14)].ival) == mp->old_desc.units.dimCount)
					/* OK, no dim changes */
					mp->flags |= METRIC_RESCALE;
				    else {
					if (wflag) {
					    pmsprintf(mess, sizeof(mess), "Metric: %s (%s): Dimension changed, cannot rescale", mp->old_name, pmIDStr(mp->old_desc.pmid));
					    yywarn(mess);
					}
				    }
				}
				else if (sflag) {
				    if ((yyvsp[(3) - (14)].ival) == mp->old_desc.units.dimSpace &&
					(yyvsp[(5) - (14)].ival) == mp->old_desc.units.dimTime &&
					(yyvsp[(7) - (14)].ival) == mp->old_desc.units.dimCount)
					mp->flags |= METRIC_RESCALE;
				}
			    }
			}
		    ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1869 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_VALUE, "value", 1); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_VALUE, "value", 1)) {
			    value_change_t	*vc_tmp;
			    value_change_t	*vcp;
			    int			sts;

			    if (mp->old_desc.type != PM_TYPE_STRING) {
				pmsprintf(mess, sizeof(mess), "Metric: %s (%s): Type %s not STRING, cannot change value", mp->old_name, pmIDStr(mp->old_desc.pmid), pmTypeStr(mp->old_desc.type));
				free((yyvsp[(3) - (5)].str));
				free((yyvsp[(5) - (5)].str));
				yywarn(mess);
				continue;
			    }
			    mp->flags |= METRIC_CHANGE_VALUE;
			    mp->nvc++;
			    vc_tmp = (value_change_t *)realloc(mp->vc, mp->nvc * sizeof(value_change_t));
			    if (vc_tmp == NULL) {
				pmsprintf(mess, sizeof(mess), "value_change realloc(%d) failed: %s\n", (int)(mp->nvc * sizeof(value_change_t)), strerror(errno));
				yyerror(mess);
			    }
			    else
				mp->vc = vc_tmp;
			    vcp = &mp->vc[mp->nvc-1];
			    vcp->pat = (yyvsp[(3) - (5)].str);
			    vcp->replace = (yyvsp[(5) - (5)].str);
			    if (pmDebugOptions.appl5)
				fprintf(stderr, "compiling value regex /%s/\n", vcp->pat);
			    if ((sts = regcomp(&vcp->regex, vcp->pat, REG_EXTENDED)) != 0) {
				size_t	pfx;
				strncat(mess, "regcomp error: ", sizeof(mess)-1);
				pfx = strlen(mess);
				regerror(sts, &vcp->regex, &mess[pfx], sizeof(mess)-pfx-1);
				yyerror(mess);
			    }
			}
		    ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1907 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_DELETE, "delete", 1); mp != NULL; mp = walk_metric(W_NEXT, METRIC_DELETE, "delete", 0)) {
			    mp->flags |= METRIC_DELETE;
			}
		    ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1914 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <domain>.<cluster>.<item> or <domain>.<cluster>.* or <domain>.*.* in pmid clause");
			yyerror(mess);
		    ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1919 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <metric_name> in iname clause");
			yyerror(mess);
		    ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1924 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting XXX (from PM_TYPE_XXX) in type clause");
			yyerror(mess);
		    ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1929 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting XXX (from PM_TYPE_XXX) after if in type clause");
			yyerror(mess);
		    ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1934 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting XXX (from PM_TYPE_XXX) in type clause");
			yyerror(mess);
		    ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1939 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <domain>.<serial> or NULL in indom clause");
			yyerror(mess);
		    ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1944 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting XXX (from PM_SEM_XXX) in sem clause");
			yyerror(mess);
		    ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1949 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting 3 numeric values for dim* fields of units");
			yyerror(mess);
		    ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1954 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting 0 or XXX (from PM_SPACE_XXX) for scaleSpace field of units");
			yyerror(mess);
		    ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1959 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting 0 or XXX (from PM_TIME_XXX) for scaleTime field of units");
			yyerror(mess);
		    ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1964 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting 0 or ONE for scaleCount field of units");
			yyerror(mess);
		    ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1969 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <replacement> in metric value clause");
			yyerror(mess);
		    ;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1974 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting -> in metric value clause");
			yyerror(mess);
		    ;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1979 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting <regular expression> in metric value clause");
			yyerror(mess);
		    ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1991 "gram.y"
    {
			(yyval.indom) = PM_INDOM_NULL;
		    ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1997 "gram.y"
    {
			output = OUTPUT_ONE;
			one_inst = (yyvsp[(3) - (3)].ival);
			one_name = NULL;
		    ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 2003 "gram.y"
    {
			output = OUTPUT_ONE;
			one_inst = PM_IN_NULL;
			one_name = (yyvsp[(3) - (3)].str);
		    ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 2009 "gram.y"
    {
			output = (yyvsp[(2) - (2)].ival);
		    ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 2013 "gram.y"
    {
			pmsprintf(mess, sizeof(mess), "Expecting FIRST or LAST or INST or INAME or MIN or MAX or AVG for OUTPUT instance option");
			yyerror(mess);
		    ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 2020 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 2022 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 2033 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;
			int		target_types;
			int		this_type;
			int		type;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			current_textspec = NULL;
			if ((yyvsp[(2) - (4)].pmid) == PM_ID_NULL) {
			    /* Metric referenced by name is not in the archive */
			    do_walk_text = 0;
			}
			else {
			    int found = 0;
			    
			    if (current_star_metric) {
				/* Set up for metrics specified using globbing. */
				star_domain = pmID_domain((yyvsp[(2) - (4)].pmid));
				if (current_star_metric == 1)
				    star_cluster = pmID_cluster((yyvsp[(2) - (4)].pmid));
				else
				    star_cluster = PM_ID_NULL;
			    }

			    /* We're looking for text of the specified type(s) for metric(s). */
			    target_types = PM_TEXT_PMID | (yyvsp[(3) - (4)].ival);
			    hcp1 = &ctxp->c_archctl->ac_log->hashtext;
			    for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
				 node1 != NULL;
				 node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
				__pmHashCtl	*hcp2;
				__pmHashNode	*node2;

				/* Was this object type selected? */
				this_type = (int)(node1->key);
				if ((this_type & target_types) != this_type)
				    continue;

				/*
				 * Collect the text records associated with the specified
				 * metric(s).
				 */
				hcp2 = (__pmHashCtl *)(node1->data);
				for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				     node2 != NULL;
				     node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				    if (current_star_metric) {
					/* Match the globbed metric spec and keep looking. */
					if (pmID_domain((pmID)(node2->key)) == star_domain &&
					    (star_cluster == PM_ID_NULL ||
					     star_cluster == pmID_cluster((pmID)(node2->key)))) {
					    current_textspec = start_text(this_type, (pmID)(node2->key), (yyvsp[(4) - (4)].str));
					    if (current_textspec) {
						current_textspec->flags |= TEXT_ACTIVE;
						++found;
					    }

					}
				    }
				    else {
					/* Match the exact metric PMID. */
					if ((pmID)(node2->key) == (yyvsp[(2) - (4)].pmid)) {
					    current_textspec = start_text(this_type, (pmID)(node2->key), (yyvsp[(4) - (4)].str));
					    if (current_textspec) {
						current_textspec->flags |= TEXT_ACTIVE;
						++found;
					    }
					    /*
					     * Stop looking if we have found all of the specified
					     * types.
					     */
					    type = this_type & PM_TEXT_TYPE_MASK;
					    target_types ^= type;
					    if ((target_types & PM_TEXT_TYPE_MASK) == 0)
						break;
					}
				    }
				}
				if ((target_types & PM_TEXT_TYPE_MASK) == 0)
				    break;
			    }
			    do_walk_text = (found > 1);
			}
		    ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 2133 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 2135 "gram.y"
    { (yyval.ival) = PM_TEXT_ONELINE; ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 2139 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 2141 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival); ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 2145 "gram.y"
    { (yyval.ival) = PM_TEXT_ONELINE | PM_TEXT_HELP; ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 2147 "gram.y"
    { (yyval.ival) = PM_TEXT_HELP; ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 2149 "gram.y"
    { (yyval.ival) = PM_TEXT_ONELINE; ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 2153 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 2155 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 2160 "gram.y"
    {
			textspec_t	*tp;
			for (tp = walk_text(W_START, TEXT_ACTIVE, "active", 0); tp != NULL; tp = walk_text(W_NEXT, 0, "", 0)) {
			    tp->flags &= ~TEXT_ACTIVE;
			}
		    ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 2173 "gram.y"
    {
			textspec_t	*tp;
			for (tp = walk_text(W_START, TEXT_DELETE, "delete", 0); tp != NULL; tp = walk_text(W_NEXT, TEXT_DELETE, "delete", 0)) {
			    tp->flags |= TEXT_DELETE;
			}
		    ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 2180 "gram.y"
    {
			textspec_t	*tp;
			for (tp = walk_text(W_START, TEXT_CHANGE_TEXT, "text", 0); tp != NULL; tp = walk_text(W_NEXT, TEXT_CHANGE_TEXT, "text", 0)) {
			    if (tp->new_text) {
				if (strcmp(tp->new_text, (yyvsp[(3) - (3)].str)) == 0) {
				    pmsprintf(mess, sizeof(mess), "Duplicate text change clause");
				    yyerror(mess);
				}
				else {
				    pmsprintf(mess, sizeof(mess), "Conflicting text change clause");
				    yyerror(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else if (strcmp(tp->old_text, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Help text: No change");
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				tp->new_text = (yyvsp[(3) - (3)].str);
				tp->flags |= TEXT_CHANGE_TEXT;
			    }
			}
		    ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 2209 "gram.y"
    {
			textspec_t	*tp;
			pmID		pmid;
			for (tp = walk_text(W_START, TEXT_CHANGE_ID, "id", 0); tp != NULL; tp = walk_text(W_NEXT, TEXT_CHANGE_ID, "id", 0)) {
			    if (current_star_metric == 1)
				pmid = pmID_build(pmID_domain((yyvsp[(3) - (3)].pmid)), pmID_cluster((yyvsp[(3) - (3)].pmid)), pmID_item(tp->old_id));
			    else if (current_star_metric == 2)
				pmid = pmID_build(pmID_domain((yyvsp[(3) - (3)].pmid)), pmID_cluster(tp->old_id), pmID_item(tp->old_id));
			    else
				pmid = (yyvsp[(3) - (3)].pmid);
			    if (pmid == tp->old_id) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Text for metric: %s: metric: No change", pmIDStr(tp->old_id));
				    yywarn(mess);
				}
			    }
			    else {
				const textspec_t *tp1;
				/* Warn if the target metric already has text of this type. */
				/*
				 * Search all of the change specs for others targeting
				 * the same metric.
				 */
				for (tp1 = text_root; tp1 != NULL; tp1 = tp1->t_next) {
				    if (! (tp1->flags & TEXT_CHANGE_ID))
					continue; /* not an id change spec */
				    if (tp1->new_type != tp->new_type)
					continue; /* target is a different type */
				    if (tp1 == tp)
					continue; /* same spec */
				    if (tp1->new_id == pmid) {
					/* conflict with another change spec. */
					pmsprintf(mess, sizeof(mess), "Text for metric: %s: metric: Conflicting metric change", pmIDStr(tp->old_id));
					yyerror(mess);
					break;
				    }
				}
				if (tp1 == NULL) {
				    /* No conflict */
				    tp->new_id = pmid;
				    tp->flags |= TEXT_CHANGE_ID;
				}
			    }
			}
		    ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 2258 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 2260 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 2264 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 2266 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 2270 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 2272 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 2276 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;
			int		target_types;
			int		this_type;
			int		type;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			current_textspec = NULL;
			if ((yyvsp[(2) - (4)].indom) == PM_ID_NULL) {
			    /* Indom is not in the archive */
			    do_walk_text = 0;
			}
			else {
			    int found = 0;
			    
			    if (current_star_indom) {
				/* Set up for indoms specified using globbing. */
				star_domain = pmInDom_domain((yyvsp[(2) - (4)].indom));
			    }

			    /* We're looking for text of the specified type(s) for indom(s). */
			    target_types = PM_TEXT_INDOM | (yyvsp[(3) - (4)].ival);
			    hcp1 = &ctxp->c_archctl->ac_log->hashtext;
			    for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
				 node1 != NULL;
				 node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
				__pmHashCtl	*hcp2;
				__pmHashNode	*node2;

				/* Was this object type selected? */
				this_type = (int)(node1->key);
				if ((this_type & target_types) != this_type)
				    continue;

				/*
				 * Collect the text records associated with the specified
				 * metric(s).
				 */
				hcp2 = (__pmHashCtl *)(node1->data);
				for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				     node2 != NULL;
				     node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				    if (current_star_indom) {
					/* Match the globbed metric spec and keep looking. */
					if (pmInDom_domain((pmID)(node2->key)) == star_domain) {
					    current_textspec = start_text(this_type, (pmID)(node2->key), (yyvsp[(4) - (4)].str));
					    if (current_textspec) {
						current_textspec->flags |= TEXT_ACTIVE;
						++found;
					    }
					}
				    }
				    else {
					/* Match the exact indom id. */
					if ((pmID)(node2->key) == (yyvsp[(2) - (4)].indom)) {
					    current_textspec = start_text(this_type, (pmID)(node2->key), (yyvsp[(4) - (4)].str));
					    if (current_textspec) {
						current_textspec->flags |= TEXT_ACTIVE;
						++found;
					    }
					    /*
					     * Stop looking if we have found all of the specified
					     * types.
					     */
					    type = this_type & PM_TEXT_TYPE_MASK;
					    target_types ^= type;
					    if ((target_types & PM_TEXT_TYPE_MASK) == 0)
						break;
					}
				    }
				}
				if ((target_types & PM_TEXT_TYPE_MASK) == 0)
				    break;
			    }
			    do_walk_text = (found > 1);
			}
		    ;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 2370 "gram.y"
    {
			textspec_t	*tp;
			for (tp = walk_text(W_START, TEXT_ACTIVE, "active", 0); tp != NULL; tp = walk_text(W_NEXT, 0, "", 0)) {
			    tp->flags &= ~TEXT_ACTIVE;
			}
		    ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 2383 "gram.y"
    {
			textspec_t	*tp;
			for (tp = walk_text(W_START, TEXT_DELETE, "delete", 0); tp != NULL; tp = walk_text(W_NEXT, TEXT_DELETE, "delete", 0)) {
			    tp->flags |= TEXT_DELETE;
			}
		    ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 2390 "gram.y"
    {
			textspec_t	*tp;
			for (tp = walk_text(W_START, TEXT_CHANGE_TEXT, "text", 0); tp != NULL; tp = walk_text(W_NEXT, TEXT_CHANGE_TEXT, "text", 0)) {
			    if (tp->new_text) {
				if (strcmp(tp->new_text, (yyvsp[(3) - (3)].str)) == 0) {
				    pmsprintf(mess, sizeof(mess), "Duplicate text change clause");
				    yyerror(mess);
				}
				else {
				    pmsprintf(mess, sizeof(mess), "Conflicting text change clause");
				    yyerror(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else if (strcmp(tp->old_text, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Help text: No change");
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				tp->new_text = (yyvsp[(3) - (3)].str);
				tp->flags |= TEXT_CHANGE_TEXT;
			    }
			}
		    ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 2419 "gram.y"
    {
			textspec_t	*tp;
			for (tp = walk_text(W_START, TEXT_CHANGE_ID, "id", 0); tp != NULL; tp = walk_text(W_NEXT, TEXT_CHANGE_ID, "id", 0)) {
			    pmInDom	indom;
			    if (tp->new_id != tp->old_id) {
				pmsprintf(mess, sizeof(mess), "Duplicate text clause for indom %s", pmInDomStr(tp->old_id));
				yyerror(mess);
			    }
			    if (current_star_indom)
				indom = pmInDom_build(pmInDom_domain((yyvsp[(3) - (3)].indom)), pmInDom_serial(tp->old_id));
			    else
				indom = (yyvsp[(3) - (3)].indom);
			    if (indom != tp->old_id) {
				tp->new_id = indom;
				tp->flags |= TEXT_CHANGE_ID;
			    }
			    else {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Text for instance domain %s: indom: No change", pmInDomStr(tp->old_id));
				    yywarn(mess);
				}
			    }
			}
		    ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 2458 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;
			int		found = 0;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			/* We're looking for context labels. */
			current_labelspec = NULL;
			hcp1 = &ctxp->c_archctl->ac_log->hashlabels;
			for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
			     node1 != NULL;
			     node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
			    __pmHashCtl	*hcp2;
			    __pmHashNode	*node2;
			    int		this_type;

			    /* Was this object type selected? */
			    this_type = (int)(node1->key);
			    if (this_type != PM_LABEL_CONTEXT)
				continue;

			    /*
			     * Collect the label records associated with the specified
			     * metric(s).
			     */
			    hcp2 = (__pmHashCtl *)(node1->data);
			    for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				 node2 != NULL;
				 node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				/* We want all of the context labels. */
				current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
								current_label_name, current_label_value);
				if (current_labelspec) {
				    current_labelspec->flags |= LABEL_ACTIVE;
				    ++found;
				}
			    }
			}
			do_walk_label = found;
		    ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 2513 "gram.y"
    { current_label_name = (yyvsp[(1) - (2)].str); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 2515 "gram.y"
    { current_label_name = NULL; ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 2517 "gram.y"
    {
			current_label_name = NULL;
			current_label_value = NULL;
		    ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 2524 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 2526 "gram.y"
    {
			(yyval.str) = add_quotes((yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
		    ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 2533 "gram.y"
    { current_label_value = (yyvsp[(1) - (1)].str); ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 2535 "gram.y"
    { current_label_value = NULL; ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 2537 "gram.y"
    { current_label_value = NULL; ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 2541 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2543 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 2545 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 2547 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 2549 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 2553 "gram.y"
    {
			(yyval.str) = dupcat("-", (yyvsp[(2) - (2)].str));
			free((yyvsp[(2) - (2)].str));
		    ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 2558 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 2560 "gram.y"
    {
			(yyval.str) = dupcat("-", (yyvsp[(2) - (2)].str));
			free((yyvsp[(2) - (2)].str));
		    ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 2565 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 2570 "gram.y"
    {
			deactivate_labels();
		    ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 2580 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_DELETE, "delete", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_DELETE, "delete", 0)) {
			    lp->flags |= LABEL_DELETE;
			}
		    ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 2587 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_LABEL, "label", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_LABEL, "label", 0)) {
			    if (lp->new_label != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for context");
				yyerror(mess);
			    }
			    if (lp->old_label != NULL &&
				strcmp(lp->old_label, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for context: label: No change");
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_label = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_LABEL;
			    }
			}
		    ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 2611 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_VALUE, "value", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_VALUE, "value", 0)) {
			    if (lp->new_value != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label value clause for cluster %d.%d", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_value != NULL &&
				strcmp(lp->old_value, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for cluster %d.%d: value: No change", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_label = lp->old_label;
				lp->new_value = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_VALUE;
			    }
			}
		    ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 2636 "gram.y"
    {
			new_context_label();
		    ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 2641 "gram.y"
    {
			/* The current label name and value must both NOT be specified. */
			if (current_label_name || current_label_value) {
			    pmsprintf(mess, sizeof(mess), "The target label name and value must both not be specified for a NEW label and will be ignored");
			    yywarn(mess);
			    if (current_label_name)
				free(current_label_name);
			    if (current_label_value)
				free(current_label_value);
			}
			current_label_name = (yyvsp[(2) - (3)].str);
			current_label_value = (yyvsp[(3) - (3)].str);
		    ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 2656 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;
			int		 found = 0;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			current_labelspec = NULL;
			assert ((yyvsp[(2) - (3)].ival) != PM_ID_NULL);
			current_label_id = (yyvsp[(2) - (3)].ival);
			    
			/* We're looking for domain labels. */
			hcp1 = &ctxp->c_archctl->ac_log->hashlabels;
			for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
			     node1 != NULL;
			     node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
			    __pmHashCtl	*hcp2;
			    __pmHashNode	*node2;
			    int		this_type;

			    /* Was this object type selected? */
			    this_type = (int)(node1->key);
			    if (this_type != PM_LABEL_DOMAIN)
				continue;

			    /*
			     * Collect the label records associated with the specified
			     * metric domain.
			     */
			    hcp2 = (__pmHashCtl *)(node1->data);
			    for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				 node2 != NULL;
				 node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				/* Match the exact metric domain. */
				if ((pmID)(node2->key) == (yyvsp[(2) - (3)].ival)) {
				    current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
								    current_label_name, current_label_value);
				    if (current_labelspec) {
					current_labelspec->flags |= LABEL_ACTIVE;
					++found;
				    }
				}
			    }
			}
			do_walk_label = found;
		    ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 2716 "gram.y"
    {
			int	domain;
			int	sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d", &domain);
			assert(sts == 1);
			if (domain < 1 || domain > DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Illegal domain field (%d) for pmid", domain);
			    yyerror(mess);
			}
			else if (domain == DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Dynamic metric domain field (%d) for pmid", domain);
			    yywarn(mess);
			}
			current_star_metric = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.ival) = domain;
		    ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 2737 "gram.y"
    {
			deactivate_labels();
		    ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 2747 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_DELETE, "delete", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_DELETE, "delete", 0)) {
			    lp->flags |= LABEL_DELETE;
			}
		    ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 2754 "gram.y"
    {
			labelspec_t	*lp;
			int		domain;
			int		sts;
			sts = sscanf((yyvsp[(3) - (3)].str), "%d", &domain);
			assert(sts == 1);
			free((yyvsp[(3) - (3)].str));
			for (lp = walk_label(W_START, LABEL_CHANGE_ID, "id", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_ID, "id", 0)) {
			    if (domain == lp->old_id) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for metric domain: %d: No change", lp->old_id);
				    yywarn(mess);
				}
			    }
			    else {
				/*
				 * No need to check for conflicts. Multiple label set records for
				 * the same domain are ok.
				 */
				lp->new_id = domain;
				lp->flags |= LABEL_CHANGE_ID;
			    }
			}
		    ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 2780 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_LABEL, "label", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_LABEL, "label", 0)) {
			    if (lp->new_label != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for domain %d", lp->old_id);
				yyerror(mess);
			    }
			    if (lp->old_label != NULL &&
				strcmp(lp->old_label, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for domain %d: label: No change", lp->old_id);
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_label = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_LABEL;
			    }
			}
		    ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 2804 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_VALUE, "value", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_VALUE, "value", 0)) {
			    if (lp->new_value != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label value clause for cluster %d.%d", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_value != NULL &&
				strcmp(lp->old_value, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for cluster %d.%d: value: No change", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_value = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_VALUE;
			    }
			}
		    ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 2828 "gram.y"
    {
			new_domain_label(current_label_id);
		    ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 2834 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;
			int		found = 0;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			current_labelspec = NULL;
			assert ((yyvsp[(2) - (3)].ival) != PM_ID_NULL);
			current_label_id = (yyvsp[(2) - (3)].ival);
			    
			if (current_star_metric) {
			    /* Set up for metrics specified using globbing. */
			    star_domain = pmID_domain((yyvsp[(2) - (3)].ival));
			    star_cluster = PM_ID_NULL;
			}

			/* We're looking for cluster labels. */
			hcp1 = &ctxp->c_archctl->ac_log->hashlabels;
			for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
			     node1 != NULL;
			     node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
			    __pmHashCtl		*hcp2;
			    __pmHashNode	*node2;
			    int			this_type;

			    /* Was this object type selected? */
			    this_type = (int)(node1->key);
			    if (this_type != PM_LABEL_CLUSTER)
				continue;

			    /*
			     * Collect the label records associated with the specified
			     * metric(s).
			     */
			    hcp2 = (__pmHashCtl *)(node1->data);
			    for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				 node2 != NULL;
				 node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				if (current_star_metric) {
				    /* Match the globbed cluster spec and keep looking. */
				    if (pmID_domain((pmID)(node2->key)) == star_domain) {
					current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
									current_label_name, current_label_value);
					if (current_labelspec) {
					    current_labelspec->flags |= LABEL_ACTIVE;
					    ++found;
					}
				    }
				}
				else {
				    /* Match the exact cluster spec. */
				    if ((pmID)(node2->key) == (yyvsp[(2) - (3)].ival)) {
					current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
									current_label_name, current_label_value);
					if (current_labelspec) {
					    current_labelspec->flags |= LABEL_ACTIVE;
					    ++found;
					}
				    }
				}
			    }
			}
			do_walk_label = found;
		    ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 2913 "gram.y"
    {
			int	domain;
			int	cluster;
			int	sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.%d", &domain, &cluster);
			assert(sts == 2);
			if (domain < 1 || domain > DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Illegal domain field (%d) for pmid", domain);
			    yyerror(mess);
			}
			else if (domain == DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Dynamic metric domain field (%d) for pmid", domain);
			    yywarn(mess);
			}
			if (cluster < 0 || cluster >= 4096) {
			    pmsprintf(mess, sizeof(mess), "Illegal cluster field (%d) for pmid", cluster);
			    yyerror(mess);
			}
			current_star_metric = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.ival) = pmID_build(domain, cluster, 0);
		    ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 2936 "gram.y"
    {
			int	domain;
			int	sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.", &domain);
			assert (sts == 1);
			if (domain < 1 || domain > DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Illegal domain field (%d) for pmid", domain);
			    yyerror(mess);
			}
			else if (domain == DYNAMIC_PMID) {
			    pmsprintf(mess, sizeof(mess), "Dynamic metric domain field (%d) for pmid", domain);
			    yywarn(mess);
			}
			current_star_metric = 1;
			free((yyvsp[(1) - (1)].str));
			(yyval.ival) = pmID_build(domain, 0, 0);
		    ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 2957 "gram.y"
    {
			deactivate_labels();
		    ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 2967 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_DELETE, "delete", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_DELETE, "delete", 0)) {
			    lp->flags |= LABEL_DELETE;
			}
		    ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 2974 "gram.y"
    {
			labelspec_t	*lp;
			int		cluster;
			for (lp = walk_label(W_START, LABEL_CHANGE_ID, "id", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_ID, "id", 0)) {
			    if (current_star_metric)
				cluster = pmID_build(pmID_domain((yyvsp[(3) - (3)].ival)), pmID_cluster(lp->old_id), PM_ID_NULL);
			    else
				cluster = pmID_build(pmID_domain((yyvsp[(3) - (3)].ival)), pmID_cluster((yyvsp[(3) - (3)].ival)), PM_ID_NULL);
			    if (cluster == lp->old_id) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for cluster: %d.%d: No change", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				    yywarn(mess);
				}
			    }
			    else {
				/*
				 * No need to check for conflicts. Multiple label set records for
				 * the same cluster are ok.
				 */
				lp->new_id = cluster;
				lp->flags |= LABEL_CHANGE_ID;
			    }
			}
		    ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 3000 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_LABEL, "label", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_LABEL, "label", 0)) {
			    if (lp->new_label != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for cluster %d.%d", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_label != NULL &&
				strcmp(lp->old_label, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for cluster %d.%d: label: No change", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_label = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_LABEL;
			    }
			}
		    ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 3023 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_VALUE, "value", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_VALUE, "value", 0)) {
			    if (lp->new_value != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label value clause for cluster %d.%d", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_value != NULL &&
				strcmp(lp->old_value, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for cluster %d.%d: value: No change", pmID_domain(lp->old_id), pmID_cluster(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_value = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_VALUE;
			    }
			}
		    ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 3046 "gram.y"
    {
			new_cluster_label(current_label_id);
		    ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 3052 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			current_labelspec = NULL;
			current_label_id = (yyvsp[(2) - (3)].pmid);
			if ((yyvsp[(2) - (3)].pmid) == PM_ID_NULL) {
			    /* Metric referenced by name is not in the archive */
			    do_walk_label = 0;
			}
			else {
			    int found = 0;
			    
			    if (current_star_metric) {
				/* Set up for metrics specified using globbing. */
				star_domain = pmID_domain((yyvsp[(2) - (3)].pmid));
				if (current_star_metric == 1)
				    star_cluster = pmID_cluster((yyvsp[(2) - (3)].pmid));
				else
				    star_cluster = PM_ID_NULL;
			    }

			    /* We're looking for item labels. */
			    hcp1 = &ctxp->c_archctl->ac_log->hashlabels;
			    for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
				 node1 != NULL;
				 node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
				__pmHashCtl	*hcp2;
				__pmHashNode	*node2;
				int		this_type;

				/* Was this object type selected? */
				this_type = (int)(node1->key);
				if (this_type != PM_LABEL_ITEM)
				    continue;

				/*
				 * Collect the label records associated with the specified
				 * metric(s).
				 */
				hcp2 = (__pmHashCtl *)(node1->data);
				for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				     node2 != NULL;
				     node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				    if (current_star_metric) {
					/* Match the globbed metric spec and keep looking. */
					if (pmID_domain((pmID)(node2->key)) == star_domain &&
					    (star_cluster == PM_ID_NULL ||
					     star_cluster == pmID_cluster((pmID)(node2->key)))) {
					    current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
									    current_label_name, current_label_value);
					    if (current_labelspec) {
						current_labelspec->flags |= LABEL_ACTIVE;
						++found;
					    }

					}
				    }
				    else {
					/* Match the exact metric PMID. */
					if ((pmID)(node2->key) == (yyvsp[(2) - (3)].pmid)) {
					    current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
									    current_label_name, current_label_value);
					    if (current_labelspec) {
						current_labelspec->flags |= LABEL_ACTIVE;
						++found;
					    }
					}
				    }
				}
			    }
			    do_walk_label = found;
			}
		    ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 3143 "gram.y"
    {
			deactivate_labels();
		    ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 3153 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_DELETE, "delete", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_DELETE, "delete", 0)) {
			    lp->flags |= LABEL_DELETE;
			}
		    ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 3160 "gram.y"
    {
			labelspec_t	*lp;
			pmID		pmid;
			for (lp = walk_label(W_START, LABEL_CHANGE_ID, "id", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_ID, "id", 0)) {
			    if (current_star_metric == 1)
				pmid = pmID_build(pmID_domain((yyvsp[(3) - (3)].pmid)), pmID_cluster((yyvsp[(3) - (3)].pmid)), pmID_item(lp->old_id));
			    else if (current_star_metric == 2)
				pmid = pmID_build(pmID_domain((yyvsp[(3) - (3)].pmid)), pmID_cluster(lp->old_id), pmID_item(lp->old_id));
			    else
				pmid = (yyvsp[(3) - (3)].pmid);
			    if (pmid == lp->old_id) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for metric: %s: item: No change", pmIDStr(lp->old_id));
				    yywarn(mess);
				}
			    }
			    else {
				/*
				 * No need to check for conflicts. Multiple label set records for
				 * the same pmid are ok.
				 */
				lp->new_id = pmid;
				lp->flags |= LABEL_CHANGE_ID;
			    }
			}
		    ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 3188 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_LABEL, "label", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_LABEL, "label", 0)) {
			    if (lp->new_label != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for metric %s", pmIDStr(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_label != NULL &&
				strcmp(lp->old_label, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for metric %s: label: No change", pmIDStr(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_label = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_LABEL;
			    }
			}
		    ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 3211 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_VALUE, "value", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_VALUE, "value", 0)) {
			    if (lp->new_value != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label value clause for metric %s", pmIDStr(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_value != NULL &&
				strcmp(lp->old_value, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for metric %s: value: No change", pmIDStr(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_value = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_VALUE;
			    }
			}
		    ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 3234 "gram.y"
    {
			new_item_label(current_label_id);
		    ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 3240 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			current_labelspec = NULL;
			current_label_id = (yyvsp[(2) - (3)].indom);
			if ((yyvsp[(2) - (3)].indom) == PM_ID_NULL) {
			    /* Indom is not in the archive */
			    do_walk_label = 0;
			}
			else {
			    int found = 0;
			    
			    if (current_star_indom) {
				/* Set up for indoms specified using globbing. */
				star_domain = pmInDom_domain((yyvsp[(2) - (3)].indom));
			    }

			    /* We're looking for label sets for indom(s). */
			    hcp1 = &ctxp->c_archctl->ac_log->hashlabels;
			    for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
				 node1 != NULL;
				 node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
				__pmHashCtl	*hcp2;
				__pmHashNode	*node2;
				int		this_type;

				/* Was this object type selected? */
				this_type = (int)(node1->key);
				if (this_type != PM_LABEL_INDOM)
				    continue;

				/*
				 * Collect the label records associated with the specified
				 * imdom(s).
				 */
				hcp2 = (__pmHashCtl *)(node1->data);
				for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				     node2 != NULL;
				     node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				    if (current_star_indom) {
					/* Match the globbed indom spec and keep looking. */
					if (pmInDom_domain((pmID)(node2->key)) == star_domain) {
					    current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
									    current_label_name, current_label_value);
					    if (current_labelspec) {
						current_labelspec->flags |= LABEL_ACTIVE;
						++found;
					    }
					}
				    }
				    else {
					/* Match the exact indom id. */
					if ((pmID)(node2->key) == (yyvsp[(2) - (3)].indom)) {
					    current_labelspec = start_label(this_type, (pmID)(node2->key), 0, NULL,
									    current_label_name, current_label_value);
					    if (current_labelspec) {
						current_labelspec->flags |= LABEL_ACTIVE;
						++found;
					    }
					}
				    }
				}
			    }
			    do_walk_label = found;
			}
		    ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 3324 "gram.y"
    {
			deactivate_labels();
		    ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 3334 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_DELETE, "delete", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_DELETE, "delete", 0)) {
			    lp->flags |= LABEL_DELETE;
			}
		    ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 3341 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_ID, "id", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_ID, "id", 0)) {
			    pmInDom	indom;
			    if (lp->new_id != lp->old_id) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for indom %s", pmInDomStr(lp->old_id));
				yyerror(mess);
			    }
			    if (current_star_indom)
				indom = pmInDom_build(pmInDom_domain((yyvsp[(3) - (3)].indom)), pmInDom_serial(lp->old_id));
			    else
				indom = (yyvsp[(3) - (3)].indom);
			    if (indom != lp->old_id) {
				lp->new_id = indom;
				lp->flags |= LABEL_CHANGE_ID;
			    }
			    else {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for instance domain %s: indom: No change", pmInDomStr(lp->old_id));
				    yywarn(mess);
				}
			    }
			}
		    ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 3367 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_LABEL, "label", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_LABEL, "label", 0)) {
			    if (lp->new_label != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for indom %s", pmInDomStr(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_label != NULL &&
				strcmp(lp->old_label, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for instance domain %s: label: No change", pmInDomStr(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_label = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_LABEL;
			    }
			}
		    ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 3390 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_VALUE, "value", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_VALUE, "value", 0)) {
			    if (lp->new_value != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label value clause for indom %s", pmInDomStr(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_value != NULL &&
				strcmp(lp->old_value, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for instance domain %s: value: No change", pmInDomStr(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_value = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_VALUE;
			    }
			}
		    ;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 3413 "gram.y"
    {
			new_indom_label(current_label_id);
		    ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 3419 "gram.y"
    {
			__pmContext	*ctxp;
			__pmHashCtl	*hcp1;
			__pmHashNode	*node1;

			ctxp = __pmHandleToPtr(pmWhichContext());
			assert(ctxp != NULL);
    /*
     * Note: This application is single threaded, and once we have ctxp,
     *	     the associated __pmContext will not move and will only be
     *	     accessed or modified synchronously either here or in libpcp.
     *	     We unlock the context so that it can be locked as required
     *	     within libpcp.
     */
			PM_UNLOCK(ctxp->c_lock);
			
			current_labelspec = NULL;
			current_label_id = (yyvsp[(2) - (3)].indom);
			if ((yyvsp[(2) - (3)].indom) == PM_ID_NULL) {
			    /* Indom is not in the archive */
			    do_walk_label = 0;
			}
			else {
			    int found = 0;
			    
			    if (current_star_indom) {
				/* Set up for indoms specified using globbing. */
				star_domain = pmInDom_domain((yyvsp[(2) - (3)].indom));
			    }

			    /* We're looking for label sets for the instances of the indom(s). */
			    hcp1 = &ctxp->c_archctl->ac_log->hashlabels;
			    for (node1 = __pmHashWalk(hcp1, PM_HASH_WALK_START);
				 node1 != NULL;
				 node1 = __pmHashWalk(hcp1, PM_HASH_WALK_NEXT)) {
				__pmHashCtl	*hcp2;
				__pmHashNode	*node2;
				int		this_type;

				/* Was this object type selected? */
				this_type = (int)(node1->key);
				if (this_type != PM_LABEL_INSTANCES)
				    continue;

				/*
				 * Collect the label records associated with the specified
				 * indom instance(s).
				 */
				hcp2 = (__pmHashCtl *)(node1->data);
				for (node2 = __pmHashWalk(hcp2, PM_HASH_WALK_START);
				     node2 != NULL;
				     node2 = __pmHashWalk(hcp2, PM_HASH_WALK_NEXT)) {
				    if (current_star_indom) {
					/* Match the globbed indom spec and keep looking. */
					if (pmInDom_domain((pmID)(node2->key)) == star_domain) {
					    current_labelspec = start_label(this_type, (pmID)(node2->key),
									    current_label_instance, current_label_instance_name,
									    current_label_name, current_label_value);
					    if (current_labelspec) {
						current_labelspec->flags |= LABEL_ACTIVE;
						++found;
					    }
					}
				    }
				    else {
					/* Match the exact indom id. */
					if ((pmID)(node2->key) == (yyvsp[(2) - (3)].indom)) {
					    current_labelspec = start_label(this_type, (pmID)(node2->key),
									    current_label_instance, current_label_instance_name,
									    current_label_name, current_label_value);
					    if (current_labelspec) {
						current_labelspec->flags |= LABEL_ACTIVE;
						++found;
					    }
					}
				    }
				}
			    }
			    do_walk_label = found;
			}
		    ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 3504 "gram.y"
    {
			current_label_instance = -1;
			current_label_instance_name = (yyvsp[(1) - (2)].str);
		    ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 3509 "gram.y"
    {
			current_label_instance = atoi((yyvsp[(1) - (2)].str));
			free((yyvsp[(1) - (2)].str));
			current_label_instance_name = NULL;
		    ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 3515 "gram.y"
    {
			current_label_instance = -1;
			current_label_instance_name = NULL;
		    ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 3520 "gram.y"
    {
			current_label_instance = -1;
			current_label_instance_name = NULL;
			current_label_name = NULL;
			current_label_value = NULL;
		    ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 3530 "gram.y"
    {
			deactivate_labels();
		    ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 3540 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_DELETE, "delete", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_DELETE, "delete", 0)) {
			    lp->flags |= LABEL_DELETE;
			}
		    ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 3547 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_ID, "id", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_ID, "id", 0)) {
			    pmInDom	indom;
			    if (lp->new_id != lp->old_id) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for instances of indom %s", pmInDomStr(lp->old_id));
				yyerror(mess);
			    }
			    if (current_star_indom)
				indom = pmInDom_build(pmInDom_domain((yyvsp[(3) - (3)].indom)), pmInDom_serial(lp->old_id));
			    else
				indom = (yyvsp[(3) - (3)].indom);
			    if (indom != lp->old_id) {
				lp->new_id = indom;
				lp->flags |= LABEL_CHANGE_ID;
			    }
			    else {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for instance domain %s: indom: No change", pmInDomStr(lp->old_id));
				    yywarn(mess);
				}
			    }
			}
		    ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 3573 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_ID, "id", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_ID, "id", 0)) {
			    int	instance;
			    if (lp->new_instance != lp->old_instance) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for instances of indom %s", pmInDomStr(lp->old_id));
				yyerror(mess);
			    }
			    instance = atoi((yyvsp[(3) - (3)].str));
			    free((yyvsp[(3) - (3)].str));
			    if (instance != lp->old_instance) {
				lp->new_instance = instance;
				lp->flags |= LABEL_CHANGE_INSTANCE;
			    }
			    else {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for instance domain %s instance %d: instance: No change", pmInDomStr(lp->old_id), lp->old_instance);
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			}
		    ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 3598 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_LABEL, "label", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_LABEL, "label", 0)) {
			    if (lp->new_label != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label clause for instances of indom %s", pmInDomStr(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_label != NULL &&
				strcmp(lp->old_label, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for instances of instance domain %s: label: No change", pmInDomStr(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_label = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_LABEL;
			    }
			}
		    ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 3621 "gram.y"
    {
			labelspec_t	*lp;
			for (lp = walk_label(W_START, LABEL_CHANGE_VALUE, "value", 0); lp != NULL; lp = walk_label(W_NEXT, LABEL_CHANGE_VALUE, "value", 0)) {
			    if (lp->new_value != NULL) {
				pmsprintf(mess, sizeof(mess), "Duplicate label value clause for instances of indom %s", pmInDomStr(lp->old_id));
				yyerror(mess);
			    }
			    if (lp->old_value != NULL &&
				strcmp(lp->old_value, (yyvsp[(3) - (3)].str)) == 0) {
				/* no change ... */
				if (wflag) {
				    pmsprintf(mess, sizeof(mess), "Label for instances of instance domain %s: value: No change", pmInDomStr(lp->old_id));
				    yywarn(mess);
				}
				free((yyvsp[(3) - (3)].str));
			    }
			    else {
				lp->new_value = (yyvsp[(3) - (3)].str);
				lp->flags |= LABEL_CHANGE_VALUE;
			    }
			}
		    ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 3644 "gram.y"
    {
			new_indom_instance_label(current_label_id);
		    ;}
    break;



/* Line 1455 of yacc.c  */
#line 6047 "gram.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 3649 "gram.y"


